/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 1

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         OCTAVE_STYPE
/* Substitute the variable and function names.  */
#define yyparse         octave_parse
#define yypush_parse    octave_push_parse
#define yypull_parse    octave_pull_parse
#define yypstate_new    octave_pstate_new
#define yypstate_clear  octave_pstate_clear
#define yypstate_delete octave_pstate_delete
#define yypstate        octave_pstate
#define yylex           octave_lex
#define yyerror         octave_error
#define yydebug         octave_debug
#define yynerrs         octave_nerrs

/* First part of user prologue.  */
#line 30 "../libinterp/parse-tree/oct-parse.yy"


#define YYDEBUG 1

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif

#include <cassert>
#include <cstdio>
#include <cstdlib>

#include <iostream>
#include <map>
#include <sstream>

#include "Matrix.h"
#include "cmd-edit.h"
#include "cmd-hist.h"
#include "file-ops.h"
#include "file-stat.h"
#include "oct-env.h"
#include "oct-time.h"
#include "quit.h"

#include "Cell.h"
#include "anon-fcn-validator.h"
#include "builtin-defun-decls.h"
#include "defun.h"
#include "dynamic-ld.h"
#include "error.h"
#include "input.h"
#include "interpreter-private.h"
#include "interpreter.h"
#include "lex.h"
#include "load-path.h"
#include "lo-sysdep.h"
#include "oct-hist.h"
#include "oct-map.h"
#include "ov-classdef.h"
#include "ov-fcn-handle.h"
#include "ov-usr-fcn.h"
#include "ov-null-mat.h"
#include "pager.h"
#include "parse.h"
#include "pt-all.h"
#include "pt-eval.h"
#include "symtab.h"
#include "token.h"
#include "unwind-prot.h"
#include "utils.h"
#include "variables.h"

// oct-parse.h must be included after pt-all.h
#include "oct-parse.h"

extern int octave_lex (YYSTYPE *, void *);

// Forward declarations for some functions defined at the bottom of
// the file.

static void yyerror (octave::base_parser& parser, const char *s);

#define lexer (parser.get_lexer ())
#define scanner lexer.m_scanner

// Previous versions of Octave used Bison's YYUSE macro to avoid
// warnings about unused values in rules.  But that Bison macro was
// apparently never intended to be public.  So define our own.  All we
// need to do is mention the symantic value somewhere in the rule.  It
// doesn't actually need to be used to avoid the Bison warning, so just
// define this macro to discard its parameter.
#define OCTAVE_YYUSE(X)

#if defined (HAVE_PRAGMA_GCC_DIAGNOSTIC)
   // Disable this warning for code that is generated by Bison,
   // including grammar rules.  Push the current state so we can
   // restore the warning state prior to functions we define at
   // the bottom of the file.
#  pragma GCC diagnostic push
#  pragma GCC diagnostic ignored "-Wold-style-cast"
#endif


#line 168 "libinterp/parse-tree/oct-parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED
# define YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED
/* Debug traces.  */
#ifndef OCTAVE_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define OCTAVE_DEBUG 1
#  else
#   define OCTAVE_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define OCTAVE_DEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined OCTAVE_DEBUG */
#if OCTAVE_DEBUG
extern int octave_debug;
#endif

/* Token kinds.  */
#ifndef OCTAVE_TOKENTYPE
# define OCTAVE_TOKENTYPE
  enum octave_tokentype
  {
    OCTAVE_EMPTY = -2,
    OCTAVE_EOF = 0,                /* "end of file"  */
    OCTAVE_error = 256,            /* error  */
    OCTAVE_UNDEF = 257,            /* "invalid token"  */
    ADD_EQ = 258,                  /* ADD_EQ  */
    SUB_EQ = 259,                  /* SUB_EQ  */
    MUL_EQ = 260,                  /* MUL_EQ  */
    DIV_EQ = 261,                  /* DIV_EQ  */
    LEFTDIV_EQ = 262,              /* LEFTDIV_EQ  */
    POW_EQ = 263,                  /* POW_EQ  */
    EMUL_EQ = 264,                 /* EMUL_EQ  */
    EDIV_EQ = 265,                 /* EDIV_EQ  */
    ELEFTDIV_EQ = 266,             /* ELEFTDIV_EQ  */
    EPOW_EQ = 267,                 /* EPOW_EQ  */
    AND_EQ = 268,                  /* AND_EQ  */
    OR_EQ = 269,                   /* OR_EQ  */
    EXPR_AND_AND = 270,            /* EXPR_AND_AND  */
    EXPR_OR_OR = 271,              /* EXPR_OR_OR  */
    EXPR_AND = 272,                /* EXPR_AND  */
    EXPR_OR = 273,                 /* EXPR_OR  */
    EXPR_NOT = 274,                /* EXPR_NOT  */
    EXPR_LT = 275,                 /* EXPR_LT  */
    EXPR_LE = 276,                 /* EXPR_LE  */
    EXPR_EQ = 277,                 /* EXPR_EQ  */
    EXPR_NE = 278,                 /* EXPR_NE  */
    EXPR_GE = 279,                 /* EXPR_GE  */
    EXPR_GT = 280,                 /* EXPR_GT  */
    LEFTDIV = 281,                 /* LEFTDIV  */
    EMUL = 282,                    /* EMUL  */
    EDIV = 283,                    /* EDIV  */
    ELEFTDIV = 284,                /* ELEFTDIV  */
    EPLUS = 285,                   /* EPLUS  */
    EMINUS = 286,                  /* EMINUS  */
    HERMITIAN = 287,               /* HERMITIAN  */
    TRANSPOSE = 288,               /* TRANSPOSE  */
    PLUS_PLUS = 289,               /* PLUS_PLUS  */
    MINUS_MINUS = 290,             /* MINUS_MINUS  */
    POW = 291,                     /* POW  */
    EPOW = 292,                    /* EPOW  */
    NUM = 293,                     /* NUM  */
    IMAG_NUM = 294,                /* IMAG_NUM  */
    STRUCT_ELT = 295,              /* STRUCT_ELT  */
    NAME = 296,                    /* NAME  */
    END = 297,                     /* END  */
    DQ_STRING = 298,               /* DQ_STRING  */
    SQ_STRING = 299,               /* SQ_STRING  */
    FOR = 300,                     /* FOR  */
    PARFOR = 301,                  /* PARFOR  */
    WHILE = 302,                   /* WHILE  */
    DO = 303,                      /* DO  */
    UNTIL = 304,                   /* UNTIL  */
    IF = 305,                      /* IF  */
    ELSEIF = 306,                  /* ELSEIF  */
    ELSE = 307,                    /* ELSE  */
    SWITCH = 308,                  /* SWITCH  */
    CASE = 309,                    /* CASE  */
    OTHERWISE = 310,               /* OTHERWISE  */
    BREAK = 311,                   /* BREAK  */
    CONTINUE = 312,                /* CONTINUE  */
    FUNC_RET = 313,                /* FUNC_RET  */
    UNWIND = 314,                  /* UNWIND  */
    CLEANUP = 315,                 /* CLEANUP  */
    TRY = 316,                     /* TRY  */
    CATCH = 317,                   /* CATCH  */
    GLOBAL = 318,                  /* GLOBAL  */
    PERSISTENT = 319,              /* PERSISTENT  */
    FCN_HANDLE = 320,              /* FCN_HANDLE  */
    CLASSDEF = 321,                /* CLASSDEF  */
    PROPERTIES = 322,              /* PROPERTIES  */
    METHODS = 323,                 /* METHODS  */
    EVENTS = 324,                  /* EVENTS  */
    ENUMERATION = 325,             /* ENUMERATION  */
    METAQUERY = 326,               /* METAQUERY  */
    SUPERCLASSREF = 327,           /* SUPERCLASSREF  */
    FQ_IDENT = 328,                /* FQ_IDENT  */
    GET = 329,                     /* GET  */
    SET = 330,                     /* SET  */
    FCN = 331,                     /* FCN  */
    LEXICAL_ERROR = 332,           /* LEXICAL_ERROR  */
    END_OF_INPUT = 333,            /* END_OF_INPUT  */
    INPUT_FILE = 334,              /* INPUT_FILE  */
    UNARY = 335                    /* UNARY  */
  };
  typedef enum octave_tokentype octave_token_kind_t;
#endif
/* Token kinds.  */
#define OCTAVE_EMPTY -2
#define OCTAVE_EOF 0
#define OCTAVE_error 256
#define OCTAVE_UNDEF 257
#define ADD_EQ 258
#define SUB_EQ 259
#define MUL_EQ 260
#define DIV_EQ 261
#define LEFTDIV_EQ 262
#define POW_EQ 263
#define EMUL_EQ 264
#define EDIV_EQ 265
#define ELEFTDIV_EQ 266
#define EPOW_EQ 267
#define AND_EQ 268
#define OR_EQ 269
#define EXPR_AND_AND 270
#define EXPR_OR_OR 271
#define EXPR_AND 272
#define EXPR_OR 273
#define EXPR_NOT 274
#define EXPR_LT 275
#define EXPR_LE 276
#define EXPR_EQ 277
#define EXPR_NE 278
#define EXPR_GE 279
#define EXPR_GT 280
#define LEFTDIV 281
#define EMUL 282
#define EDIV 283
#define ELEFTDIV 284
#define EPLUS 285
#define EMINUS 286
#define HERMITIAN 287
#define TRANSPOSE 288
#define PLUS_PLUS 289
#define MINUS_MINUS 290
#define POW 291
#define EPOW 292
#define NUM 293
#define IMAG_NUM 294
#define STRUCT_ELT 295
#define NAME 296
#define END 297
#define DQ_STRING 298
#define SQ_STRING 299
#define FOR 300
#define PARFOR 301
#define WHILE 302
#define DO 303
#define UNTIL 304
#define IF 305
#define ELSEIF 306
#define ELSE 307
#define SWITCH 308
#define CASE 309
#define OTHERWISE 310
#define BREAK 311
#define CONTINUE 312
#define FUNC_RET 313
#define UNWIND 314
#define CLEANUP 315
#define TRY 316
#define CATCH 317
#define GLOBAL 318
#define PERSISTENT 319
#define FCN_HANDLE 320
#define CLASSDEF 321
#define PROPERTIES 322
#define METHODS 323
#define EVENTS 324
#define ENUMERATION 325
#define METAQUERY 326
#define SUPERCLASSREF 327
#define FQ_IDENT 328
#define GET 329
#define SET 330
#define FCN 331
#define LEXICAL_ERROR 332
#define END_OF_INPUT 333
#define INPUT_FILE 334
#define UNARY 335

/* Value type.  */
#if ! defined OCTAVE_STYPE && ! defined OCTAVE_STYPE_IS_DECLARED
union OCTAVE_STYPE
{
#line 139 "../libinterp/parse-tree/oct-parse.yy"

  int dummy_type;

  // The type of the basic tokens returned by the lexer.
  octave::token *tok_val;

  // Comment strings that we need to deal with mid-rule.
  octave::comment_list *comment_type;

  // Types for the nonterminals we generate.
  char punct_type;
  octave::tree *tree_type;
  octave::tree_matrix *tree_matrix_type;
  octave::tree_cell *tree_cell_type;
  octave::tree_expression *tree_expression_type;
  octave::tree_constant *tree_constant_type;
  octave::tree_fcn_handle *tree_fcn_handle_type;
  octave::tree_superclass_ref *tree_superclass_ref_type;
  octave::tree_metaclass_query *tree_metaclass_query_type;
  octave::tree_function_def *tree_function_def_type;
  octave::tree_anon_fcn_handle *tree_anon_fcn_handle_type;
  octave::tree_identifier *tree_identifier_type;
  octave::tree_index_expression *tree_index_expression_type;
  octave::tree_colon_expression *tree_colon_expression_type;
  octave::tree_argument_list *tree_argument_list_type;
  octave::tree_parameter_list *tree_parameter_list_type;
  octave::tree_command *tree_command_type;
  octave::tree_if_command *tree_if_command_type;
  octave::tree_if_clause *tree_if_clause_type;
  octave::tree_if_command_list *tree_if_command_list_type;
  octave::tree_switch_command *tree_switch_command_type;
  octave::tree_switch_case *tree_switch_case_type;
  octave::tree_switch_case_list *tree_switch_case_list_type;
  octave::tree_decl_elt *tree_decl_elt_type;
  octave::tree_decl_init_list *tree_decl_init_list_type;
  octave::tree_decl_command *tree_decl_command_type;
  octave::tree_statement *tree_statement_type;
  octave::tree_statement_list *tree_statement_list_type;
  octave_user_function *octave_user_function_type;

  octave::tree_classdef *tree_classdef_type;
  octave::tree_classdef_attribute* tree_classdef_attribute_type;
  octave::tree_classdef_attribute_list* tree_classdef_attribute_list_type;
  octave::tree_classdef_superclass* tree_classdef_superclass_type;
  octave::tree_classdef_superclass_list* tree_classdef_superclass_list_type;
  octave::tree_classdef_body* tree_classdef_body_type;
  octave::tree_classdef_property* tree_classdef_property_type;
  octave::tree_classdef_property_list* tree_classdef_property_list_type;
  octave::tree_classdef_properties_block* tree_classdef_properties_block_type;
  octave::tree_classdef_methods_list* tree_classdef_methods_list_type;
  octave::tree_classdef_methods_block* tree_classdef_methods_block_type;
  octave::tree_classdef_event* tree_classdef_event_type;
  octave::tree_classdef_events_list* tree_classdef_events_list_type;
  octave::tree_classdef_events_block* tree_classdef_events_block_type;
  octave::tree_classdef_enum* tree_classdef_enum_type;
  octave::tree_classdef_enum_list* tree_classdef_enum_list_type;
  octave::tree_classdef_enum_block* tree_classdef_enum_block_type;

#line 448 "libinterp/parse-tree/oct-parse.cc"

};
typedef union OCTAVE_STYPE OCTAVE_STYPE;
# define OCTAVE_STYPE_IS_TRIVIAL 1
# define OCTAVE_STYPE_IS_DECLARED 1
#endif



#ifndef YYPUSH_MORE_DEFINED
# define YYPUSH_MORE_DEFINED
enum { YYPUSH_MORE = 4 };
#endif

typedef struct octave_pstate octave_pstate;


int octave_parse (octave::base_parser& parser);
int octave_push_parse (octave_pstate *ps,
                  int pushed_char, OCTAVE_STYPE const *pushed_val, octave::base_parser& parser);
int octave_pull_parse (octave_pstate *ps, octave::base_parser& parser);
octave_pstate *octave_pstate_new (void);
void octave_pstate_delete (octave_pstate *ps);


#endif /* !YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_3_ = 3,                         /* '='  */
  YYSYMBOL_4_ = 4,                         /* ':'  */
  YYSYMBOL_5_ = 5,                         /* '-'  */
  YYSYMBOL_6_ = 6,                         /* '+'  */
  YYSYMBOL_7_ = 7,                         /* '*'  */
  YYSYMBOL_8_ = 8,                         /* '/'  */
  YYSYMBOL_9_ = 9,                         /* '('  */
  YYSYMBOL_10_ = 10,                       /* ')'  */
  YYSYMBOL_11_ = 11,                       /* '['  */
  YYSYMBOL_12_ = 12,                       /* ']'  */
  YYSYMBOL_13_ = 13,                       /* '{'  */
  YYSYMBOL_14_ = 14,                       /* '}'  */
  YYSYMBOL_15_ = 15,                       /* '.'  */
  YYSYMBOL_16_ = 16,                       /* '@'  */
  YYSYMBOL_17_ = 17,                       /* ','  */
  YYSYMBOL_18_ = 18,                       /* ';'  */
  YYSYMBOL_19_n_ = 19,                     /* '\n'  */
  YYSYMBOL_ADD_EQ = 20,                    /* ADD_EQ  */
  YYSYMBOL_SUB_EQ = 21,                    /* SUB_EQ  */
  YYSYMBOL_MUL_EQ = 22,                    /* MUL_EQ  */
  YYSYMBOL_DIV_EQ = 23,                    /* DIV_EQ  */
  YYSYMBOL_LEFTDIV_EQ = 24,                /* LEFTDIV_EQ  */
  YYSYMBOL_POW_EQ = 25,                    /* POW_EQ  */
  YYSYMBOL_EMUL_EQ = 26,                   /* EMUL_EQ  */
  YYSYMBOL_EDIV_EQ = 27,                   /* EDIV_EQ  */
  YYSYMBOL_ELEFTDIV_EQ = 28,               /* ELEFTDIV_EQ  */
  YYSYMBOL_EPOW_EQ = 29,                   /* EPOW_EQ  */
  YYSYMBOL_AND_EQ = 30,                    /* AND_EQ  */
  YYSYMBOL_OR_EQ = 31,                     /* OR_EQ  */
  YYSYMBOL_EXPR_AND_AND = 32,              /* EXPR_AND_AND  */
  YYSYMBOL_EXPR_OR_OR = 33,                /* EXPR_OR_OR  */
  YYSYMBOL_EXPR_AND = 34,                  /* EXPR_AND  */
  YYSYMBOL_EXPR_OR = 35,                   /* EXPR_OR  */
  YYSYMBOL_EXPR_NOT = 36,                  /* EXPR_NOT  */
  YYSYMBOL_EXPR_LT = 37,                   /* EXPR_LT  */
  YYSYMBOL_EXPR_LE = 38,                   /* EXPR_LE  */
  YYSYMBOL_EXPR_EQ = 39,                   /* EXPR_EQ  */
  YYSYMBOL_EXPR_NE = 40,                   /* EXPR_NE  */
  YYSYMBOL_EXPR_GE = 41,                   /* EXPR_GE  */
  YYSYMBOL_EXPR_GT = 42,                   /* EXPR_GT  */
  YYSYMBOL_LEFTDIV = 43,                   /* LEFTDIV  */
  YYSYMBOL_EMUL = 44,                      /* EMUL  */
  YYSYMBOL_EDIV = 45,                      /* EDIV  */
  YYSYMBOL_ELEFTDIV = 46,                  /* ELEFTDIV  */
  YYSYMBOL_EPLUS = 47,                     /* EPLUS  */
  YYSYMBOL_EMINUS = 48,                    /* EMINUS  */
  YYSYMBOL_HERMITIAN = 49,                 /* HERMITIAN  */
  YYSYMBOL_TRANSPOSE = 50,                 /* TRANSPOSE  */
  YYSYMBOL_PLUS_PLUS = 51,                 /* PLUS_PLUS  */
  YYSYMBOL_MINUS_MINUS = 52,               /* MINUS_MINUS  */
  YYSYMBOL_POW = 53,                       /* POW  */
  YYSYMBOL_EPOW = 54,                      /* EPOW  */
  YYSYMBOL_NUM = 55,                       /* NUM  */
  YYSYMBOL_IMAG_NUM = 56,                  /* IMAG_NUM  */
  YYSYMBOL_STRUCT_ELT = 57,                /* STRUCT_ELT  */
  YYSYMBOL_NAME = 58,                      /* NAME  */
  YYSYMBOL_END = 59,                       /* END  */
  YYSYMBOL_DQ_STRING = 60,                 /* DQ_STRING  */
  YYSYMBOL_SQ_STRING = 61,                 /* SQ_STRING  */
  YYSYMBOL_FOR = 62,                       /* FOR  */
  YYSYMBOL_PARFOR = 63,                    /* PARFOR  */
  YYSYMBOL_WHILE = 64,                     /* WHILE  */
  YYSYMBOL_DO = 65,                        /* DO  */
  YYSYMBOL_UNTIL = 66,                     /* UNTIL  */
  YYSYMBOL_IF = 67,                        /* IF  */
  YYSYMBOL_ELSEIF = 68,                    /* ELSEIF  */
  YYSYMBOL_ELSE = 69,                      /* ELSE  */
  YYSYMBOL_SWITCH = 70,                    /* SWITCH  */
  YYSYMBOL_CASE = 71,                      /* CASE  */
  YYSYMBOL_OTHERWISE = 72,                 /* OTHERWISE  */
  YYSYMBOL_BREAK = 73,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 74,                  /* CONTINUE  */
  YYSYMBOL_FUNC_RET = 75,                  /* FUNC_RET  */
  YYSYMBOL_UNWIND = 76,                    /* UNWIND  */
  YYSYMBOL_CLEANUP = 77,                   /* CLEANUP  */
  YYSYMBOL_TRY = 78,                       /* TRY  */
  YYSYMBOL_CATCH = 79,                     /* CATCH  */
  YYSYMBOL_GLOBAL = 80,                    /* GLOBAL  */
  YYSYMBOL_PERSISTENT = 81,                /* PERSISTENT  */
  YYSYMBOL_FCN_HANDLE = 82,                /* FCN_HANDLE  */
  YYSYMBOL_CLASSDEF = 83,                  /* CLASSDEF  */
  YYSYMBOL_PROPERTIES = 84,                /* PROPERTIES  */
  YYSYMBOL_METHODS = 85,                   /* METHODS  */
  YYSYMBOL_EVENTS = 86,                    /* EVENTS  */
  YYSYMBOL_ENUMERATION = 87,               /* ENUMERATION  */
  YYSYMBOL_METAQUERY = 88,                 /* METAQUERY  */
  YYSYMBOL_SUPERCLASSREF = 89,             /* SUPERCLASSREF  */
  YYSYMBOL_FQ_IDENT = 90,                  /* FQ_IDENT  */
  YYSYMBOL_GET = 91,                       /* GET  */
  YYSYMBOL_SET = 92,                       /* SET  */
  YYSYMBOL_FCN = 93,                       /* FCN  */
  YYSYMBOL_LEXICAL_ERROR = 94,             /* LEXICAL_ERROR  */
  YYSYMBOL_END_OF_INPUT = 95,              /* END_OF_INPUT  */
  YYSYMBOL_INPUT_FILE = 96,                /* INPUT_FILE  */
  YYSYMBOL_UNARY = 97,                     /* UNARY  */
  YYSYMBOL_YYACCEPT = 98,                  /* $accept  */
  YYSYMBOL_input = 99,                     /* input  */
  YYSYMBOL_simple_list = 100,              /* simple_list  */
  YYSYMBOL_simple_list1 = 101,             /* simple_list1  */
  YYSYMBOL_opt_list = 102,                 /* opt_list  */
  YYSYMBOL_list = 103,                     /* list  */
  YYSYMBOL_list1 = 104,                    /* list1  */
  YYSYMBOL_opt_fcn_list = 105,             /* opt_fcn_list  */
  YYSYMBOL_fcn_list = 106,                 /* fcn_list  */
  YYSYMBOL_fcn_list1 = 107,                /* fcn_list1  */
  YYSYMBOL_statement = 108,                /* statement  */
  YYSYMBOL_word_list_cmd = 109,            /* word_list_cmd  */
  YYSYMBOL_word_list = 110,                /* word_list  */
  YYSYMBOL_identifier = 111,               /* identifier  */
  YYSYMBOL_superclass_identifier = 112,    /* superclass_identifier  */
  YYSYMBOL_meta_identifier = 113,          /* meta_identifier  */
  YYSYMBOL_string = 114,                   /* string  */
  YYSYMBOL_constant = 115,                 /* constant  */
  YYSYMBOL_matrix = 116,                   /* matrix  */
  YYSYMBOL_matrix_rows = 117,              /* matrix_rows  */
  YYSYMBOL_cell = 118,                     /* cell  */
  YYSYMBOL_cell_rows = 119,                /* cell_rows  */
  YYSYMBOL_cell_or_matrix_row = 120,       /* cell_or_matrix_row  */
  YYSYMBOL_fcn_handle = 121,               /* fcn_handle  */
  YYSYMBOL_anon_fcn_handle = 122,          /* anon_fcn_handle  */
  YYSYMBOL_primary_expr = 123,             /* primary_expr  */
  YYSYMBOL_magic_colon = 124,              /* magic_colon  */
  YYSYMBOL_magic_tilde = 125,              /* magic_tilde  */
  YYSYMBOL_arg_list = 126,                 /* arg_list  */
  YYSYMBOL_indirect_ref_op = 127,          /* indirect_ref_op  */
  YYSYMBOL_oper_expr = 128,                /* oper_expr  */
  YYSYMBOL_power_expr = 129,               /* power_expr  */
  YYSYMBOL_colon_expr = 130,               /* colon_expr  */
  YYSYMBOL_simple_expr = 131,              /* simple_expr  */
  YYSYMBOL_assign_lhs = 132,               /* assign_lhs  */
  YYSYMBOL_assign_expr = 133,              /* assign_expr  */
  YYSYMBOL_expression = 134,               /* expression  */
  YYSYMBOL_command = 135,                  /* command  */
  YYSYMBOL_declaration = 136,              /* declaration  */
  YYSYMBOL_decl1 = 137,                    /* decl1  */
  YYSYMBOL_decl_param_init = 138,          /* decl_param_init  */
  YYSYMBOL_decl2 = 139,                    /* decl2  */
  YYSYMBOL_select_command = 140,           /* select_command  */
  YYSYMBOL_if_command = 141,               /* if_command  */
  YYSYMBOL_if_cmd_list = 142,              /* if_cmd_list  */
  YYSYMBOL_if_cmd_list1 = 143,             /* if_cmd_list1  */
  YYSYMBOL_elseif_clause = 144,            /* elseif_clause  */
  YYSYMBOL_else_clause = 145,              /* else_clause  */
  YYSYMBOL_switch_command = 146,           /* switch_command  */
  YYSYMBOL_case_list = 147,                /* case_list  */
  YYSYMBOL_case_list1 = 148,               /* case_list1  */
  YYSYMBOL_switch_case = 149,              /* switch_case  */
  YYSYMBOL_default_case = 150,             /* default_case  */
  YYSYMBOL_loop_command = 151,             /* loop_command  */
  YYSYMBOL_jump_command = 152,             /* jump_command  */
  YYSYMBOL_except_command = 153,           /* except_command  */
  YYSYMBOL_push_fcn_symtab = 154,          /* push_fcn_symtab  */
  YYSYMBOL_param_list_beg = 155,           /* param_list_beg  */
  YYSYMBOL_param_list_end = 156,           /* param_list_end  */
  YYSYMBOL_opt_param_list = 157,           /* opt_param_list  */
  YYSYMBOL_param_list = 158,               /* param_list  */
  YYSYMBOL_param_list1 = 159,              /* param_list1  */
  YYSYMBOL_param_list2 = 160,              /* param_list2  */
  YYSYMBOL_param_list_elt = 161,           /* param_list_elt  */
  YYSYMBOL_return_list = 162,              /* return_list  */
  YYSYMBOL_return_list1 = 163,             /* return_list1  */
  YYSYMBOL_parsing_local_fcns = 164,       /* parsing_local_fcns  */
  YYSYMBOL_push_script_symtab = 165,       /* push_script_symtab  */
  YYSYMBOL_begin_file = 166,               /* begin_file  */
  YYSYMBOL_file = 167,                     /* file  */
  YYSYMBOL_function_beg = 168,             /* function_beg  */
  YYSYMBOL_fcn_name = 169,                 /* fcn_name  */
  YYSYMBOL_function_end = 170,             /* function_end  */
  YYSYMBOL_function = 171,                 /* function  */
  YYSYMBOL_classdef_beg = 172,             /* classdef_beg  */
  YYSYMBOL_classdef = 173,                 /* classdef  */
  YYSYMBOL_attr_list = 174,                /* attr_list  */
  YYSYMBOL_attr_list1 = 175,               /* attr_list1  */
  YYSYMBOL_attr = 176,                     /* attr  */
  YYSYMBOL_superclass_list = 177,          /* superclass_list  */
  YYSYMBOL_superclass_list1 = 178,         /* superclass_list1  */
  YYSYMBOL_superclass = 179,               /* superclass  */
  YYSYMBOL_class_body = 180,               /* class_body  */
  YYSYMBOL_class_body1 = 181,              /* class_body1  */
  YYSYMBOL_properties_block = 182,         /* properties_block  */
  YYSYMBOL_property_list = 183,            /* property_list  */
  YYSYMBOL_property_list1 = 184,           /* property_list1  */
  YYSYMBOL_class_property = 185,           /* class_property  */
  YYSYMBOL_methods_block = 186,            /* methods_block  */
  YYSYMBOL_method_decl1 = 187,             /* method_decl1  */
  YYSYMBOL_method_decl = 188,              /* method_decl  */
  YYSYMBOL_189_1 = 189,                    /* $@1  */
  YYSYMBOL_method = 190,                   /* method  */
  YYSYMBOL_methods_list = 191,             /* methods_list  */
  YYSYMBOL_methods_list1 = 192,            /* methods_list1  */
  YYSYMBOL_events_block = 193,             /* events_block  */
  YYSYMBOL_events_list = 194,              /* events_list  */
  YYSYMBOL_events_list1 = 195,             /* events_list1  */
  YYSYMBOL_class_event = 196,              /* class_event  */
  YYSYMBOL_enum_block = 197,               /* enum_block  */
  YYSYMBOL_enum_list = 198,                /* enum_list  */
  YYSYMBOL_enum_list1 = 199,               /* enum_list1  */
  YYSYMBOL_class_enum = 200,               /* class_enum  */
  YYSYMBOL_stmt_begin = 201,               /* stmt_begin  */
  YYSYMBOL_anon_fcn_begin = 202,           /* anon_fcn_begin  */
  YYSYMBOL_stash_comment = 203,            /* stash_comment  */
  YYSYMBOL_parse_error = 204,              /* parse_error  */
  YYSYMBOL_sep_no_nl = 205,                /* sep_no_nl  */
  YYSYMBOL_opt_sep_no_nl = 206,            /* opt_sep_no_nl  */
  YYSYMBOL_opt_nl = 207,                   /* opt_nl  */
  YYSYMBOL_nl = 208,                       /* nl  */
  YYSYMBOL_sep = 209,                      /* sep  */
  YYSYMBOL_opt_sep = 210                   /* opt_sep  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined OCTAVE_STYPE_IS_TRIVIAL && OCTAVE_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  106
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1588

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  98
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  113
/* YYNRULES -- Number of rules.  */
#define YYNRULES  290
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  529

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   335


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      19,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       9,    10,     7,     6,    17,     5,    15,     8,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    18,
       2,     3,     2,     2,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    11,     2,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    13,     2,    14,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97
};

#if OCTAVE_DEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   391,   391,   400,   410,   417,   423,   427,   429,   434,
     435,   439,   443,   445,   450,   451,   455,   463,   468,   475,
     477,   479,   491,   503,   505,   516,   525,   536,   545,   547,
     551,   553,   555,   559,   563,   565,   581,   585,   587,   612,
     613,   619,   621,   627,   633,   642,   650,   662,   675,   677,
     679,   681,   686,   688,   690,   692,   701,   710,   718,   720,
     722,   724,   731,   738,   747,   756,   758,   760,   762,   774,
     786,   798,   810,   812,   814,   816,   823,   825,   827,   829,
     831,   833,   835,   837,   839,   841,   843,   845,   847,   849,
     851,   853,   855,   859,   861,   863,   865,   877,   889,   901,
     913,   915,   922,   924,   926,   928,   930,   934,   946,   961,
     963,   965,   967,   969,   971,   973,   975,   977,   979,   981,
     983,   987,  1001,  1003,  1005,  1007,  1009,  1011,  1013,  1015,
    1017,  1019,  1021,  1023,  1025,  1029,  1044,  1051,  1059,  1061,
    1063,  1065,  1067,  1069,  1071,  1079,  1084,  1091,  1093,  1101,
    1106,  1108,  1121,  1123,  1131,  1141,  1143,  1150,  1158,  1165,
    1176,  1189,  1202,  1203,  1205,  1207,  1214,  1216,  1223,  1232,
    1245,  1257,  1264,  1276,  1290,  1302,  1323,  1328,  1333,  1341,
    1354,  1367,  1385,  1397,  1414,  1425,  1426,  1430,  1437,  1446,
    1447,  1464,  1466,  1475,  1477,  1485,  1494,  1513,  1533,  1537,
    1552,  1556,  1565,  1569,  1597,  1616,  1625,  1634,  1644,  1656,
    1669,  1704,  1711,  1725,  1742,  1762,  1763,  1773,  1775,  1784,
    1786,  1793,  1802,  1808,  1820,  1826,  1835,  1840,  1841,  1849,
    1851,  1853,  1855,  1857,  1864,  1871,  1878,  1888,  1906,  1907,
    1916,  1918,  1950,  1954,  1964,  1981,  1986,  1993,  1996,  1995,
    2011,  2013,  2018,  2019,  2027,  2035,  2049,  2067,  2068,  2076,
    2078,  2087,  2091,  2109,  2110,  2118,  2120,  2129,  2143,  2150,
    2158,  2161,  2167,  2171,  2177,  2183,  2189,  2198,  2199,  2204,
    2205,  2209,  2215,  2223,  2229,  2235,  2241,  2247,  2253,  2262,
    2263
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if OCTAVE_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "'='", "':'", "'-'",
  "'+'", "'*'", "'/'", "'('", "')'", "'['", "']'", "'{'", "'}'", "'.'",
  "'@'", "','", "';'", "'\\n'", "ADD_EQ", "SUB_EQ", "MUL_EQ", "DIV_EQ",
  "LEFTDIV_EQ", "POW_EQ", "EMUL_EQ", "EDIV_EQ", "ELEFTDIV_EQ", "EPOW_EQ",
  "AND_EQ", "OR_EQ", "EXPR_AND_AND", "EXPR_OR_OR", "EXPR_AND", "EXPR_OR",
  "EXPR_NOT", "EXPR_LT", "EXPR_LE", "EXPR_EQ", "EXPR_NE", "EXPR_GE",
  "EXPR_GT", "LEFTDIV", "EMUL", "EDIV", "ELEFTDIV", "EPLUS", "EMINUS",
  "HERMITIAN", "TRANSPOSE", "PLUS_PLUS", "MINUS_MINUS", "POW", "EPOW",
  "NUM", "IMAG_NUM", "STRUCT_ELT", "NAME", "END", "DQ_STRING", "SQ_STRING",
  "FOR", "PARFOR", "WHILE", "DO", "UNTIL", "IF", "ELSEIF", "ELSE",
  "SWITCH", "CASE", "OTHERWISE", "BREAK", "CONTINUE", "FUNC_RET", "UNWIND",
  "CLEANUP", "TRY", "CATCH", "GLOBAL", "PERSISTENT", "FCN_HANDLE",
  "CLASSDEF", "PROPERTIES", "METHODS", "EVENTS", "ENUMERATION",
  "METAQUERY", "SUPERCLASSREF", "FQ_IDENT", "GET", "SET", "FCN",
  "LEXICAL_ERROR", "END_OF_INPUT", "INPUT_FILE", "UNARY", "$accept",
  "input", "simple_list", "simple_list1", "opt_list", "list", "list1",
  "opt_fcn_list", "fcn_list", "fcn_list1", "statement", "word_list_cmd",
  "word_list", "identifier", "superclass_identifier", "meta_identifier",
  "string", "constant", "matrix", "matrix_rows", "cell", "cell_rows",
  "cell_or_matrix_row", "fcn_handle", "anon_fcn_handle", "primary_expr",
  "magic_colon", "magic_tilde", "arg_list", "indirect_ref_op", "oper_expr",
  "power_expr", "colon_expr", "simple_expr", "assign_lhs", "assign_expr",
  "expression", "command", "declaration", "decl1", "decl_param_init",
  "decl2", "select_command", "if_command", "if_cmd_list", "if_cmd_list1",
  "elseif_clause", "else_clause", "switch_command", "case_list",
  "case_list1", "switch_case", "default_case", "loop_command",
  "jump_command", "except_command", "push_fcn_symtab", "param_list_beg",
  "param_list_end", "opt_param_list", "param_list", "param_list1",
  "param_list2", "param_list_elt", "return_list", "return_list1",
  "parsing_local_fcns", "push_script_symtab", "begin_file", "file",
  "function_beg", "fcn_name", "function_end", "function", "classdef_beg",
  "classdef", "attr_list", "attr_list1", "attr", "superclass_list",
  "superclass_list1", "superclass", "class_body", "class_body1",
  "properties_block", "property_list", "property_list1", "class_property",
  "methods_block", "method_decl1", "method_decl", "$@1", "method",
  "methods_list", "methods_list1", "events_block", "events_list",
  "events_list1", "class_event", "enum_block", "enum_list", "enum_list1",
  "class_enum", "stmt_begin", "anon_fcn_begin", "stash_comment",
  "parse_error", "sep_no_nl", "opt_sep_no_nl", "opt_nl", "nl", "sep",
  "opt_sep", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,    61,    58,    45,    43,    42,    47,    40,
      41,    91,    93,   123,   125,    46,    64,    44,    59,    10,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335
};
#endif

#define YYPACT_NINF (-385)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-291)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     615,  -385,  1291,  1291,  1233,   285,   285,    52,  -385,  -385,
    1291,  1291,  1291,  -385,  -385,  -385,  -385,  -385,  -385,  -385,
    -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,    33,
      33,  -385,  -385,  -385,  -385,    69,     9,   203,  -385,  -385,
     178,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,
    1420,  -385,  1546,   619,  -385,  -385,  -385,  -385,  -385,  -385,
    -385,  -385,  -385,  -385,     7,    -1,   103,  -385,  -385,  -385,
    -385,   261,  -385,  -385,   197,   197,   135,  -385,  1221,  1291,
     190,  -385,  -385,  -385,   144,  -385,    60,  -385,  -385,    48,
    -385,   197,   197,   197,  1326,  1361,  1233,   218,  1233,  1233,
     218,   218,   160,    33,  -385,    33,  -385,  -385,  -385,   788,
    -385,   178,  -385,  1291,  1291,  1291,  1291,  1291,  1031,  1044,
    -385,  1291,  1291,  1291,  1291,  1291,  1291,  -385,  -385,  -385,
    -385,  1396,  1396,    29,  1291,  1291,  1291,  1291,  1291,  1291,
    1291,  1291,  1291,  1291,  1233,  1233,  1233,  1233,  1233,  1233,
    1233,  1233,  1233,  1233,  1233,  1233,  1233,  -385,  -385,  -385,
     869,   163,    23,  -385,  -385,  -385,   167,  -385,   285,  1221,
    -385,   285,  -385,  -385,  -385,  -385,   182,   177,  -385,    41,
    1233,   323,   206,  1233,   224,  -385,  -385,  -385,  -385,   251,
     950,  -385,   173,   212,   218,   950,   950,  -385,  -385,  -385,
    -385,  1482,  1468,  1468,   197,   197,  -385,    55,  -385,    96,
     197,   197,   197,   197,  1468,  1468,  1396,  1396,  1396,  1396,
    1396,  -385,    28,    28,  1233,  -385,   382,   343,   292,   400,
    -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,
    -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,
     146,  -385,   218,  -385,  -385,  -385,  -385,    36,   228,   230,
     269,   272,    52,  1221,  -385,  -385,  -385,  -385,  -385,  -385,
    -385,    17,  -385,  -385,   711,  1233,   724,  1233,   218,  -385,
    -385,  -385,   216,   218,  -385,  -385,  -385,  -385,  -385,   214,
     207,    -8,  1233,  1291,  -385,  1221,  -385,    28,    28,    28,
      28,    28,  1105,  1163,  -385,  -385,    30,   277,  -385,   707,
    -385,   279,   218,  -385,  -385,    47,    33,    33,    94,   218,
    -385,  -385,  1233,  -385,  1233,  -385,   950,  1233,   950,   218,
     218,  -385,  -385,   233,   214,  -385,  -385,  -385,  -385,  -385,
    -385,  1494,  -385,   187,  -385,   217,  1233,  -385,  -385,  -385,
      24,    33,   200,  -385,    33,  -385,  -385,  -385,    52,   950,
     289,   218,   283,   218,   244,  -385,  -385,  1233,   950,   218,
     218,  -385,  -385,  -385,   218,   218,  -385,  -385,   295,    33,
     303,   188,  -385,   218,   215,  -385,   218,  -385,  -385,   218,
     -19,   218,   950,  1233,   950,  -385,  -385,  -385,  1233,   950,
     950,   950,  -385,  -385,  -385,   218,    24,   270,  -385,   200,
     950,  -385,  -385,  -385,   950,   265,   325,   280,   218,  -385,
    -385,   290,   293,  1233,  -385,  -385,   248,    56,   196,  -385,
     -19,   294,  -385,   218,  -385,   950,   218,  -385,  -385,  -385,
    -385,  -385,  -385,  -385,  -385,  -385,   310,   218,  -385,  -385,
    -385,  -385,   248,  -385,  -385,  -385,   950,  -385,   950,   218,
     218,   218,   218,  -385,    56,  -385,   312,  -385,   279,   279,
     279,   279,  -385,  -385,  -385,  -385,  -385,   314,    14,   314,
     314,   317,   218,  -385,    33,  -385,  -385,  -385,   327,   218,
      25,   329,   218,  -385,    33,   330,   218,  -385,    33,  -385,
      49,  -385,   345,  -385,   100,   213,   387,  -385,  -385,   314,
    -385,  -385,   314,   384,  -385,  -385,  -385,  -385,  -385,  -385,
    -385,  1233,  1233,    33,   381,  -385,    52,  -385,  -385
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,   272,     0,     0,     0,    39,    39,     0,   273,   274,
       0,     0,     0,    30,    31,    25,    28,    29,   270,   270,
     270,   270,   270,   270,   176,   177,   178,   270,   270,     0,
       0,    45,    27,    26,   271,     0,     0,   277,     7,    21,
      48,    54,    53,    32,    49,    51,    52,    50,   137,    65,
     109,   110,   135,     0,   136,    19,    20,   138,   139,   152,
     153,   140,   141,   142,     0,     0,   279,   144,   270,   143,
       4,   278,     5,    48,    80,    79,     0,    56,    40,    57,
       0,    34,    59,    60,    41,    58,     0,    37,   183,     0,
     269,    78,    76,    77,     0,     0,     0,   289,     0,     0,
     289,   289,   150,   145,   147,   146,     1,     2,     3,   278,
       6,    22,    23,     0,     0,     0,     0,     0,     0,     0,
      64,     0,     0,     0,     0,     0,     0,    72,    73,    66,
      67,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,   202,   281,
       9,   280,     0,   275,   276,    55,    43,    33,    39,    42,
      36,    39,   188,    57,   194,   193,     0,   190,   191,     0,
       0,   121,     0,     0,     0,   268,   283,   284,   285,   290,
       9,   268,     0,   155,   289,     9,     9,   149,   148,     8,
      24,   107,    84,    83,    85,    86,    68,     0,    70,     0,
      91,    89,    90,    92,    87,    88,     0,     0,     0,     0,
       0,    93,    81,    82,     0,    74,   119,   120,   117,   118,
     111,   112,   113,   116,   114,   115,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   213,
       0,    10,   289,    12,   270,   200,   282,     0,     0,     0,
     206,     0,   185,    44,    35,    61,    62,    63,    38,   184,
     187,     0,    47,    46,     0,     0,     0,     0,   289,   286,
     287,   288,     0,   289,   154,   270,   270,   158,   156,   162,
       0,     0,     0,     0,    69,     0,    71,   106,   105,   104,
     102,   103,     0,     0,    94,    95,     0,     0,   203,   290,
      11,   215,   289,   195,   198,     0,     0,     0,     0,   289,
     186,   192,     0,   268,     0,   268,     9,     0,     9,   289,
     289,   270,   270,     0,   164,   166,   163,   270,   181,   270,
     151,   108,    96,     0,    98,     0,     0,   100,    75,    13,
       0,     0,    14,   197,     0,   207,   208,   206,   185,     9,
       0,   289,   122,   289,     0,   171,   157,     0,     9,   289,
     289,   161,   167,   165,   289,   289,    97,    99,     0,     0,
     219,     0,   217,   289,     0,    15,   289,    17,   199,   289,
       0,   289,     9,     0,     9,   170,   268,   160,     0,     9,
       9,     9,   101,   221,   149,   289,     0,   222,   204,    16,
       9,   209,   210,   211,     9,     0,     0,     0,   289,   268,
     169,     0,     0,     0,   216,   218,     0,   227,   289,    18,
       0,     0,   172,   289,   174,     9,   289,   179,   180,   220,
     226,   224,   270,   270,   270,   270,     0,   289,   229,   230,
     231,   232,     0,   223,   212,   173,     9,   159,     9,   289,
     289,   289,   289,   214,   228,   225,     0,   168,   215,   215,
     215,   215,   233,   234,   235,   236,   175,   238,   270,   257,
     263,     0,   289,   240,     0,   251,   250,   254,     0,   289,
       0,     0,   289,   259,     0,     0,   289,   265,     0,   237,
     270,   239,   242,   244,   270,   245,     0,   247,   256,   258,
     261,   262,   264,     0,   241,   149,   255,   246,   248,   260,
     266,     0,     0,     0,     0,   243,   245,   249,   267
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -385,  -385,  -385,  -385,   118,  -385,  -385,  -385,  -385,  -385,
       2,  -385,  -385,     0,  -385,  -385,   -23,  -385,  -385,  -385,
    -385,  -385,    12,  -385,  -385,   -69,  -142,   -84,   -74,   -45,
      11,   -62,  -385,   124,   -63,  -385,    20,  -385,  -385,   365,
    -384,   -70,  -385,  -385,  -385,  -385,  -385,  -385,  -385,  -385,
    -385,    62,    63,  -385,  -385,  -385,  -385,  -385,  -385,    40,
      -6,  -385,  -385,   131,   -87,  -385,  -385,  -385,  -385,  -385,
    -385,    86,   -25,  -297,  -385,  -385,  -245,  -385,     1,  -385,
    -385,   -44,  -385,  -385,   -55,  -385,  -385,   -89,   -52,  -108,
    -385,  -385,   -79,  -385,  -385,   -38,  -385,  -385,   -82,   -35,
    -385,  -385,   -76,  -179,  -385,   -12,  -385,   408,   410,  -385,
    -385,  -249,   176
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    35,    36,    37,   250,   251,   252,   384,   385,   386,
     253,    39,   111,    73,    41,    42,    43,    44,    45,    80,
      46,    86,    81,    47,    48,    49,    82,    83,    84,   133,
      50,   222,    51,    52,    53,    54,    55,    56,    57,   103,
     292,   104,    58,    59,   192,   193,   287,   288,    60,   333,
     334,   335,   336,    61,    62,    63,    64,    89,   270,   319,
     320,   176,   177,   178,   261,   315,   312,    65,    66,    67,
      68,   262,   413,    69,   254,   255,   351,   381,   382,   427,
     428,   441,   446,   447,   448,   481,   482,   483,   449,   507,
     486,   523,   487,   488,   489,   450,   491,   492,   493,   451,
     495,   496,   497,   278,   179,   484,    70,    71,    72,   160,
     161,   189,   190
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      40,    90,    38,   309,   166,   174,    94,    95,    96,    97,
      98,    99,   283,    74,    75,   100,   101,   112,    87,   175,
     423,    91,    92,    93,    76,    85,    85,   265,   107,   102,
     102,   182,   184,   198,   257,   198,   257,   302,   224,   346,
     411,   303,   272,   120,   207,   209,     2,     3,   313,   172,
       4,   338,     5,   173,     6,   387,   162,     7,  -189,   353,
     379,    88,   221,   221,   354,   294,   279,   280,   281,   106,
     223,   339,   295,  -252,   170,    15,   412,    10,   171,   304,
     305,    15,    15,    15,   173,   266,   225,   347,   200,   102,
      91,    15,    11,    12,    15,   158,    13,    14,    85,    15,
     157,    16,    17,   102,   108,   102,    15,  -182,  -290,    40,
     296,   199,   429,   295,   258,   259,   185,   274,   191,   194,
     276,   265,   159,    31,   201,   202,   203,   204,   205,    32,
      33,   522,   210,   211,   212,   213,   214,   215,    85,    85,
     442,   443,   444,   445,   361,   165,   363,   221,   221,   221,
     221,   221,    15,   265,   297,   298,   299,   300,   301,  -253,
      40,   169,   260,   197,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   306,   306,   266,
     264,   485,   256,   268,   263,   258,   259,   174,    85,   267,
      40,    85,   269,  -182,   271,    40,    40,   376,   405,   273,
      76,   175,   167,    76,   295,   406,   118,   485,   168,   275,
     119,   266,   120,   186,   187,   188,  -196,   418,   181,   181,
       8,     9,    88,   477,   478,   479,   480,   277,   343,   345,
     452,   377,   284,   500,   295,   186,   187,   188,    16,    17,
     436,   308,   311,   316,   307,   317,   127,   128,   129,   130,
     131,   132,   306,   306,   306,   306,   306,   314,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   279,   280,
     281,   102,  -196,   329,   330,   318,   195,   196,   163,   164,
     285,   286,   327,   267,   337,   331,   332,   348,   350,    77,
       2,     3,   371,  -182,     4,   323,     5,   325,     6,   391,
     393,     7,    78,   395,   341,   402,   404,   426,   282,    40,
     408,   349,   340,   290,   291,   267,   355,   356,   357,   369,
     370,    79,    85,    85,   432,   374,    40,   375,    40,   138,
     139,   140,   141,   142,   143,   433,    11,    12,   440,   434,
      13,    14,   360,    15,   362,    16,    17,   365,   515,   437,
     380,   383,   438,   455,   388,   134,   135,   136,   137,    40,
     138,   139,   140,   141,   142,   143,   378,    31,    40,   463,
     289,   476,  -270,    32,    33,   134,   499,   136,   137,   403,
     138,   139,   140,   141,   142,   143,   503,   396,   508,   511,
     518,   528,    40,   521,    40,   105,   372,   373,   389,    40,
      40,    40,   321,   506,   358,   454,   380,   425,   465,   472,
      40,   514,   473,   416,    40,   527,   136,   137,   419,   138,
     139,   140,   141,   142,   143,   516,   474,   519,   310,   475,
     459,   460,   461,   462,   136,    40,   520,   138,   139,   140,
     141,   142,   143,   439,   364,   109,   366,   110,     0,     0,
       0,     0,     0,     0,   326,     0,    40,     0,    40,   328,
       0,     0,     0,     0,     0,     0,   490,   494,   498,     0,
       0,     0,     0,     0,     0,     0,     0,   390,     0,     0,
       0,     0,     0,     0,   502,     0,   397,     0,   352,     0,
     505,     0,   490,     0,   510,   359,     0,   494,   513,   517,
     498,     0,     0,     0,     0,   367,   368,     0,     0,     0,
     415,     0,   417,     0,     0,     0,     0,   420,   421,   422,
     517,     0,     0,   526,     0,     0,     0,     0,   430,     0,
       0,     0,   431,     0,     0,     0,     0,   392,     0,   394,
       0,   524,   525,     0,     0,   398,   399,     0,     0,     0,
     400,   401,     0,   457,     0,     0,     0,     0,     0,   407,
       0,     0,   409,     0,     0,   410,     0,   414,     0,     0,
       0,     0,     0,     0,   466,     0,   467,     0,     0,     0,
       0,   424,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   435,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   453,     0,     0,     0,     0,   456,
       0,     0,   458,     0,     0,     0,     1,     0,     0,     0,
       2,     3,   144,   464,     4,     0,     5,     0,     6,     0,
       0,     7,     8,     9,  -277,   468,   469,   470,   471,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,    10,     0,     0,     0,     0,     0,     0,   501,     0,
       0,     0,     0,     0,     0,   504,    11,    12,   509,     0,
      13,    14,   512,    15,     0,    16,    17,    18,    19,    20,
      21,     0,    22,     0,     0,    23,     0,     0,    24,    25,
      26,    27,     0,    28,     0,    29,    30,    31,     0,     0,
       0,     0,     0,    32,    33,     0,     0,     0,  -182,    34,
    -277,  -201,     2,     3,   322,     0,     4,     0,     5,     0,
       6,     0,     0,     7,   279,   280,   281,   324,     0,     0,
       0,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,    10,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,     0,     0,    11,    12,
       0,     0,    13,    14,     0,    15,     0,    16,    17,    18,
      19,    20,    21,     0,    22,     0,     0,    23,     0,     0,
      24,    25,    26,    27,     0,    28,     0,    29,    30,    31,
       0,     0,     0,     2,     3,    32,    33,     4,     0,     5,
    -182,     6,     0,  -201,     7,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
      12,     0,     0,    13,    14,     0,    15,     0,    16,    17,
      18,    19,    20,    21,     0,    22,     0,     0,    23,     0,
       0,    24,    25,    26,    27,     0,    28,     0,    29,    30,
      31,     0,     0,     0,     2,     3,    32,    33,     4,     0,
       5,  -182,     6,     0,  -201,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      11,    12,     0,     0,    13,    14,     0,    15,     0,    16,
      17,    18,    19,    20,    21,     0,    22,     0,     0,    23,
       0,     0,    24,    25,    26,    27,     0,    28,     0,    29,
      30,    31,   249,     0,     0,     2,     3,    32,    33,     4,
       0,     5,  -182,     6,     0,  -201,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    11,    12,     0,     0,    13,    14,     0,    15,     0,
      16,    17,    18,    19,    20,    21,     0,    22,     0,     0,
      23,     0,     0,    24,    25,    26,    27,     0,    28,     0,
      29,    30,    31,     0,     0,    77,     2,     3,    32,    33,
       4,   206,     5,  -182,     6,     0,  -201,     7,    77,     2,
       3,     0,     0,     4,     0,     5,     0,     6,   208,     0,
       7,     0,     0,     0,     0,     0,     0,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,     0,    11,    12,     0,     0,    13,    14,     0,    15,
       0,    16,    17,     0,     0,    11,    12,     0,     0,    13,
      14,     0,    15,     0,    16,    17,     0,     0,     0,    77,
       2,     3,     0,    31,     4,   342,     5,     0,     6,    32,
      33,     7,     0,     0,     0,     0,    31,     0,     0,     0,
       0,     0,    32,    33,     0,     0,     0,     0,     0,     0,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    11,    12,     0,     0,
      13,    14,     0,    15,     0,    16,    17,    77,     2,     3,
       0,     0,     4,     0,     5,     0,     6,   344,     0,     7,
       0,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,     0,     0,    32,    33,     0,     0,     0,     0,    79,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    11,    12,     0,     0,    13,    14,
       0,    15,     0,    16,    17,    77,     2,     3,     0,     0,
       4,     0,     5,     0,     6,     0,     0,     7,     2,     3,
       0,     0,     4,     0,     5,    31,     6,     0,     0,     7,
       0,    32,    33,     0,     0,     0,     0,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    10,
       0,     0,    11,    12,     0,     0,    13,    14,     0,    15,
       0,    16,    17,     0,    11,    12,     0,     0,    13,    14,
       0,    15,     0,    16,    17,     0,     2,     3,     0,     0,
       4,     0,     5,    31,     6,     0,     0,     0,     0,    32,
      33,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,    32,    33,     0,     0,     0,     0,    10,     0,     0,
       0,     2,     3,     0,     0,   180,     0,     5,     0,     6,
       0,     0,    11,    12,     0,     0,    13,    14,     0,    15,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,     0,     0,     0,     2,     3,     0,     0,
     183,     0,     5,    31,     6,     0,     0,    11,    12,    32,
      33,    13,    14,     0,    15,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    10,     0,     0,
       0,   216,   217,     0,     0,     4,     0,     5,    31,     6,
       0,     0,    11,    12,    32,    33,    13,    14,     0,    15,
       0,    16,    17,     0,   113,   114,   115,   116,   117,   118,
       0,     0,   218,   119,     0,   120,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,   219,   220,    32,
      33,    13,    14,     0,    15,     0,    16,    17,     0,     0,
       0,     0,     0,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   116,   117,   118,    31,     0,
       0,   119,     0,   120,    32,    33,   293,   114,   115,   116,
     117,   118,     0,     0,     0,   119,     0,   120,     0,   114,
     115,   116,   117,   118,     0,     0,     0,   119,     0,   120,
       0,   121,   122,   123,   124,     0,     0,   127,   128,   129,
     130,   131,   132,     0,     0,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,  -121,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -121,  -121,  -121,  -121,
    -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,   134,   135,
     136,   137,     0,   138,   139,   140,   141,   142,   143
};

static const yytype_int16 yycheck[] =
{
       0,     7,     0,   252,    78,    89,    18,    19,    20,    21,
      22,    23,   191,     2,     3,    27,    28,    40,     6,    89,
     404,    10,    11,    12,     4,     5,     6,   169,    19,    29,
      30,    94,    95,   103,    11,   105,    11,     9,     9,     9,
      59,    13,     1,    15,   118,   119,     5,     6,    12,     1,
       9,    59,    11,    36,    13,   352,    68,    16,    10,    12,
      36,     9,   131,   132,    17,    10,    17,    18,    19,     0,
     132,    79,    17,    59,    14,    58,    95,    36,    18,    51,
      52,    58,    58,    58,    36,   169,    57,    57,   111,    89,
      79,    58,    51,    52,    58,    96,    55,    56,    78,    58,
      93,    60,    61,   103,    95,   105,    58,    93,    59,   109,
      14,   109,   409,    17,    91,    92,    96,   180,    98,    99,
     183,   263,    19,    82,   113,   114,   115,   116,   117,    88,
      89,   515,   121,   122,   123,   124,   125,   126,   118,   119,
      84,    85,    86,    87,   323,    10,   325,   216,   217,   218,
     219,   220,    58,   295,   216,   217,   218,   219,   220,    59,
     160,    17,   162,     3,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   222,   223,   263,
     168,   478,    19,   171,    17,    91,    92,   271,   168,   169,
     190,   171,    10,    93,    17,   195,   196,    10,    10,   179,
     180,   271,    12,   183,    17,    17,     9,   504,    18,     3,
      13,   295,    15,    17,    18,    19,     3,   396,    94,    95,
      17,    18,     9,   468,   469,   470,   471,     3,   302,   303,
      34,    14,    59,   482,    17,    17,    18,    19,    60,    61,
     419,    95,   254,    15,   224,    15,    49,    50,    51,    52,
      53,    54,   297,   298,   299,   300,   301,   257,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,    17,    18,
      19,   271,     3,   285,   286,     3,   100,   101,    17,    18,
      68,    69,    66,   263,    77,    71,    72,    10,     9,     4,
       5,     6,    59,    93,     9,   275,    11,   277,    13,    10,
      17,    16,    17,    59,   293,    10,     3,    37,   190,   309,
      95,   309,   292,   195,   196,   295,   316,   317,   318,   331,
     332,    36,   302,   303,    59,   337,   326,   339,   328,    37,
      38,    39,    40,    41,    42,    10,    51,    52,    90,    59,
      55,    56,   322,    58,   324,    60,    61,   327,     3,    59,
     350,   351,    59,    59,   354,    32,    33,    34,    35,   359,
      37,    38,    39,    40,    41,    42,   346,    82,   368,    59,
     194,    59,    58,    88,    89,    32,    59,    34,    35,   379,
      37,    38,    39,    40,    41,    42,    59,   367,    59,    59,
       3,    10,   392,     9,   394,    30,   334,   334,   358,   399,
     400,   401,   271,   490,   318,   430,   406,   406,   452,   464,
     410,   500,   464,   393,   414,   523,    34,    35,   398,    37,
      38,    39,    40,    41,    42,   504,   464,   509,   252,   464,
     442,   443,   444,   445,    34,   435,   512,    37,    38,    39,
      40,    41,    42,   423,   326,    37,   328,    37,    -1,    -1,
      -1,    -1,    -1,    -1,   278,    -1,   456,    -1,   458,   283,
      -1,    -1,    -1,    -1,    -1,    -1,   478,   479,   480,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,
      -1,    -1,    -1,    -1,   484,    -1,   368,    -1,   312,    -1,
     490,    -1,   504,    -1,   494,   319,    -1,   509,   498,   505,
     512,    -1,    -1,    -1,    -1,   329,   330,    -1,    -1,    -1,
     392,    -1,   394,    -1,    -1,    -1,    -1,   399,   400,   401,
     526,    -1,    -1,   523,    -1,    -1,    -1,    -1,   410,    -1,
      -1,    -1,   414,    -1,    -1,    -1,    -1,   361,    -1,   363,
      -1,   521,   522,    -1,    -1,   369,   370,    -1,    -1,    -1,
     374,   375,    -1,   435,    -1,    -1,    -1,    -1,    -1,   383,
      -1,    -1,   386,    -1,    -1,   389,    -1,   391,    -1,    -1,
      -1,    -1,    -1,    -1,   456,    -1,   458,    -1,    -1,    -1,
      -1,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   428,    -1,    -1,    -1,    -1,   433,
      -1,    -1,   436,    -1,    -1,    -1,     1,    -1,    -1,    -1,
       5,     6,     3,   447,     9,    -1,    11,    -1,    13,    -1,
      -1,    16,    17,    18,    19,   459,   460,   461,   462,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    36,    -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,
      -1,    -1,    -1,    -1,    -1,   489,    51,    52,   492,    -1,
      55,    56,   496,    58,    -1,    60,    61,    62,    63,    64,
      65,    -1,    67,    -1,    -1,    70,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    93,    94,
      95,    96,     5,     6,     3,    -1,     9,    -1,    11,    -1,
      13,    -1,    -1,    16,    17,    18,    19,     3,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    36,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    51,    52,
      -1,    -1,    55,    56,    -1,    58,    -1,    60,    61,    62,
      63,    64,    65,    -1,    67,    -1,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      -1,    -1,    -1,     5,     6,    88,    89,     9,    -1,    11,
      93,    13,    -1,    96,    16,    17,    18,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      52,    -1,    -1,    55,    56,    -1,    58,    -1,    60,    61,
      62,    63,    64,    65,    -1,    67,    -1,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    -1,    -1,    -1,     5,     6,    88,    89,     9,    -1,
      11,    93,    13,    -1,    96,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    55,    56,    -1,    58,    -1,    60,
      61,    62,    63,    64,    65,    -1,    67,    -1,    -1,    70,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    -1,    -1,     5,     6,    88,    89,     9,
      -1,    11,    93,    13,    -1,    96,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    52,    -1,    -1,    55,    56,    -1,    58,    -1,
      60,    61,    62,    63,    64,    65,    -1,    67,    -1,    -1,
      70,    -1,    -1,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    -1,    -1,     4,     5,     6,    88,    89,
       9,    10,    11,    93,    13,    -1,    96,    16,     4,     5,
       6,    -1,    -1,     9,    -1,    11,    -1,    13,    14,    -1,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    51,    52,    -1,    -1,    55,    56,    -1,    58,
      -1,    60,    61,    -1,    -1,    51,    52,    -1,    -1,    55,
      56,    -1,    58,    -1,    60,    61,    -1,    -1,    -1,     4,
       5,     6,    -1,    82,     9,    10,    11,    -1,    13,    88,
      89,    16,    -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      55,    56,    -1,    58,    -1,    60,    61,     4,     5,     6,
      -1,    -1,     9,    -1,    11,    -1,    13,    14,    -1,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    55,    56,
      -1,    58,    -1,    60,    61,     4,     5,     6,    -1,    -1,
       9,    -1,    11,    -1,    13,    -1,    -1,    16,     5,     6,
      -1,    -1,     9,    -1,    11,    82,    13,    -1,    -1,    16,
      -1,    88,    89,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    51,    52,    -1,    -1,    55,    56,    -1,    58,
      -1,    60,    61,    -1,    51,    52,    -1,    -1,    55,    56,
      -1,    58,    -1,    60,    61,    -1,     5,     6,    -1,    -1,
       9,    -1,    11,    82,    13,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,     5,     6,    -1,    -1,     9,    -1,    11,    -1,    13,
      -1,    -1,    51,    52,    -1,    -1,    55,    56,    -1,    58,
      -1,    60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,     5,     6,    -1,    -1,
       9,    -1,    11,    82,    13,    -1,    -1,    51,    52,    88,
      89,    55,    56,    -1,    58,    -1,    60,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,     5,     6,    -1,    -1,     9,    -1,    11,    82,    13,
      -1,    -1,    51,    52,    88,    89,    55,    56,    -1,    58,
      -1,    60,    61,    -1,     4,     5,     6,     7,     8,     9,
      -1,    -1,    36,    13,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    -1,    -1,    -1,    51,    52,    88,
      89,    55,    56,    -1,    58,    -1,    60,    61,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,     7,     8,     9,    82,    -1,
      -1,    13,    -1,    15,    88,    89,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    13,    -1,    15,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    13,    -1,    15,
      -1,    43,    44,    45,    46,    -1,    -1,    49,    50,    51,
      52,    53,    54,    -1,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    37,    38,    39,    40,    41,    42
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     5,     6,     9,    11,    13,    16,    17,    18,
      36,    51,    52,    55,    56,    58,    60,    61,    62,    63,
      64,    65,    67,    70,    73,    74,    75,    76,    78,    80,
      81,    82,    88,    89,    94,    99,   100,   101,   108,   109,
     111,   112,   113,   114,   115,   116,   118,   121,   122,   123,
     128,   130,   131,   132,   133,   134,   135,   136,   140,   141,
     146,   151,   152,   153,   154,   165,   166,   167,   168,   171,
     204,   205,   206,   111,   128,   128,   134,     4,    17,    36,
     117,   120,   124,   125,   126,   134,   119,   120,     9,   155,
     158,   128,   128,   128,   203,   203,   203,   203,   203,   203,
     203,   203,   111,   137,   139,   137,     0,    19,    95,   205,
     206,   110,   114,     4,     5,     6,     7,     8,     9,    13,
      15,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,   127,    32,    33,    34,    35,    37,    38,
      39,    40,    41,    42,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    93,    96,    19,
     207,   208,   203,    17,    18,    10,   126,    12,    18,    17,
      14,    18,     1,    36,   125,   139,   159,   160,   161,   202,
       9,   131,   132,     9,   132,   134,    17,    18,    19,   209,
     210,   134,   142,   143,   134,   210,   210,     3,   139,   108,
     114,   128,   128,   128,   128,   128,    10,   126,    14,   126,
     128,   128,   128,   128,   128,   128,     5,     6,    36,    51,
      52,   123,   129,   129,     9,    57,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,    83,
     102,   103,   104,   108,   172,   173,    19,    11,    91,    92,
     111,   162,   169,    17,   120,   124,   125,   134,   120,    10,
     156,    17,     1,   134,   132,     3,   132,     3,   201,    17,
      18,    19,   102,   201,    59,    68,    69,   144,   145,   210,
     102,   102,   138,     4,    10,    17,    14,   129,   129,   129,
     129,   129,     9,    13,    51,    52,   127,   134,    95,   209,
     210,   203,   164,    12,   111,   163,    15,    15,     3,   157,
     158,   161,     3,   134,     3,   134,   210,    66,   210,   203,
     203,    71,    72,   147,   148,   149,   150,    77,    59,    79,
     134,   128,    10,   126,    14,   126,     9,    57,    10,   108,
       9,   174,   210,    12,    17,   111,   111,   111,   169,   210,
     134,   201,   134,   201,   102,   134,   102,   210,   210,   203,
     203,    59,   149,   150,   203,   203,    10,    14,   134,    36,
     111,   175,   176,   111,   105,   106,   107,   171,   111,   157,
     102,    10,   210,    17,   210,    59,   134,   102,   210,   210,
     210,   210,    10,   111,     3,    10,    17,   210,    95,   210,
     210,    59,    95,   170,   210,   102,   134,   102,   201,   134,
     102,   102,   102,   138,   210,   176,    37,   177,   178,   171,
     102,   102,    59,    10,    59,   210,   201,    59,    59,   134,
      90,   179,    84,    85,    86,    87,   180,   181,   182,   186,
     193,   197,    34,   210,   170,    59,   210,   102,   210,   203,
     203,   203,   203,    59,   210,   179,   102,   102,   210,   210,
     210,   210,   182,   186,   193,   197,    59,   174,   174,   174,
     174,   183,   184,   185,   203,   171,   188,   190,   191,   192,
     203,   194,   195,   196,   203,   198,   199,   200,   203,    59,
     209,   210,   111,    59,   210,   111,   162,   187,    59,   210,
     111,    59,   210,   111,   185,     3,   190,   158,     3,   196,
     200,     9,   138,   189,   134,   134,   111,   187,    10
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    98,    99,    99,    99,   100,   100,   101,   101,   102,
     102,   103,   104,   104,   105,   105,   106,   107,   107,   108,
     108,   108,   109,   110,   110,   111,   112,   113,   114,   114,
     115,   115,   115,   116,   117,   117,   118,   119,   119,   120,
     120,   120,   120,   120,   120,   121,   122,   122,   123,   123,
     123,   123,   123,   123,   123,   123,   124,   125,   126,   126,
     126,   126,   126,   126,   127,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   130,   130,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   132,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   134,   134,   134,   135,   135,
     135,   135,   135,   135,   135,   136,   136,   137,   137,   138,
     139,   139,   140,   140,   141,   142,   142,   143,   143,   144,
     145,   146,   147,   147,   147,   147,   148,   148,   149,   150,
     151,   151,   151,   151,   151,   151,   152,   152,   152,   153,
     153,   153,   154,   155,   156,   157,   157,   158,   158,   159,
     159,   160,   160,   161,   161,   162,   162,   162,   163,   163,
     164,   165,   166,   167,   167,   168,   169,   169,   169,   170,
     170,   171,   171,   172,   173,   174,   174,   175,   175,   176,
     176,   176,   177,   177,   178,   178,   179,   180,   180,   181,
     181,   181,   181,   181,   181,   181,   181,   182,   183,   183,
     184,   184,   185,   185,   186,   187,   187,   188,   189,   188,
     190,   190,   191,   191,   192,   192,   193,   194,   194,   195,
     195,   196,   197,   198,   198,   199,   199,   200,   201,   202,
     203,   204,   204,   205,   205,   205,   205,   206,   206,   207,
     207,   208,   208,   209,   209,   209,   209,   209,   209,   210,
     210
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     1,     1,     2,     1,     3,     0,
       1,     2,     1,     3,     0,     1,     2,     1,     3,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     3,     0,
       1,     1,     2,     2,     3,     1,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     3,     3,     3,     1,     1,     2,     2,     3,     4,
       3,     4,     2,     2,     3,     5,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     2,     2,     3,     4,     3,     4,
       3,     5,     2,     2,     2,     2,     2,     3,     5,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     0,
       1,     4,     1,     1,     4,     1,     2,     4,     2,     7,
       4,     6,     0,     1,     1,     2,     1,     2,     7,     4,
       7,     6,     9,    10,     9,    12,     1,     1,     1,     9,
       9,     5,     0,     1,     1,     0,     1,     3,     2,     0,
       1,     1,     3,     1,     1,     2,     1,     3,     1,     3,
       0,     0,     2,     4,     7,     2,     1,     3,     3,     1,
       1,     7,     9,     1,     8,     0,     4,     1,     3,     1,
       4,     2,     0,     2,     2,     3,     1,     0,     2,     1,
       1,     1,     1,     3,     3,     3,     3,     6,     0,     2,
       1,     3,     2,     5,     6,     1,     2,     2,     0,     5,
       1,     1,     0,     2,     1,     3,     6,     0,     2,     1,
       3,     2,     6,     0,     2,     1,     3,     5,     0,     0,
       0,     1,     1,     1,     1,     2,     2,     0,     1,     0,
       1,     1,     2,     1,     1,     1,     2,     2,     2,     0,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = OCTAVE_EMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == OCTAVE_EMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parser, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use OCTAVE_error or OCTAVE_UNDEF. */
#define YYERRCODE OCTAVE_UNDEF


/* Enable debugging if requested.  */
#if OCTAVE_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, octave::base_parser& parser)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (parser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, octave::base_parser& parser)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parser);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, octave::base_parser& parser)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !OCTAVE_DEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !OCTAVE_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif
/* Parser data structure.  */
struct yypstate
  {
    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;
    /* Whether this instance has not started parsing yet.
     * If 2, it corresponds to a finished parsing.  */
    int yynew;
  };






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, octave::base_parser& parser)
{
  YY_USE (yyvaluep);
  YY_USE (parser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_3_: /* '='  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2026 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_4_: /* ':'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2032 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_5_: /* '-'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2038 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_6_: /* '+'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2044 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_7_: /* '*'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2050 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_8_: /* '/'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2056 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_9_: /* '('  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2062 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_10_: /* ')'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2068 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_11_: /* '['  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2074 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_12_: /* ']'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2080 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_13_: /* '{'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2086 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_14_: /* '}'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2092 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_15_: /* '.'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2098 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_16_: /* '@'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2104 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_17_: /* ','  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2110 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_18_: /* ';'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2116 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_19_n_: /* '\n'  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2122 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ADD_EQ: /* ADD_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2128 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SUB_EQ: /* SUB_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2134 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_MUL_EQ: /* MUL_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2140 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_DIV_EQ: /* DIV_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2146 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_LEFTDIV_EQ: /* LEFTDIV_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2152 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_POW_EQ: /* POW_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2158 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EMUL_EQ: /* EMUL_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2164 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EDIV_EQ: /* EDIV_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2170 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELEFTDIV_EQ: /* ELEFTDIV_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2176 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EPOW_EQ: /* EPOW_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2182 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_AND_EQ: /* AND_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2188 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_OR_EQ: /* OR_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2194 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_AND_AND: /* EXPR_AND_AND  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2200 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_OR_OR: /* EXPR_OR_OR  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2206 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_AND: /* EXPR_AND  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2212 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_OR: /* EXPR_OR  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2218 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_NOT: /* EXPR_NOT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2224 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_LT: /* EXPR_LT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2230 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_LE: /* EXPR_LE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2236 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_EQ: /* EXPR_EQ  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2242 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_NE: /* EXPR_NE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2248 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_GE: /* EXPR_GE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2254 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_GT: /* EXPR_GT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2260 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_LEFTDIV: /* LEFTDIV  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2266 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EMUL: /* EMUL  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2272 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EDIV: /* EDIV  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2278 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELEFTDIV: /* ELEFTDIV  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2284 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EPLUS: /* EPLUS  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2290 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EMINUS: /* EMINUS  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2296 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_HERMITIAN: /* HERMITIAN  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2302 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_TRANSPOSE: /* TRANSPOSE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2308 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PLUS_PLUS: /* PLUS_PLUS  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2314 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_MINUS_MINUS: /* MINUS_MINUS  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2320 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_POW: /* POW  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2326 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EPOW: /* EPOW  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2332 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_NUM: /* NUM  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2338 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_IMAG_NUM: /* IMAG_NUM  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2344 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_STRUCT_ELT: /* STRUCT_ELT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2350 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_NAME: /* NAME  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2356 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_END: /* END  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2362 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_DQ_STRING: /* DQ_STRING  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2368 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SQ_STRING: /* SQ_STRING  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2374 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FOR: /* FOR  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2380 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PARFOR: /* PARFOR  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2386 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_WHILE: /* WHILE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2392 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_DO: /* DO  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2398 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_UNTIL: /* UNTIL  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2404 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_IF: /* IF  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2410 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELSEIF: /* ELSEIF  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2416 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELSE: /* ELSE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2422 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SWITCH: /* SWITCH  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2428 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CASE: /* CASE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2434 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_OTHERWISE: /* OTHERWISE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2440 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_BREAK: /* BREAK  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2446 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CONTINUE: /* CONTINUE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2452 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FUNC_RET: /* FUNC_RET  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2458 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_UNWIND: /* UNWIND  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2464 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CLEANUP: /* CLEANUP  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2470 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_TRY: /* TRY  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2476 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CATCH: /* CATCH  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2482 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_GLOBAL: /* GLOBAL  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2488 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PERSISTENT: /* PERSISTENT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2494 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FCN_HANDLE: /* FCN_HANDLE  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2500 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CLASSDEF: /* CLASSDEF  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2506 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PROPERTIES: /* PROPERTIES  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2512 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_METHODS: /* METHODS  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2518 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EVENTS: /* EVENTS  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2524 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ENUMERATION: /* ENUMERATION  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2530 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_METAQUERY: /* METAQUERY  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2536 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SUPERCLASSREF: /* SUPERCLASSREF  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2542 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FQ_IDENT: /* FQ_IDENT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2548 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_GET: /* GET  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2554 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SET: /* SET  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2560 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FCN: /* FCN  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2566 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_LEXICAL_ERROR: /* LEXICAL_ERROR  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2572 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_END_OF_INPUT: /* END_OF_INPUT  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2578 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_UNARY: /* UNARY  */
#line 325 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2584 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_input: /* input  */
#line 327 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_type); }
#line 2590 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_simple_list: /* simple_list  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2596 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_simple_list1: /* simple_list1  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2602 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_list: /* opt_list  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2608 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_list: /* list  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2614 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_list1: /* list1  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2620 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_fcn_list: /* opt_fcn_list  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2626 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_list: /* fcn_list  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2632 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_list1: /* fcn_list1  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2638 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_statement: /* statement  */
#line 351 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_type); }
#line 2644 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_word_list_cmd: /* word_list_cmd  */
#line 338 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_index_expression_type); }
#line 2650 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_word_list: /* word_list  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2656 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_identifier: /* identifier  */
#line 337 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2662 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass_identifier: /* superclass_identifier  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_superclass_ref_type); }
#line 2668 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_meta_identifier: /* meta_identifier  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_metaclass_query_type); }
#line 2674 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_string: /* string  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2680 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_constant: /* constant  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2686 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_matrix: /* matrix  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2692 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_matrix_rows: /* matrix_rows  */
#line 328 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_matrix_type); }
#line 2698 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_cell: /* cell  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2704 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_cell_rows: /* cell_rows  */
#line 329 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_cell_type); }
#line 2710 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_cell_or_matrix_row: /* cell_or_matrix_row  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2716 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_handle: /* fcn_handle  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_fcn_handle_type); }
#line 2722 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_anon_fcn_handle: /* anon_fcn_handle  */
#line 336 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_anon_fcn_handle_type); }
#line 2728 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_primary_expr: /* primary_expr  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2734 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_magic_colon: /* magic_colon  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2740 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_magic_tilde: /* magic_tilde  */
#line 337 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2746 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_arg_list: /* arg_list  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2752 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_oper_expr: /* oper_expr  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2758 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_power_expr: /* power_expr  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2764 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_colon_expr: /* colon_expr  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2770 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_simple_expr: /* simple_expr  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2776 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_assign_lhs: /* assign_lhs  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2782 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_assign_expr: /* assign_expr  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2788 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_expression: /* expression  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2794 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_command: /* command  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2800 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_declaration: /* declaration  */
#line 350 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_command_type); }
#line 2806 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_decl1: /* decl1  */
#line 349 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_init_list_type); }
#line 2812 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_decl2: /* decl2  */
#line 348 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_elt_type); }
#line 2818 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_select_command: /* select_command  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2824 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_if_command: /* if_command  */
#line 342 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_type); }
#line 2830 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_if_cmd_list: /* if_cmd_list  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_list_type); }
#line 2836 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_if_cmd_list1: /* if_cmd_list1  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_list_type); }
#line 2842 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_elseif_clause: /* elseif_clause  */
#line 343 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_clause_type); }
#line 2848 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_else_clause: /* else_clause  */
#line 343 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_clause_type); }
#line 2854 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_switch_command: /* switch_command  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_command_type); }
#line 2860 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_case_list: /* case_list  */
#line 347 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_list_type); }
#line 2866 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_case_list1: /* case_list1  */
#line 347 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_list_type); }
#line 2872 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_switch_case: /* switch_case  */
#line 346 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_type); }
#line 2878 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_default_case: /* default_case  */
#line 346 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_type); }
#line 2884 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_loop_command: /* loop_command  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2890 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_jump_command: /* jump_command  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2896 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_except_command: /* except_command  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2902 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_param_list: /* opt_param_list  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2908 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list: /* param_list  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2914 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list1: /* param_list1  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2920 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list2: /* param_list2  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2926 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list_elt: /* param_list_elt  */
#line 348 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_elt_type); }
#line 2932 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_return_list: /* return_list  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2938 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_return_list1: /* return_list1  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2944 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_file: /* file  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2950 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_function_beg: /* function_beg  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2956 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_name: /* fcn_name  */
#line 337 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2962 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_function_end: /* function_end  */
#line 351 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_type); }
#line 2968 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_function: /* function  */
#line 335 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 2974 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_classdef_beg: /* classdef_beg  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2980 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_classdef: /* classdef  */
#line 355 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_type); }
#line 2986 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_attr_list: /* attr_list  */
#line 357 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_list_type); }
#line 2992 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_attr_list1: /* attr_list1  */
#line 357 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_list_type); }
#line 2998 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_attr: /* attr  */
#line 356 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_type); }
#line 3004 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass_list: /* superclass_list  */
#line 359 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_list_type); }
#line 3010 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass_list1: /* superclass_list1  */
#line 359 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_list_type); }
#line 3016 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass: /* superclass  */
#line 358 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_type); }
#line 3022 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_body: /* class_body  */
#line 360 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_body_type); }
#line 3028 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_body1: /* class_body1  */
#line 360 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_body_type); }
#line 3034 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_properties_block: /* properties_block  */
#line 363 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_properties_block_type); }
#line 3040 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_property_list: /* property_list  */
#line 362 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_list_type); }
#line 3046 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_property_list1: /* property_list1  */
#line 362 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_list_type); }
#line 3052 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_property: /* class_property  */
#line 361 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_type); }
#line 3058 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_methods_block: /* methods_block  */
#line 365 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_block_type); }
#line 3064 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_method_decl1: /* method_decl1  */
#line 353 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).octave_user_function_type); }
#line 3070 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_method_decl: /* method_decl  */
#line 335 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 3076 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_method: /* method  */
#line 335 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 3082 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_methods_list: /* methods_list  */
#line 364 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_list_type); }
#line 3088 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_methods_list1: /* methods_list1  */
#line 364 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_list_type); }
#line 3094 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_events_block: /* events_block  */
#line 368 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_block_type); }
#line 3100 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_events_list: /* events_list  */
#line 367 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_list_type); }
#line 3106 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_events_list1: /* events_list1  */
#line 367 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_list_type); }
#line 3112 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_event: /* class_event  */
#line 366 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_event_type); }
#line 3118 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_enum_block: /* enum_block  */
#line 371 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_block_type); }
#line 3124 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_enum_list: /* enum_list  */
#line 370 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_list_type); }
#line 3130 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_enum_list1: /* enum_list1  */
#line 370 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_list_type); }
#line 3136 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_enum: /* class_enum  */
#line 369 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_type); }
#line 3142 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_stash_comment: /* stash_comment  */
#line 324 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3148 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_sep_no_nl: /* sep_no_nl  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3154 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_sep_no_nl: /* opt_sep_no_nl  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3160 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_nl: /* opt_nl  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3166 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_nl: /* nl  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3172 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_sep: /* sep  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3178 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_sep: /* opt_sep  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3184 "libinterp/parse-tree/oct-parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}





int
yyparse (octave::base_parser& parser)
{
  yypstate *yyps = yypstate_new ();
  if (!yyps)
    {
      yyerror (parser, YY_("memory exhausted"));
      return 2;
    }
  int yystatus = yypull_parse (yyps, parser);
  yypstate_delete (yyps);
  return yystatus;
}

int
yypull_parse (yypstate *yyps, octave::base_parser& parser)
{
  YY_ASSERT (yyps);
  int yystatus;
  do {
    YYSTYPE yylval;
    int yychar = yylex (&yylval, scanner);
    yystatus = yypush_parse (yyps, yychar, &yylval, parser);
  } while (yystatus == YYPUSH_MORE);
  return yystatus;
}

#define octave_nerrs yyps->octave_nerrs
#define yystate yyps->yystate
#define yyerrstatus yyps->yyerrstatus
#define yyssa yyps->yyssa
#define yyss yyps->yyss
#define yyssp yyps->yyssp
#define yyvsa yyps->yyvsa
#define yyvs yyps->yyvs
#define yyvsp yyps->yyvsp
#define yystacksize yyps->yystacksize

/* Initialize the parser data structure.  */
static void
yypstate_clear (yypstate *yyps)
{
  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yyssp = yyss;
  yyvsp = yyvs;

  /* Initialize the state stack, in case yypcontext_expected_tokens is
     called before the first call to yyparse. */
  *yyssp = 0;
  yyps->yynew = 1;
}

/* Initialize the parser data structure.  */
yypstate *
yypstate_new (void)
{
  yypstate *yyps;
  yyps = YY_CAST (yypstate *, YYMALLOC (sizeof *yyps));
  if (!yyps)
    return YY_NULLPTR;
  yystacksize = YYINITDEPTH;
  yyss = yyssa;
  yyvs = yyvsa;
  yypstate_clear (yyps);
  return yyps;
}

void
yypstate_delete (yypstate *yyps)
{
  if (yyps)
    {
#ifndef yyoverflow
      /* If the stack was reallocated but the parse did not complete, then the
         stack still needs to be freed.  */
      if (yyss != yyssa)
        YYSTACK_FREE (yyss);
#endif
      YYFREE (yyps);
    }
}



/*---------------.
| yypush_parse.  |
`---------------*/

int
yypush_parse (yypstate *yyps,
              int yypushed_char, YYSTYPE const *yypushed_val, octave::base_parser& parser)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  switch (yyps->yynew)
    {
    case 2:
      yypstate_clear (yyps);
      goto case_0;

    case_0:
    case 0:
      yyn = yypact[yystate];
      goto yyread_pushed_token;
    }

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = OCTAVE_EMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == OCTAVE_EMPTY)
    {
      if (!yyps->yynew)
        {
          YYDPRINTF ((stderr, "Return for a new token:\n"));
          yyresult = YYPUSH_MORE;
          goto yypushreturn;
        }
      yyps->yynew = 0;
yyread_pushed_token:
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yypushed_char;
      if (yypushed_val)
        yylval = *yypushed_val;
    }

  if (yychar <= OCTAVE_EOF)
    {
      yychar = OCTAVE_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == OCTAVE_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = OCTAVE_UNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = OCTAVE_EMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* input: simple_list '\n'  */
#line 392 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_type) = nullptr;
                    std::shared_ptr<octave::tree_statement_list> tmp_lst ((yyvsp[-1].tree_statement_list_type));
                    parser.statement_list (tmp_lst);
                    YYACCEPT;
                  }
#line 3551 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 3: /* input: simple_list END_OF_INPUT  */
#line 401 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_type) = nullptr;
                    lexer.m_end_of_input = true;
                    std::shared_ptr<octave::tree_statement_list> tmp_lst ((yyvsp[-1].tree_statement_list_type));
                    parser.statement_list (tmp_lst);
                    YYACCEPT;
                  }
#line 3565 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 4: /* input: parse_error  */
#line 411 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_type) = nullptr;
                    YYABORT;
                  }
#line 3574 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 5: /* simple_list: opt_sep_no_nl  */
#line 418 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_statement_list_type) = nullptr;
                  }
#line 3584 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 6: /* simple_list: simple_list1 opt_sep_no_nl  */
#line 424 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.set_stmt_print_flag ((yyvsp[-1].tree_statement_list_type), (yyvsp[0].punct_type), false); }
#line 3590 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 7: /* simple_list1: statement  */
#line 428 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.make_statement_list ((yyvsp[0].tree_statement_type)); }
#line 3596 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 8: /* simple_list1: simple_list1 sep_no_nl statement  */
#line 430 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), (yyvsp[0].tree_statement_type), false); }
#line 3602 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 9: /* opt_list: %empty  */
#line 434 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = new octave::tree_statement_list (); }
#line 3608 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 10: /* opt_list: list  */
#line 436 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = (yyvsp[0].tree_statement_list_type); }
#line 3614 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 11: /* list: list1 opt_sep  */
#line 440 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.set_stmt_print_flag ((yyvsp[-1].tree_statement_list_type), (yyvsp[0].punct_type), true); }
#line 3620 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 12: /* list1: statement  */
#line 444 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.make_statement_list ((yyvsp[0].tree_statement_type)); }
#line 3626 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 13: /* list1: list1 sep statement  */
#line 446 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), (yyvsp[0].tree_statement_type), true); }
#line 3632 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 14: /* opt_fcn_list: %empty  */
#line 450 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = new octave::tree_statement_list (); }
#line 3638 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 15: /* opt_fcn_list: fcn_list  */
#line 452 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = (yyvsp[0].tree_statement_list_type); }
#line 3644 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 16: /* fcn_list: fcn_list1 opt_sep  */
#line 456 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_statement_list_type) = (yyvsp[-1].tree_statement_list_type);
                  }
#line 3654 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 17: /* fcn_list1: function  */
#line 464 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave::tree_statement *stmt = parser.make_statement ((yyvsp[0].tree_function_def_type));
                    (yyval.tree_statement_list_type) = new octave::tree_statement_list (stmt);
                  }
#line 3663 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 18: /* fcn_list1: fcn_list1 opt_sep function  */
#line 469 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave::tree_statement *stmt = parser.make_statement ((yyvsp[0].tree_function_def_type));
                    (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), stmt, false);
                  }
#line 3672 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 19: /* statement: expression  */
#line 476 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_expression_type)); }
#line 3678 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 20: /* statement: command  */
#line 478 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_command_type)); }
#line 3684 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 21: /* statement: word_list_cmd  */
#line 480 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_index_expression_type)); }
#line 3690 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 22: /* word_list_cmd: identifier word_list  */
#line 492 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_index_expression_type) = parser.make_index_expression ((yyvsp[-1].tree_identifier_type), (yyvsp[0].tree_argument_list_type), '(');
                    if (! (yyval.tree_index_expression_type))
                      {
                        // make_index_expression deleted $1 and $2.
                        YYABORT;
                      }
                    (yyval.tree_index_expression_type)->mark_word_list_cmd ();
                  }
#line 3704 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 23: /* word_list: string  */
#line 504 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_constant_type)); }
#line 3710 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 24: /* word_list: word_list string  */
#line 506 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_argument_list_type)->append ((yyvsp[0].tree_constant_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3719 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 25: /* identifier: NAME  */
#line 517 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_identifier_type) = new octave::tree_identifier ((yyvsp[0].tok_val)->sym_rec (),
                                                      (yyvsp[0].tok_val)->line (),
                                                      (yyvsp[0].tok_val)->column ());
                  }
#line 3729 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 26: /* superclass_identifier: SUPERCLASSREF  */
#line 526 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    std::string meth = (yyvsp[0].tok_val)->superclass_method_name ();
                    std::string cls = (yyvsp[0].tok_val)->superclass_class_name ();

                    (yyval.tree_superclass_ref_type) = new octave::tree_superclass_ref (meth, cls,
                                                          (yyvsp[0].tok_val)->line (),
                                                          (yyvsp[0].tok_val)->column ());
                  }
#line 3742 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 27: /* meta_identifier: METAQUERY  */
#line 537 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    std::string cls = (yyvsp[0].tok_val)->text ();

                    (yyval.tree_metaclass_query_type) = new octave::tree_metaclass_query (cls, (yyvsp[0].tok_val)->line (),
                                                           (yyvsp[0].tok_val)->column ());
                  }
#line 3753 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 28: /* string: DQ_STRING  */
#line 546 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (DQ_STRING, (yyvsp[0].tok_val)); }
#line 3759 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 29: /* string: SQ_STRING  */
#line 548 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (SQ_STRING, (yyvsp[0].tok_val)); }
#line 3765 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 30: /* constant: NUM  */
#line 552 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (NUM, (yyvsp[0].tok_val)); }
#line 3771 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 31: /* constant: IMAG_NUM  */
#line 554 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (IMAG_NUM, (yyvsp[0].tok_val)); }
#line 3777 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 32: /* constant: string  */
#line 556 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = (yyvsp[0].tree_constant_type); }
#line 3783 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 33: /* matrix: '[' matrix_rows ']'  */
#line 560 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.finish_matrix ((yyvsp[-1].tree_matrix_type), (yyvsp[-2].tok_val), (yyvsp[0].tok_val)); }
#line 3789 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 34: /* matrix_rows: cell_or_matrix_row  */
#line 564 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_matrix_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_matrix ((yyvsp[0].tree_argument_list_type)) : nullptr; }
#line 3795 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 35: /* matrix_rows: matrix_rows ';' cell_or_matrix_row  */
#line 566 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    if ((yyvsp[-2].tree_matrix_type))
                      {
                        if ((yyvsp[0].tree_argument_list_type))
                          (yyvsp[-2].tree_matrix_type)->append ((yyvsp[0].tree_argument_list_type));

                        (yyval.tree_matrix_type) = (yyvsp[-2].tree_matrix_type);
                      }
                    else
                      (yyval.tree_matrix_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_matrix ((yyvsp[0].tree_argument_list_type)) : nullptr;
                  }
#line 3813 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 36: /* cell: '{' cell_rows '}'  */
#line 582 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.finish_cell ((yyvsp[-1].tree_cell_type), (yyvsp[-2].tok_val), (yyvsp[0].tok_val)); }
#line 3819 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 37: /* cell_rows: cell_or_matrix_row  */
#line 586 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_cell_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_cell ((yyvsp[0].tree_argument_list_type)) : nullptr; }
#line 3825 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 38: /* cell_rows: cell_rows ';' cell_or_matrix_row  */
#line 588 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    if ((yyvsp[-2].tree_cell_type))
                      {
                        if ((yyvsp[0].tree_argument_list_type))
                          (yyvsp[-2].tree_cell_type)->append ((yyvsp[0].tree_argument_list_type));

                        (yyval.tree_cell_type) = (yyvsp[-2].tree_cell_type);
                      }
                    else
                      (yyval.tree_cell_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_cell ((yyvsp[0].tree_argument_list_type)) : nullptr;
                  }
#line 3843 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 39: /* cell_or_matrix_row: %empty  */
#line 612 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = nullptr; }
#line 3849 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 40: /* cell_or_matrix_row: ','  */
#line 614 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = nullptr;
                  }
#line 3859 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 41: /* cell_or_matrix_row: arg_list  */
#line 620 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = (yyvsp[0].tree_argument_list_type); }
#line 3865 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 42: /* cell_or_matrix_row: arg_list ','  */
#line 622 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3875 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 43: /* cell_or_matrix_row: ',' arg_list  */
#line 628 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[0].tree_argument_list_type);
                  }
#line 3885 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 44: /* cell_or_matrix_row: ',' arg_list ','  */
#line 634 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3896 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 45: /* fcn_handle: FCN_HANDLE  */
#line 643 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_fcn_handle_type) = parser.make_fcn_handle ((yyvsp[0].tok_val)); }
#line 3902 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 46: /* anon_fcn_handle: '@' param_list anon_fcn_begin expression  */
#line 651 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_anon_fcn_handle_type) = parser.make_anon_fcn_handle ((yyvsp[-2].tree_parameter_list_type), (yyvsp[0].tree_expression_type), (yyvsp[-3].tok_val)->beg_pos ());
                    if (! (yyval.tree_anon_fcn_handle_type))
                      {
                        // make_anon_fcn_handle deleted $2 and $4.
                        YYABORT;
                      }

                    lexer.m_parsing_anon_fcn_body = false;
                    lexer.m_nesting_level.remove ();
                  }
#line 3918 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 47: /* anon_fcn_handle: '@' param_list anon_fcn_begin error  */
#line 663 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].tree_parameter_list_type));

                    lexer.m_parsing_anon_fcn_body = false;

                    (yyval.tree_anon_fcn_handle_type) = nullptr;
                    parser.bison_error ("anonymous function bodies must be single expressions");
                    YYABORT;
                  }
#line 3933 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 48: /* primary_expr: identifier  */
#line 676 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_identifier_type); }
#line 3939 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 49: /* primary_expr: constant  */
#line 678 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_constant_type); }
#line 3945 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 50: /* primary_expr: fcn_handle  */
#line 680 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_fcn_handle_type); }
#line 3951 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 51: /* primary_expr: matrix  */
#line 682 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_looking_at_matrix_or_assign_lhs = false;
                    (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 3960 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 52: /* primary_expr: cell  */
#line 687 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 3966 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 53: /* primary_expr: meta_identifier  */
#line 689 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_metaclass_query_type); }
#line 3972 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 54: /* primary_expr: superclass_identifier  */
#line 691 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_superclass_ref_type); }
#line 3978 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 55: /* primary_expr: '(' expression ')'  */
#line 693 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = (yyvsp[-1].tree_expression_type)->mark_in_parens ();
                  }
#line 3989 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 56: /* magic_colon: ':'  */
#line 702 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    octave_value tmp (octave_value::magic_colon_t);
                    (yyval.tree_constant_type) = new octave::tree_constant (tmp);
                  }
#line 4000 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 57: /* magic_tilde: EXPR_NOT  */
#line 711 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_identifier_type) = new octave::tree_black_hole ();
                  }
#line 4010 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 58: /* arg_list: expression  */
#line 719 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_expression_type)); }
#line 4016 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 59: /* arg_list: magic_colon  */
#line 721 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_constant_type)); }
#line 4022 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 60: /* arg_list: magic_tilde  */
#line 723 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_identifier_type)); }
#line 4028 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 61: /* arg_list: arg_list ',' magic_colon  */
#line 725 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_constant_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 4039 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 62: /* arg_list: arg_list ',' magic_tilde  */
#line 732 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_identifier_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 4050 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 63: /* arg_list: arg_list ',' expression  */
#line 739 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_expression_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 4061 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 64: /* indirect_ref_op: '.'  */
#line 748 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_indirect_ref = true;
                  }
#line 4072 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 65: /* oper_expr: primary_expr  */
#line 757 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4078 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 66: /* oper_expr: oper_expr PLUS_PLUS  */
#line 759 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (PLUS_PLUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4084 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 67: /* oper_expr: oper_expr MINUS_MINUS  */
#line 761 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (MINUS_MINUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4090 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 68: /* oper_expr: oper_expr '(' ')'  */
#line 763 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4106 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 69: /* oper_expr: oper_expr '(' arg_list ')'  */
#line 775 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4122 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 70: /* oper_expr: oper_expr '{' '}'  */
#line 787 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4138 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 71: /* oper_expr: oper_expr '{' arg_list '}'  */
#line 799 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4154 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 72: /* oper_expr: oper_expr HERMITIAN  */
#line 811 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (HERMITIAN, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4160 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 73: /* oper_expr: oper_expr TRANSPOSE  */
#line 813 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (TRANSPOSE, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4166 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 74: /* oper_expr: oper_expr indirect_ref_op STRUCT_ELT  */
#line 815 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-2].tree_expression_type), (yyvsp[0].tok_val)->text ()); }
#line 4172 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 75: /* oper_expr: oper_expr indirect_ref_op '(' expression ')'  */
#line 817 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_expression_type));
                  }
#line 4183 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 76: /* oper_expr: PLUS_PLUS oper_expr  */
#line 824 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (PLUS_PLUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4189 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 77: /* oper_expr: MINUS_MINUS oper_expr  */
#line 826 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (MINUS_MINUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4195 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 78: /* oper_expr: EXPR_NOT oper_expr  */
#line 828 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (EXPR_NOT, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4201 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 79: /* oper_expr: '+' oper_expr  */
#line 830 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('+', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4207 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 80: /* oper_expr: '-' oper_expr  */
#line 832 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('-', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4213 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 81: /* oper_expr: oper_expr POW power_expr  */
#line 834 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (POW, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4219 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 82: /* oper_expr: oper_expr EPOW power_expr  */
#line 836 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EPOW, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4225 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 83: /* oper_expr: oper_expr '+' oper_expr  */
#line 838 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('+', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4231 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 84: /* oper_expr: oper_expr '-' oper_expr  */
#line 840 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('-', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4237 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 85: /* oper_expr: oper_expr '*' oper_expr  */
#line 842 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('*', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4243 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 86: /* oper_expr: oper_expr '/' oper_expr  */
#line 844 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('/', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4249 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 87: /* oper_expr: oper_expr EPLUS oper_expr  */
#line 846 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('+', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4255 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 88: /* oper_expr: oper_expr EMINUS oper_expr  */
#line 848 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('-', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4261 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 89: /* oper_expr: oper_expr EMUL oper_expr  */
#line 850 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EMUL, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4267 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 90: /* oper_expr: oper_expr EDIV oper_expr  */
#line 852 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4273 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 91: /* oper_expr: oper_expr LEFTDIV oper_expr  */
#line 854 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (LEFTDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4279 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 92: /* oper_expr: oper_expr ELEFTDIV oper_expr  */
#line 856 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (ELEFTDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4285 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 93: /* power_expr: primary_expr  */
#line 860 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4291 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 94: /* power_expr: power_expr PLUS_PLUS  */
#line 862 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (PLUS_PLUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4297 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 95: /* power_expr: power_expr MINUS_MINUS  */
#line 864 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (MINUS_MINUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4303 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 96: /* power_expr: power_expr '(' ')'  */
#line 866 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4319 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 97: /* power_expr: power_expr '(' arg_list ')'  */
#line 878 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4335 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 98: /* power_expr: power_expr '{' '}'  */
#line 890 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4351 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 99: /* power_expr: power_expr '{' arg_list '}'  */
#line 902 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4367 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 100: /* power_expr: power_expr indirect_ref_op STRUCT_ELT  */
#line 914 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-2].tree_expression_type), (yyvsp[0].tok_val)->text ()); }
#line 4373 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 101: /* power_expr: power_expr indirect_ref_op '(' expression ')'  */
#line 916 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_expression_type));
                  }
#line 4384 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 102: /* power_expr: PLUS_PLUS power_expr  */
#line 923 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (PLUS_PLUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4390 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 103: /* power_expr: MINUS_MINUS power_expr  */
#line 925 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (MINUS_MINUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4396 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 104: /* power_expr: EXPR_NOT power_expr  */
#line 927 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (EXPR_NOT, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4402 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 105: /* power_expr: '+' power_expr  */
#line 929 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('+', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4408 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 106: /* power_expr: '-' power_expr  */
#line 931 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('-', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4414 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 107: /* colon_expr: oper_expr ':' oper_expr  */
#line 935 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_expression_type) = parser.make_colon_expression ((yyvsp[-2].tree_expression_type), (yyvsp[0].tree_expression_type));

                    if (! (yyval.tree_expression_type))
                      {
                        // finish_colon_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4430 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 108: /* colon_expr: oper_expr ':' oper_expr ':' oper_expr  */
#line 947 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_expression_type) = parser.make_colon_expression ((yyvsp[-4].tree_expression_type), (yyvsp[0].tree_expression_type), (yyvsp[-2].tree_expression_type));

                    if (! (yyval.tree_expression_type))
                      {
                        // finish_colon_expression deleted $1, $3, and $5.
                        YYABORT;
                      }
                  }
#line 4447 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 109: /* simple_expr: oper_expr  */
#line 962 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4453 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 110: /* simple_expr: colon_expr  */
#line 964 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4459 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 111: /* simple_expr: simple_expr EXPR_LT simple_expr  */
#line 966 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_LT, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4465 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 112: /* simple_expr: simple_expr EXPR_LE simple_expr  */
#line 968 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_LE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4471 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 113: /* simple_expr: simple_expr EXPR_EQ simple_expr  */
#line 970 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_EQ, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4477 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 114: /* simple_expr: simple_expr EXPR_GE simple_expr  */
#line 972 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_GE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4483 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 115: /* simple_expr: simple_expr EXPR_GT simple_expr  */
#line 974 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_GT, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4489 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 116: /* simple_expr: simple_expr EXPR_NE simple_expr  */
#line 976 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_NE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4495 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 117: /* simple_expr: simple_expr EXPR_AND simple_expr  */
#line 978 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_AND, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4501 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 118: /* simple_expr: simple_expr EXPR_OR simple_expr  */
#line 980 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_OR, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4507 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 119: /* simple_expr: simple_expr EXPR_AND_AND simple_expr  */
#line 982 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_boolean_op (EXPR_AND_AND, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4513 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 120: /* simple_expr: simple_expr EXPR_OR_OR simple_expr  */
#line 984 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_boolean_op (EXPR_OR_OR, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4519 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 121: /* assign_lhs: simple_expr  */
#line 988 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_argument_list_type) = parser.validate_matrix_for_assignment ((yyvsp[0].tree_expression_type));

                    if ((yyval.tree_argument_list_type))
                      { lexer.m_looking_at_matrix_or_assign_lhs = false; }
                    else
                      {
                        // validate_matrix_for_assignment deleted $1.
                        YYABORT;
                      }
                  }
#line 4535 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 122: /* assign_expr: assign_lhs '=' expression  */
#line 1002 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op ('=', (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4541 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 123: /* assign_expr: assign_lhs ADD_EQ expression  */
#line 1004 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (ADD_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4547 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 124: /* assign_expr: assign_lhs SUB_EQ expression  */
#line 1006 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (SUB_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4553 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 125: /* assign_expr: assign_lhs MUL_EQ expression  */
#line 1008 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (MUL_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4559 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 126: /* assign_expr: assign_lhs DIV_EQ expression  */
#line 1010 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (DIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4565 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 127: /* assign_expr: assign_lhs LEFTDIV_EQ expression  */
#line 1012 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (LEFTDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4571 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 128: /* assign_expr: assign_lhs POW_EQ expression  */
#line 1014 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (POW_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4577 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 129: /* assign_expr: assign_lhs EMUL_EQ expression  */
#line 1016 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EMUL_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4583 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 130: /* assign_expr: assign_lhs EDIV_EQ expression  */
#line 1018 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4589 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 131: /* assign_expr: assign_lhs ELEFTDIV_EQ expression  */
#line 1020 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (ELEFTDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4595 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 132: /* assign_expr: assign_lhs EPOW_EQ expression  */
#line 1022 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EPOW_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4601 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 133: /* assign_expr: assign_lhs AND_EQ expression  */
#line 1024 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (AND_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4607 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 134: /* assign_expr: assign_lhs OR_EQ expression  */
#line 1026 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (OR_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4613 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 135: /* expression: simple_expr  */
#line 1030 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if ((yyvsp[0].tree_expression_type) && ((yyvsp[0].tree_expression_type)->is_matrix () || (yyvsp[0].tree_expression_type)->iscell ()))
                      {
                        if (parser.validate_array_list ((yyvsp[0].tree_expression_type)))
                          (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                        else
                          {
                            delete (yyvsp[0].tree_expression_type);
                            YYABORT;
                          }
                      }
                    else
                      (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 4632 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 136: /* expression: assign_expr  */
#line 1045 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! (yyvsp[0].tree_expression_type))
                      YYABORT;

                    (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 4643 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 137: /* expression: anon_fcn_handle  */
#line 1052 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_anon_fcn_handle_type); }
#line 4649 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 138: /* command: declaration  */
#line 1060 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_decl_command_type); }
#line 4655 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 139: /* command: select_command  */
#line 1062 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4661 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 140: /* command: loop_command  */
#line 1064 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4667 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 141: /* command: jump_command  */
#line 1066 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4673 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 142: /* command: except_command  */
#line 1068 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4679 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 143: /* command: function  */
#line 1070 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_function_def_type); }
#line 4685 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 144: /* command: file  */
#line 1072 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4691 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 145: /* declaration: GLOBAL decl1  */
#line 1080 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_decl_command_type) = parser.make_decl_command (GLOBAL, (yyvsp[-1].tok_val), (yyvsp[0].tree_decl_init_list_type));
                    lexer.m_looking_at_decl_list = false;
                  }
#line 4700 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 146: /* declaration: PERSISTENT decl1  */
#line 1085 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_decl_command_type) = parser.make_decl_command (PERSISTENT, (yyvsp[-1].tok_val), (yyvsp[0].tree_decl_init_list_type));
                    lexer.m_looking_at_decl_list = false;
                  }
#line 4709 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 147: /* decl1: decl2  */
#line 1092 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_init_list_type) = new octave::tree_decl_init_list ((yyvsp[0].tree_decl_elt_type)); }
#line 4715 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 148: /* decl1: decl1 decl2  */
#line 1094 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_decl_init_list_type)->append ((yyvsp[0].tree_decl_elt_type));
                    (yyval.tree_decl_init_list_type) = (yyvsp[-1].tree_decl_init_list_type);
                  }
#line 4724 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 149: /* decl_param_init: %empty  */
#line 1101 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_initializer_expression = true;
                  }
#line 4733 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 150: /* decl2: identifier  */
#line 1107 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)); }
#line 4739 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 151: /* decl2: identifier '=' decl_param_init expression  */
#line 1109 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 4750 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 152: /* select_command: if_command  */
#line 1122 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_if_command_type); }
#line 4756 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 153: /* select_command: switch_command  */
#line 1124 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_switch_command_type); }
#line 4762 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 154: /* if_command: IF stash_comment if_cmd_list END  */
#line 1132 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_if_command_type) = parser.finish_if_command ((yyvsp[-3].tok_val), (yyvsp[-1].tree_if_command_list_type), (yyvsp[0].tok_val), (yyvsp[-2].comment_type))))
                      {
                        // finish_if_command deleted $3.
                        YYABORT;
                      }
                  }
#line 4774 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 155: /* if_cmd_list: if_cmd_list1  */
#line 1142 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_if_command_list_type) = (yyvsp[0].tree_if_command_list_type); }
#line 4780 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 156: /* if_cmd_list: if_cmd_list1 else_clause  */
#line 1144 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_if_command_list_type)->append ((yyvsp[0].tree_if_clause_type));
                    (yyval.tree_if_command_list_type) = (yyvsp[-1].tree_if_command_list_type);
                  }
#line 4789 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 157: /* if_cmd_list1: expression stmt_begin opt_sep opt_list  */
#line 1151 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-3].tree_expression_type)->mark_braindead_shortcircuit ();

                    (yyval.tree_if_command_list_type) = parser.start_if_command ((yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type));
                  }
#line 4801 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 158: /* if_cmd_list1: if_cmd_list1 elseif_clause  */
#line 1159 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_if_command_list_type)->append ((yyvsp[0].tree_if_clause_type));
                    (yyval.tree_if_command_list_type) = (yyvsp[-1].tree_if_command_list_type);
                  }
#line 4810 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 159: /* elseif_clause: ELSEIF stash_comment opt_sep expression stmt_begin opt_sep opt_list  */
#line 1166 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-4].punct_type));
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-3].tree_expression_type)->mark_braindead_shortcircuit ();

                    (yyval.tree_if_clause_type) = parser.make_elseif_clause ((yyvsp[-6].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type), (yyvsp[-5].comment_type));
                  }
#line 4823 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 160: /* else_clause: ELSE stash_comment opt_sep opt_list  */
#line 1177 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_if_clause_type) = new octave::tree_if_clause ((yyvsp[0].tree_statement_list_type), (yyvsp[-2].comment_type));
                  }
#line 4834 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 161: /* switch_command: SWITCH stash_comment expression opt_sep case_list END  */
#line 1190 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_switch_command_type) = parser.finish_switch_command ((yyvsp[-5].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_switch_case_list_type), (yyvsp[0].tok_val), (yyvsp[-4].comment_type))))
                      {
                        // finish_switch_command deleted $3 adn $5.
                        YYABORT;
                      }
                  }
#line 4848 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 162: /* case_list: %empty  */
#line 1202 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list (); }
#line 4854 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 163: /* case_list: default_case  */
#line 1204 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list ((yyvsp[0].tree_switch_case_type)); }
#line 4860 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 164: /* case_list: case_list1  */
#line 1206 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = (yyvsp[0].tree_switch_case_list_type); }
#line 4866 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 165: /* case_list: case_list1 default_case  */
#line 1208 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_switch_case_list_type)->append ((yyvsp[0].tree_switch_case_type));
                    (yyval.tree_switch_case_list_type) = (yyvsp[-1].tree_switch_case_list_type);
                  }
#line 4875 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 166: /* case_list1: switch_case  */
#line 1215 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list ((yyvsp[0].tree_switch_case_type)); }
#line 4881 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 167: /* case_list1: case_list1 switch_case  */
#line 1217 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_switch_case_list_type)->append ((yyvsp[0].tree_switch_case_type));
                    (yyval.tree_switch_case_list_type) = (yyvsp[-1].tree_switch_case_list_type);
                  }
#line 4890 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 168: /* switch_case: CASE stash_comment opt_sep expression stmt_begin opt_sep opt_list  */
#line 1224 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-4].punct_type));
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_switch_case_type) = parser.make_switch_case ((yyvsp[-6].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type), (yyvsp[-5].comment_type));
                  }
#line 4901 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 169: /* default_case: OTHERWISE stash_comment opt_sep opt_list  */
#line 1233 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_switch_case_type) = new octave::tree_switch_case ((yyvsp[0].tree_statement_list_type), (yyvsp[-2].comment_type));
                  }
#line 4912 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 170: /* loop_command: WHILE stash_comment expression stmt_begin opt_sep opt_list END  */
#line 1246 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    (yyvsp[-4].tree_expression_type)->mark_braindead_shortcircuit ();

                    if (! ((yyval.tree_command_type) = parser.make_while_command ((yyvsp[-6].tok_val), (yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_while_command deleted $3 and $6.
                        YYABORT;
                      }
                  }
#line 4928 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 171: /* loop_command: DO stash_comment opt_sep opt_list UNTIL expression  */
#line 1258 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-5].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-3].punct_type));

                    (yyval.tree_command_type) = parser.make_do_until_command ((yyvsp[-1].tok_val), (yyvsp[-2].tree_statement_list_type), (yyvsp[0].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 4939 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 172: /* loop_command: FOR stash_comment assign_lhs '=' expression stmt_begin opt_sep opt_list END  */
#line 1265 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-5].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (FOR, (yyvsp[-8].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_for_command deleted $3, $5, and $8.
                        YYABORT;
                      }
                  }
#line 4955 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 173: /* loop_command: FOR stash_comment '(' assign_lhs '=' expression ')' opt_sep opt_list END  */
#line 1277 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-7].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-5].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (FOR, (yyvsp[-9].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-8].comment_type))))
                      {
                        // make_for_command deleted $4, $6, and $9.
                        YYABORT;
                      }
                  }
#line 4973 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 174: /* loop_command: PARFOR stash_comment assign_lhs '=' expression stmt_begin opt_sep opt_list END  */
#line 1291 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-5].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (PARFOR, (yyvsp[-8].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_for_command deleted $3, $5, and $8.
                        YYABORT;
                      }
                  }
#line 4989 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 175: /* loop_command: PARFOR stash_comment '(' assign_lhs '=' expression ',' expression ')' opt_sep opt_list END  */
#line 1303 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-9].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-7].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-5].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (PARFOR, (yyvsp[-11].tok_val), (yyvsp[-8].tree_argument_list_type), (yyvsp[-6].tree_expression_type),
                                                         (yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-10].comment_type))))
                      {
                        // make_for_command deleted $4, $6, $8, and $11.
                        YYABORT;
                      }
                  }
#line 5008 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 176: /* jump_command: BREAK  */
#line 1324 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_command_type) = parser.make_break_command ((yyvsp[0].tok_val))))
                      YYABORT;
                  }
#line 5017 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 177: /* jump_command: CONTINUE  */
#line 1329 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_command_type) = parser.make_continue_command ((yyvsp[0].tok_val))))
                      YYABORT;
                  }
#line 5026 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 178: /* jump_command: FUNC_RET  */
#line 1334 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = parser.make_return_command ((yyvsp[0].tok_val)); }
#line 5032 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 179: /* except_command: UNWIND stash_comment opt_sep opt_list CLEANUP stash_comment opt_sep opt_list END  */
#line 1343 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-6].punct_type));
                    OCTAVE_YYUSE ((yyvsp[-4].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_unwind_command ((yyvsp[-8].tok_val), (yyvsp[-5].tree_statement_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type), (yyvsp[-3].comment_type))))
                      {
                        // make_unwind_command deleted $4 and $8.
                        YYABORT;
                      }
                  }
#line 5048 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 180: /* except_command: TRY stash_comment opt_sep opt_list CATCH stash_comment opt_sep opt_list END  */
#line 1356 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-6].punct_type));
                    OCTAVE_YYUSE ((yyvsp[-4].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_try_command ((yyvsp[-8].tok_val), (yyvsp[-5].tree_statement_list_type), (yyvsp[-2].punct_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type), (yyvsp[-3].comment_type))))
                      {
                        // make_try_command deleted $4 and $8.
                        YYABORT;
                      }
                  }
#line 5064 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 181: /* except_command: TRY stash_comment opt_sep opt_list END  */
#line 1368 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_try_command ((yyvsp[-4].tok_val), (yyvsp[-1].tree_statement_list_type), 0, nullptr,
                                                         (yyvsp[0].tok_val), (yyvsp[-3].comment_type), nullptr)))
                      {
                        // make_try_command deleted $4.
                        YYABORT;
                      }
                  }
#line 5079 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 182: /* push_fcn_symtab: %empty  */
#line 1385 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! parser.push_fcn_symtab ())
                      YYABORT;

                    (yyval.dummy_type) = 0;
                  }
#line 5090 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 183: /* param_list_beg: '('  */
#line 1398 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_parameter_list = true;

                    if (lexer.m_looking_at_function_handle)
                      {
                        // Will get a real name later.
                        lexer.m_symtab_context.push (octave::symbol_scope ("parser:param_lsit_beg"));
                        lexer.m_looking_at_function_handle--;
                        lexer.m_looking_at_anon_fcn_args = true;
                      }
                  }
#line 5109 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 184: /* param_list_end: ')'  */
#line 1415 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_parameter_list = false;
                    lexer.m_looking_for_object_index = false;
                  }
#line 5121 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 185: /* opt_param_list: %empty  */
#line 1425 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = nullptr; }
#line 5127 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 186: /* opt_param_list: param_list  */
#line 1427 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = (yyvsp[0].tree_parameter_list_type); }
#line 5133 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 187: /* param_list: param_list_beg param_list1 param_list_end  */
#line 1431 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if ((yyvsp[-1].tree_parameter_list_type))
                      lexer.mark_as_variables ((yyvsp[-1].tree_parameter_list_type)->variable_names ());

                    (yyval.tree_parameter_list_type) = (yyvsp[-1].tree_parameter_list_type);
                  }
#line 5144 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 188: /* param_list: param_list_beg error  */
#line 1438 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_parameter_list_type) = nullptr;
                    parser.bison_error ("invalid parameter list");
                    YYABORT;
                  }
#line 5154 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 189: /* param_list1: %empty  */
#line 1446 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::in); }
#line 5160 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 190: /* param_list1: param_list2  */
#line 1448 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[0].tree_parameter_list_type)->mark_as_formal_parameters ();

                    if (parser.validate_param_list ((yyvsp[0].tree_parameter_list_type), octave::tree_parameter_list::in))
                      {
                        lexer.mark_as_variables ((yyvsp[0].tree_parameter_list_type)->variable_names ());
                        (yyval.tree_parameter_list_type) = (yyvsp[0].tree_parameter_list_type);
                      }
                    else
                      {
                        delete (yyvsp[0].tree_parameter_list_type);
                        YYABORT;
                      }
                  }
#line 5179 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 191: /* param_list2: param_list_elt  */
#line 1465 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::in, (yyvsp[0].tree_decl_elt_type)); }
#line 5185 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 192: /* param_list2: param_list2 ',' param_list_elt  */
#line 1467 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_parameter_list_type)->append ((yyvsp[0].tree_decl_elt_type));
                    (yyval.tree_parameter_list_type) = (yyvsp[-2].tree_parameter_list_type);
                  }
#line 5196 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 193: /* param_list_elt: decl2  */
#line 1476 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = (yyvsp[0].tree_decl_elt_type); }
#line 5202 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 194: /* param_list_elt: magic_tilde  */
#line 1478 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)); }
#line 5208 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 195: /* return_list: '[' ']'  */
#line 1486 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    lexer.m_looking_at_return_list = false;

                    (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::out);
                  }
#line 5221 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 196: /* return_list: identifier  */
#line 1495 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_looking_at_return_list = false;

                    octave::tree_parameter_list *tmp
                      = new octave::tree_parameter_list (octave::tree_parameter_list::out, (yyvsp[0].tree_identifier_type));

                    // Even though this parameter list can contain only
                    // a single identifier, we still need to validate it
                    // to check for varargin or varargout.

                    if (parser.validate_param_list (tmp, octave::tree_parameter_list::out))
                      (yyval.tree_parameter_list_type) = tmp;
                    else
                      {
                        delete tmp;
                        YYABORT;
                      }
                  }
#line 5244 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 197: /* return_list: '[' return_list1 ']'  */
#line 1514 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    lexer.m_looking_at_return_list = false;

                    // Check for duplicate parameter names, varargin,
                    // or varargout.

                    if (parser.validate_param_list ((yyvsp[-1].tree_parameter_list_type), octave::tree_parameter_list::out))
                      (yyval.tree_parameter_list_type) = (yyvsp[-1].tree_parameter_list_type);
                    else
                      {
                        delete (yyvsp[-1].tree_parameter_list_type);
                        YYABORT;
                      }
                  }
#line 5266 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 198: /* return_list1: identifier  */
#line 1534 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::out, new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)));
                  }
#line 5274 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 199: /* return_list1: return_list1 ',' identifier  */
#line 1538 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_parameter_list_type)->append (new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)));
                    (yyval.tree_parameter_list_type) = (yyvsp[-2].tree_parameter_list_type);
                  }
#line 5285 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 200: /* parsing_local_fcns: %empty  */
#line 1552 "../libinterp/parse-tree/oct-parse.yy"
                  { parser.parsing_local_functions (true); }
#line 5291 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 201: /* push_script_symtab: %empty  */
#line 1556 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;

                    // This scope may serve as the parent scope for local
                    // functions in classdef files..
                    lexer.m_symtab_context.push (octave::symbol_scope ("parser:push_script_symtab"));
                  }
#line 5303 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 202: /* begin_file: push_script_symtab INPUT_FILE  */
#line 1566 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.dummy_type) = 0; }
#line 5309 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 203: /* file: begin_file opt_nl opt_list END_OF_INPUT  */
#line 1570 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    if (lexer.m_reading_fcn_file)
                      {
                        // Delete the dummy statement_list we created
                        // after parsing the function.  Any function
                        // definitions found in the file have already
                        // been stored in the symbol table or in
                        // base_parser::m_primary_fcn.

                        // Unused symbol table context.
                        lexer.m_symtab_context.pop ();

                        delete (yyvsp[-1].tree_statement_list_type);
                      }
                    else
                      {
                        octave::tree_statement *end_of_script
                          = parser.make_end ("endscript", true,
                                             (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());

                        parser.make_script ((yyvsp[-1].tree_statement_list_type), end_of_script);
                      }

                    (yyval.tree_command_type) = nullptr;
                  }
#line 5341 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 204: /* file: begin_file opt_nl classdef parsing_local_fcns opt_sep opt_fcn_list END_OF_INPUT  */
#line 1598 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-5].punct_type));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    // Unused symbol table context.
                    lexer.m_symtab_context.pop ();

                    parser.finish_classdef_file ((yyvsp[-4].tree_classdef_type), (yyvsp[-1].tree_statement_list_type));

                    (yyval.tree_command_type) = nullptr;
                  }
#line 5358 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 205: /* function_beg: push_fcn_symtab FCN  */
#line 1617 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tok_val) = (yyvsp[0].tok_val);
                    if (lexer.m_reading_classdef_file
                        || lexer.m_parsing_classdef)
                      lexer.m_maybe_classdef_get_set_method = true;
                  }
#line 5369 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 206: /* fcn_name: identifier  */
#line 1626 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_identifier_type) = parser.make_fcn_name ((yyvsp[0].tree_identifier_type));
                    if (! (yyval.tree_identifier_type))
                      {
                        // make_fcn_name deleted $1.
                        YYABORT;
                      }
                  }
#line 5382 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 207: /* fcn_name: GET '.' identifier  */
#line 1635 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    lexer.m_parsed_function_name.top () = true;
                    lexer.m_maybe_classdef_get_set_method = false;
                    lexer.m_parsing_classdef_get_method = true;
                    (yyval.tree_identifier_type) = (yyvsp[0].tree_identifier_type);
                  }
#line 5396 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 208: /* fcn_name: SET '.' identifier  */
#line 1645 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    lexer.m_parsed_function_name.top () = true;
                    lexer.m_maybe_classdef_get_set_method = false;
                    lexer.m_parsing_classdef_set_method = true;
                    (yyval.tree_identifier_type) = (yyvsp[0].tree_identifier_type);
                  }
#line 5410 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 209: /* function_end: END  */
#line 1657 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    parser.endfunction_found (true);

                    if (parser.end_token_ok ((yyvsp[0].tok_val), octave::token::function_end))
                      (yyval.tree_statement_type) = parser.make_end ("endfunction", false,
                                            (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());
                    else
                      {
                        parser.end_token_error ((yyvsp[0].tok_val), octave::token::function_end);
                        YYABORT;
                      }
                  }
#line 5427 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 210: /* function_end: END_OF_INPUT  */
#line 1670 "../libinterp/parse-tree/oct-parse.yy"
                  {
// A lot of tests are based on the assumption that this is OK
//                  if (lexer.m_reading_script_file)
//                    {
//                      parser.bison_error ("function body open at end of script");
//                      YYABORT;
//                    }

                    if (parser.endfunction_found ())
                      {
                        parser.bison_error ("inconsistent function endings -- "
                                 "if one function is explicitly ended, "
                                 "so must all the others");
                        YYABORT;
                      }

                    if (! (lexer.m_reading_fcn_file || lexer.m_reading_script_file
                           || lexer.input_from_eval_string ()))
                      {
                        parser.bison_error ("function body open at end of input");
                        YYABORT;
                      }

                    if (lexer.m_reading_classdef_file)
                      {
                        parser.bison_error ("classdef body open at end of input");
                        YYABORT;
                      }

                    (yyval.tree_statement_type) = parser.make_end ("endfunction", true,
                                          (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());
                  }
#line 5464 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 211: /* function: function_beg stash_comment fcn_name opt_param_list opt_sep opt_list function_end  */
#line 1706 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    (yyval.tree_function_def_type) = parser.make_function ((yyvsp[-6].tok_val), nullptr, (yyvsp[-4].tree_identifier_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tree_statement_type), (yyvsp[-5].comment_type));
                  }
#line 5474 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 212: /* function: function_beg stash_comment return_list '=' fcn_name opt_param_list opt_sep opt_list function_end  */
#line 1713 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-5].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-2].punct_type));

                    (yyval.tree_function_def_type) = parser.make_function ((yyvsp[-8].tok_val), (yyvsp[-6].tree_parameter_list_type), (yyvsp[-4].tree_identifier_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tree_statement_type), (yyvsp[-7].comment_type));
                  }
#line 5485 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 213: /* classdef_beg: CLASSDEF  */
#line 1726 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! lexer.m_reading_classdef_file)
                      {
                        parser.bison_error ("classdef must appear inside a file containing only a class definition");
                        YYABORT;
                      }

                    // Create invalid parent scope.
                    lexer.m_symtab_context.push (octave::symbol_scope ());
                    lexer.m_parsing_classdef = true;
                    lexer.m_parsing_classdef_decl = true;

                    (yyval.tok_val) = (yyvsp[0].tok_val);
                  }
#line 5504 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 214: /* classdef: classdef_beg stash_comment attr_list identifier opt_sep superclass_list class_body END  */
#line 1743 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-6].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    lexer.m_parsing_classdef = false;

                    if (! ((yyval.tree_classdef_type) = parser.make_classdef ((yyvsp[-7].tok_val), (yyvsp[-5].tree_classdef_attribute_list_type), (yyvsp[-4].tree_identifier_type), (yyvsp[-2].tree_classdef_superclass_list_type), (yyvsp[-1].tree_classdef_body_type), (yyvsp[0].tok_val),
                                                      lc, tc)))
                      {
                        // make_classdef deleted $3, $4, $6, $7, LC, and
                        // TC.
                        YYABORT;
                      }
                  }
#line 5525 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 215: /* attr_list: %empty  */
#line 1762 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_list_type) = nullptr; }
#line 5531 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 216: /* attr_list: '(' attr_list1 ')' opt_sep  */
#line 1764 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].tok_val));
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_attribute_list_type) = (yyvsp[-2].tree_classdef_attribute_list_type);
                  }
#line 5543 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 217: /* attr_list1: attr  */
#line 1774 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_list_type) = new octave::tree_classdef_attribute_list ((yyvsp[0].tree_classdef_attribute_type)); }
#line 5549 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 218: /* attr_list1: attr_list1 ',' attr  */
#line 1776 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_classdef_attribute_list_type)->append ((yyvsp[0].tree_classdef_attribute_type));
                    (yyval.tree_classdef_attribute_list_type) = (yyvsp[-2].tree_classdef_attribute_list_type);
                  }
#line 5560 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 219: /* attr: identifier  */
#line 1785 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[0].tree_identifier_type)); }
#line 5566 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 220: /* attr: identifier '=' decl_param_init expression  */
#line 1787 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 5577 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 221: /* attr: EXPR_NOT identifier  */
#line 1794 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[0].tree_identifier_type), false);
                  }
#line 5587 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 222: /* superclass_list: %empty  */
#line 1802 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_parsing_classdef_decl = false;
                    lexer.m_parsing_classdef_superclass = false;

                    (yyval.tree_classdef_superclass_list_type) = nullptr;
                  }
#line 5598 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 223: /* superclass_list: superclass_list1 opt_sep  */
#line 1809 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    lexer.m_parsing_classdef_decl = false;
                    lexer.m_parsing_classdef_superclass = false;

                    (yyval.tree_classdef_superclass_list_type) = (yyvsp[-1].tree_classdef_superclass_list_type);
                  }
#line 5611 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 224: /* superclass_list1: EXPR_LT superclass  */
#line 1821 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_classdef_superclass_list_type) = new octave::tree_classdef_superclass_list ((yyvsp[0].tree_classdef_superclass_type));
                  }
#line 5621 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 225: /* superclass_list1: superclass_list1 EXPR_AND superclass  */
#line 1827 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_classdef_superclass_list_type)->append ((yyvsp[0].tree_classdef_superclass_type));
                    (yyval.tree_classdef_superclass_list_type) = (yyvsp[-2].tree_classdef_superclass_list_type);
                  }
#line 5632 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 226: /* superclass: FQ_IDENT  */
#line 1836 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_superclass_type) = new octave::tree_classdef_superclass ((yyvsp[0].tok_val)->text ()); }
#line 5638 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 227: /* class_body: %empty  */
#line 1840 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = nullptr; }
#line 5644 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 228: /* class_body: class_body1 opt_sep  */
#line 1842 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_body_type) = (yyvsp[-1].tree_classdef_body_type);
                  }
#line 5654 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 229: /* class_body1: properties_block  */
#line 1850 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_properties_block_type)); }
#line 5660 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 230: /* class_body1: methods_block  */
#line 1852 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_methods_block_type)); }
#line 5666 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 231: /* class_body1: events_block  */
#line 1854 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_events_block_type)); }
#line 5672 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 232: /* class_body1: enum_block  */
#line 1856 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_enum_block_type)); }
#line 5678 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 233: /* class_body1: class_body1 opt_sep properties_block  */
#line 1858 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_properties_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5689 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 234: /* class_body1: class_body1 opt_sep methods_block  */
#line 1865 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_methods_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5700 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 235: /* class_body1: class_body1 opt_sep events_block  */
#line 1872 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_events_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5711 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 236: /* class_body1: class_body1 opt_sep enum_block  */
#line 1879 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_enum_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5722 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 237: /* properties_block: PROPERTIES stash_comment opt_sep attr_list property_list END  */
#line 1889 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_properties_block_type) = parser.make_classdef_properties_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_property_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_properties_block deleted $4,
                        // $5, LC, and TC.
                        YYABORT;
                      }
                  }
#line 5741 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 238: /* property_list: %empty  */
#line 1906 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_property_list_type) = nullptr; }
#line 5747 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 239: /* property_list: property_list1 opt_sep  */
#line 1908 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_property_list_type) = (yyvsp[-1].tree_classdef_property_list_type);
                  }
#line 5757 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 240: /* property_list1: class_property  */
#line 1917 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_property_list_type) = new octave::tree_classdef_property_list ((yyvsp[0].tree_classdef_property_type)); }
#line 5763 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 241: /* property_list1: property_list1 sep class_property  */
#line 1919 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    // We don't look ahead to grab end-of-line comments.
                    // Instead, they are grabbed when we see the
                    // identifier that becomes the next element in the
                    // list.  If the element at the end of the list
                    // doesn't have a doc string, see whether the
                    // element we are adding is stroing an end-of-line
                    // comment for us to use.

                    octave::tree_classdef_property *last_elt = (yyvsp[-2].tree_classdef_property_list_type)->back ();

                    if (! last_elt->have_doc_string ())
                      {
                        octave::comment_list *cl = (yyvsp[0].tree_classdef_property_type)->comments ();

                        if (cl)
                          {
                            octave::comment_elt elt = cl->front ();

                            if (elt.is_end_of_line ())
                              last_elt->doc_string (elt.text ());
                          }
                      }

                    (yyvsp[-2].tree_classdef_property_list_type)->append ((yyvsp[0].tree_classdef_property_type));
                    (yyval.tree_classdef_property_list_type) = (yyvsp[-2].tree_classdef_property_list_type);
                  }
#line 5797 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 242: /* class_property: stash_comment identifier  */
#line 1951 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_classdef_property_type) = new octave::tree_classdef_property ((yyvsp[0].tree_identifier_type), (yyvsp[-1].comment_type));
                  }
#line 5805 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 243: /* class_property: stash_comment identifier '=' decl_param_init expression  */
#line 1955 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;

                    (yyval.tree_classdef_property_type) = new octave::tree_classdef_property ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 5817 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 244: /* methods_block: METHODS stash_comment opt_sep attr_list methods_list END  */
#line 1965 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_methods_block_type) = parser.make_classdef_methods_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_methods_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_methods_block deleted $4, $5,
                        // LC, and TC.
                        YYABORT;
                      }
                  }
#line 5836 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 245: /* method_decl1: identifier  */
#line 1982 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.octave_user_function_type) = parser.start_classdef_external_method ((yyvsp[0].tree_identifier_type), nullptr)))
                      YYABORT;
                  }
#line 5845 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 246: /* method_decl1: identifier param_list  */
#line 1987 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.octave_user_function_type) = parser.start_classdef_external_method ((yyvsp[-1].tree_identifier_type), (yyvsp[0].tree_parameter_list_type))))
                      YYABORT;
                  }
#line 5854 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 247: /* method_decl: stash_comment method_decl1  */
#line 1994 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = parser.finish_classdef_external_method ((yyvsp[0].octave_user_function_type), nullptr, (yyvsp[-1].comment_type)); }
#line 5860 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 248: /* $@1: %empty  */
#line 1996 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    lexer.m_defining_func++;
                    lexer.m_parsed_function_name.push (false);
                  }
#line 5871 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 249: /* method_decl: stash_comment return_list '=' $@1 method_decl1  */
#line 2003 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_defining_func--;
                    lexer.m_parsed_function_name.pop ();

                    (yyval.tree_function_def_type) = parser.finish_classdef_external_method ((yyvsp[0].octave_user_function_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-4].comment_type));
                  }
#line 5882 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 250: /* method: method_decl  */
#line 2012 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = (yyvsp[0].tree_function_def_type); }
#line 5888 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 251: /* method: function  */
#line 2014 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = (yyvsp[0].tree_function_def_type); }
#line 5894 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 252: /* methods_list: %empty  */
#line 2018 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_methods_list_type) = nullptr; }
#line 5900 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 253: /* methods_list: methods_list1 opt_sep  */
#line 2020 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_methods_list_type) = (yyvsp[-1].tree_classdef_methods_list_type);
                  }
#line 5910 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 254: /* methods_list1: method  */
#line 2028 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave_value fcn;
                    if ((yyvsp[0].tree_function_def_type))
                      fcn = (yyvsp[0].tree_function_def_type)->function ();
                    delete (yyvsp[0].tree_function_def_type);
                    (yyval.tree_classdef_methods_list_type) = new octave::tree_classdef_methods_list (fcn);
                  }
#line 5922 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 255: /* methods_list1: methods_list1 opt_sep method  */
#line 2036 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    octave_value fcn;
                    if ((yyvsp[0].tree_function_def_type))
                      fcn = (yyvsp[0].tree_function_def_type)->function ();
                    delete (yyvsp[0].tree_function_def_type);

                    (yyvsp[-2].tree_classdef_methods_list_type)->append (fcn);
                    (yyval.tree_classdef_methods_list_type) = (yyvsp[-2].tree_classdef_methods_list_type);
                  }
#line 5938 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 256: /* events_block: EVENTS stash_comment opt_sep attr_list events_list END  */
#line 2050 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_events_block_type) = parser.make_classdef_events_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_events_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_events_block deleted $4, $5,
                        // LC, and TC.
                        YYABORT;
                      }
                  }
#line 5957 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 257: /* events_list: %empty  */
#line 2067 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_events_list_type) = nullptr; }
#line 5963 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 258: /* events_list: events_list1 opt_sep  */
#line 2069 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_events_list_type) = (yyvsp[-1].tree_classdef_events_list_type);
                  }
#line 5973 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 259: /* events_list1: class_event  */
#line 2077 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_events_list_type) = new octave::tree_classdef_events_list ((yyvsp[0].tree_classdef_event_type)); }
#line 5979 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 260: /* events_list1: events_list1 opt_sep class_event  */
#line 2079 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_events_list_type)->append ((yyvsp[0].tree_classdef_event_type));
                    (yyval.tree_classdef_events_list_type) = (yyvsp[-2].tree_classdef_events_list_type);
                  }
#line 5990 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 261: /* class_event: stash_comment identifier  */
#line 2088 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_event_type) = new octave::tree_classdef_event ((yyvsp[0].tree_identifier_type), (yyvsp[-1].comment_type)); }
#line 5996 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 262: /* enum_block: ENUMERATION stash_comment opt_sep attr_list enum_list END  */
#line 2092 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_enum_block_type) = parser.make_classdef_enum_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_enum_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_enum_block deleted $4, $5, LC,
                        // and TC.
                        YYABORT;
                      }
                  }
#line 6015 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 263: /* enum_list: %empty  */
#line 2109 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_enum_list_type) = nullptr; }
#line 6021 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 264: /* enum_list: enum_list1 opt_sep  */
#line 2111 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_enum_list_type) = (yyvsp[-1].tree_classdef_enum_list_type);
                  }
#line 6031 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 265: /* enum_list1: class_enum  */
#line 2119 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_enum_list_type) = new octave::tree_classdef_enum_list ((yyvsp[0].tree_classdef_enum_type)); }
#line 6037 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 266: /* enum_list1: enum_list1 opt_sep class_enum  */
#line 2121 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_enum_list_type)->append ((yyvsp[0].tree_classdef_enum_type));
                    (yyval.tree_classdef_enum_list_type) = (yyvsp[-2].tree_classdef_enum_list_type);
                  }
#line 6048 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 267: /* class_enum: stash_comment identifier '(' expression ')'  */
#line 2130 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[-2].tok_val));
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_classdef_enum_type) = new octave::tree_classdef_enum ((yyvsp[-3].tree_identifier_type), (yyvsp[-1].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 6059 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 268: /* stmt_begin: %empty  */
#line 2143 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_at_beginning_of_statement = true;
                  }
#line 6068 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 269: /* anon_fcn_begin: %empty  */
#line 2150 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_at_beginning_of_statement = true;
                    lexer.m_parsing_anon_fcn_body = true;
                  }
#line 6078 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 270: /* stash_comment: %empty  */
#line 2158 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.comment_type) = lexer.get_comment (); }
#line 6084 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 271: /* parse_error: LEXICAL_ERROR  */
#line 2162 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    std::string msg = (yyvsp[0].tok_val)->text ();
                    parser.bison_error (msg.c_str ());
                  }
#line 6094 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 272: /* parse_error: error  */
#line 2168 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.dummy_type) = 0; }
#line 6100 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 273: /* sep_no_nl: ','  */
#line 2172 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ',';
                  }
#line 6110 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 274: /* sep_no_nl: ';'  */
#line 2178 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ';';
                  }
#line 6120 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 275: /* sep_no_nl: sep_no_nl ','  */
#line 2184 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6130 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 276: /* sep_no_nl: sep_no_nl ';'  */
#line 2190 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6140 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 277: /* opt_sep_no_nl: %empty  */
#line 2198 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6146 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 278: /* opt_sep_no_nl: sep_no_nl  */
#line 2200 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6152 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 279: /* opt_nl: %empty  */
#line 2204 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6158 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 280: /* opt_nl: nl  */
#line 2206 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6164 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 281: /* nl: '\n'  */
#line 2210 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = '\n';
                  }
#line 6174 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 282: /* nl: nl '\n'  */
#line 2216 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6184 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 283: /* sep: ','  */
#line 2224 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ',';
                  }
#line 6194 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 284: /* sep: ';'  */
#line 2230 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ';';
                  }
#line 6204 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 285: /* sep: '\n'  */
#line 2236 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = '\n';
                  }
#line 6214 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 286: /* sep: sep ','  */
#line 2242 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6224 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 287: /* sep: sep ';'  */
#line 2248 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6234 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 288: /* sep: sep '\n'  */
#line 2254 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    OCTAVE_YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6244 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 289: /* opt_sep: %empty  */
#line 2262 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6250 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 290: /* opt_sep: sep  */
#line 2264 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6256 "libinterp/parse-tree/oct-parse.cc"
    break;


#line 6260 "libinterp/parse-tree/oct-parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == OCTAVE_EMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parser, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= OCTAVE_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == OCTAVE_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parser);
          yychar = OCTAVE_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (parser, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != OCTAVE_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parser);
      YYPOPSTACK (1);
    }
  yyps->yynew = 2;
  goto yypushreturn;


/*-------------------------.
| yypushreturn -- return.  |
`-------------------------*/
yypushreturn:

  return yyresult;
}
#undef octave_nerrs
#undef yystate
#undef yyerrstatus
#undef yyssa
#undef yyss
#undef yyssp
#undef yyvsa
#undef yyvs
#undef yyvsp
#undef yystacksize
#line 2267 "../libinterp/parse-tree/oct-parse.yy"


#if defined (HAVE_PRAGMA_GCC_DIAGNOSTIC)
   // Restore prevailing warning state for remainder of the file.
#  pragma GCC diagnostic pop
#endif

// Generic error messages.

#undef lexer
#undef scanner

static void
yyerror (octave::base_parser& parser, const char *s)
{
  parser.bison_error (s);
}

namespace octave
{
  std::size_t
  base_parser::parent_scope_info::size (void) const
  {
    return m_info.size ();
  }

  void
  base_parser::parent_scope_info::push (const value_type& elt)
  {
    m_info.push_back (elt);
  }

  void
  base_parser::parent_scope_info::push (const symbol_scope& scope)
  {
    push (value_type (scope, ""));
  }

  void
  base_parser::parent_scope_info::pop (void)
  {
    m_info.pop_back ();
  }

  bool
  base_parser::parent_scope_info::name_ok (const std::string& name)
  {
    // Name can't be the same as any parent function or any other
    // function we've already seen.  We could maintain a complex
    // tree structure of names, or we can just store the set of
    // full names of all the functions, which must be unique.

    std::string full_name;

    for (std::size_t i = 0; i < size()-1; i++)
      {
        const value_type& elt = m_info[i];

        if (name == elt.second)
          return false;

        full_name += elt.second + ">";
      }

    full_name += name;

    if (m_all_names.find (full_name) != m_all_names.end ())
      {
        // Return false (failure) if we are parsing a subfunction, local
        // function, or nested function.  Otherwise, it is OK to have a
        // duplicate name.

        return ! (m_parser.parsing_subfunctions ()
                  || m_parser.parsing_local_functions ()
                  || m_parser.curr_fcn_depth () > 0);
      }

    m_all_names.insert (full_name);

    return true;
  }

  bool
  base_parser::parent_scope_info::name_current_scope (const std::string& name)
  {
    if (! name_ok (name))
      return false;

    if (size () > 0)
      m_info.back().second = name;

    return true;
  }

  symbol_scope
  base_parser::parent_scope_info::parent_scope (void) const
  {
    return size () > 1 ? m_info[size()-2].first : symbol_scope ();
  }

  std::string
  base_parser::parent_scope_info::parent_name (void) const
  {
    return m_info[size()-2].second;
  }

  void base_parser::parent_scope_info::clear (void)
  {
    m_info.clear ();
    m_all_names.clear ();
  }

  base_parser::base_parser (base_lexer& lxr)
    : m_endfunction_found (false), m_autoloading (false),
      m_fcn_file_from_relative_lookup (false),
      m_parsing_subfunctions (false), m_parsing_local_functions (false),
      m_max_fcn_depth (-1), m_curr_fcn_depth (-1), m_primary_fcn_scope (),
      m_curr_class_name (), m_curr_package_name (), m_function_scopes (*this),
      m_primary_fcn (), m_subfunction_names (), m_classdef_object (),
      m_stmt_list (), m_lexer (lxr), m_parser_state (yypstate_new ())
  { }

  base_parser::~base_parser (void)
  {
    delete &m_lexer;

    // FIXME: Deleting the internal Bison parser state structure does
    // not clean up any partial parse trees in the event of an interrupt or
    // error.  It's not clear how to safely do that with the C language
    // parser that Bison generates.  The C++ language parser that Bison
    // generates would do it for us automatically whenever an exception
    // is thrown while parsing input, but there is currently no C++
    // interface for a push parser.

    yypstate_delete (static_cast<yypstate *> (m_parser_state));
  }

  void
  base_parser::reset (void)
  {
    m_endfunction_found = false;
    m_autoloading = false;
    m_fcn_file_from_relative_lookup = false;
    m_parsing_subfunctions = false;
    m_parsing_local_functions = false;
    m_max_fcn_depth = -1;
    m_curr_fcn_depth = -1;
    m_primary_fcn_scope = symbol_scope ();
    m_curr_class_name = "";
    m_curr_package_name = "";
    m_function_scopes.clear ();
    m_primary_fcn = octave_value ();
    m_subfunction_names.clear ();
    m_classdef_object.reset ();
    m_stmt_list.reset ();

    m_lexer.reset ();

    yypstate_delete (static_cast<yypstate *> (m_parser_state));
    m_parser_state = yypstate_new ();
  }

  // Error messages for mismatched end tokens.

  static std::string
  end_token_as_string (token::end_tok_type ettype)
  {
    std::string retval = "<unknown>";

    switch (ettype)
      {
      case token::simple_end:
        retval = "end";
        break;

      case token::classdef_end:
        retval = "endclassdef";
        break;

      case token::enumeration_end:
        retval = "endenumeration";
        break;

      case token::events_end:
        retval = "endevents";
        break;

      case token::for_end:
        retval = "endfor";
        break;

      case token::function_end:
        retval = "endfunction";
        break;

      case token::if_end:
        retval = "endif";
        break;

      case token::methods_end:
        retval = "endmethods";
        break;

      case token::parfor_end:
        retval = "endparfor";
        break;

      case token::properties_end:
        retval = "endproperties";
        break;

      case token::switch_end:
        retval = "endswitch";
        break;

      case token::try_catch_end:
        retval = "end_try_catch";
        break;

      case token::unwind_protect_end:
        retval = "end_unwind_protect";
        break;

      case token::while_end:
        retval = "endwhile";
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  void
  base_parser::statement_list (std::shared_ptr<tree_statement_list>& lst)
  {
    if (! lst)
      return;

    if (m_stmt_list)
      {
        // Append additional code to existing statement list.

        while (! lst->empty ())
          {
            m_stmt_list->push_back (lst->front ());
            lst->pop_front ();
          }
      }
    else
      m_stmt_list = lst;
  }

  void
  base_parser::end_token_error (token *tok, token::end_tok_type expected)
  {
    std::string msg = ("'" + end_token_as_string (expected)
                       + "' command matched by '"
                       + end_token_as_string (tok->ettype ()) + "'");

    bison_error (msg, tok->beg_pos ());
  }

  // Check to see that end tokens are properly matched.

  bool
  base_parser::end_token_ok (token *tok, token::end_tok_type expected)
  {
    token::end_tok_type ettype = tok->ettype ();

    return ettype == expected || ettype == token::simple_end;
  }

  bool
  base_parser::push_fcn_symtab (void)
  {
    m_curr_fcn_depth++;

    if (m_max_fcn_depth < m_curr_fcn_depth)
      m_max_fcn_depth = m_curr_fcn_depth;

    // Will get a real name later.
    m_lexer.m_symtab_context.push (octave::symbol_scope ("parser:push_fcn_symtab"));
    m_function_scopes.push (m_lexer.m_symtab_context.curr_scope ());

    if (! m_lexer.m_reading_script_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
        {
          m_primary_fcn_scope = m_lexer.m_symtab_context.curr_scope ();
          m_primary_fcn_scope.mark_primary_fcn_scope ();
        }

    if (m_lexer.m_reading_script_file && m_curr_fcn_depth > 0)
      {
        bison_error ("nested functions not implemented in this context");

        return false;
      }

    return true;
  }

  // Make a constant.

  tree_constant *
  base_parser::make_constant (int op, token *tok_val)
  {
    int l = tok_val->line ();
    int c = tok_val->column ();

    tree_constant *retval = nullptr;

    switch (op)
      {
      case NUM:
        {
          octave_value tmp (tok_val->number ());
          retval = new tree_constant (tmp, l, c);
          retval->stash_original_text (tok_val->text_rep ());
        }
        break;

      case IMAG_NUM:
        {
          octave_value tmp (Complex (0.0, tok_val->number ()));
          retval = new tree_constant (tmp, l, c);
          retval->stash_original_text (tok_val->text_rep ());
        }
        break;

      case DQ_STRING:
      case SQ_STRING:
        {
          std::string txt = tok_val->text ();

          char delim = op == DQ_STRING ? '"' : '\'';
          octave_value tmp (txt, delim);

          if (txt.empty ())
            {
              if (op == DQ_STRING)
                tmp = octave_null_str::instance;
              else
                tmp = octave_null_sq_str::instance;
            }

          retval = new tree_constant (tmp, l, c);

          if (op == DQ_STRING)
            txt = undo_string_escapes (txt);

          // FIXME: maybe this should also be handled by
          // tok_val->text_rep () for character strings?
          retval->stash_original_text (delim + txt + delim);
        }
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  // Make a function handle.

  tree_fcn_handle *
  base_parser::make_fcn_handle (token *tok_val)
  {
    int l = tok_val->line ();
    int c = tok_val->column ();

    tree_fcn_handle *retval = new tree_fcn_handle (tok_val->text (), l, c);

    return retval;
  }

  // Make an anonymous function handle.

  tree_anon_fcn_handle *
  base_parser::make_anon_fcn_handle (tree_parameter_list *param_list,
                                     tree_expression *expr,
                                     const filepos& at_pos)
  {
    // FIXME: We need to examine EXPR and issue an error if any
    // sub-expression contains an assignment, compound assignment,
    // increment, or decrement operator.

    anon_fcn_validator validator (param_list, expr);

    if (! validator.ok ())
      {
        delete param_list;
        delete expr;

        bison_error (validator.message (), validator.line (),
                     validator.column ());

        return nullptr;
      }

    symbol_scope fcn_scope = m_lexer.m_symtab_context.curr_scope ();
    symbol_scope parent_scope = m_lexer.m_symtab_context.parent_scope ();

    m_lexer.m_symtab_context.pop ();

    expr->set_print_flag (false);

    fcn_scope.mark_static ();

    int at_line = at_pos.line ();
    int at_column = at_pos.column ();

    tree_anon_fcn_handle *retval
      = new tree_anon_fcn_handle (param_list, expr, fcn_scope,
                                  parent_scope, at_line, at_column);

    std::ostringstream buf;

    tree_print_code tpc (buf);

    retval->accept (tpc);

    std::string file = m_lexer.m_fcn_file_full_name;
    if (! file.empty ())
      buf << ": file: " << file;
    else if (m_lexer.input_from_terminal ())
      buf << ": *terminal input*";
    else if (m_lexer.input_from_eval_string ())
      buf << ": *eval string*";
    buf << ": line: " << at_line << " column: " << at_column;

    std::string scope_name = buf.str ();

    fcn_scope.cache_name (scope_name);

    // FIXME: Stash the filename.  This does not work and produces
    // errors when executed.
    //retval->stash_file_name (m_lexer.m_fcn_file_name);

    return retval;
  }

  // Build a colon expression.

  tree_expression *
  base_parser::make_colon_expression (tree_expression *base,
                                      tree_expression *limit,
                                      tree_expression *incr)
  {
    tree_expression *retval = nullptr;

    if (! base || ! limit)
      {
        delete base;
        delete limit;
        delete incr;

        return retval;
      }

    int l = base->line ();
    int c = base->column ();

    tree_colon_expression *expr
      = new tree_colon_expression (base, limit, incr, l, c);

    retval = expr;

    if (base->is_constant () && limit->is_constant ()
        && (! incr || incr->is_constant ()))
      {
        interpreter& interp = __get_interpreter__ ("finish_colon_expression");

        try
          {
            // If the evaluation generates a warning message, restore
            // the previous value of last_warning_message and skip the
            // conversion to a constant value.

            unwind_protect frame;

            error_system& es = interp.get_error_system ();

            frame.add_method (es, &error_system::set_last_warning_message,
                              es.last_warning_message (""));

            frame.add_method (es, &error_system::set_discard_warning_messages,
                              es.discard_warning_messages (true));

            tree_evaluator& tw = interp.get_evaluator ();

            octave_value tmp = expr->evaluate (tw);

            std::string msg = es.last_warning_message ();

            if (msg.empty ())
              {
                tree_constant *tc_retval
                  = new tree_constant (tmp, expr->line (), expr->column ());

                std::ostringstream buf;

                tree_print_code tpc (buf);

                expr->accept (tpc);

                tc_retval->stash_original_text (buf.str ());

                delete expr;

                retval = tc_retval;
              }
          }
        catch (const execution_exception&)
          {
            interp.recover_from_exception ();
          }
      }

    return retval;
  }

  // Build a binary expression.

  tree_expression *
  base_parser::make_binary_op (int op, tree_expression *op1,
                               token *tok_val, tree_expression *op2)
  {
    octave_value::binary_op t = octave_value::unknown_binary_op;

    switch (op)
      {
      case POW:
        t = octave_value::op_pow;
        break;

      case EPOW:
        t = octave_value::op_el_pow;
        break;

      case '+':
        t = octave_value::op_add;
        break;

      case '-':
        t = octave_value::op_sub;
        break;

      case '*':
        t = octave_value::op_mul;
        break;

      case '/':
        t = octave_value::op_div;
        break;

      case EMUL:
        t = octave_value::op_el_mul;
        break;

      case EDIV:
        t = octave_value::op_el_div;
        break;

      case LEFTDIV:
        t = octave_value::op_ldiv;
        break;

      case ELEFTDIV:
        t = octave_value::op_el_ldiv;
        break;

      case EXPR_LT:
        t = octave_value::op_lt;
        break;

      case EXPR_LE:
        t = octave_value::op_le;
        break;

      case EXPR_EQ:
        t = octave_value::op_eq;
        break;

      case EXPR_GE:
        t = octave_value::op_ge;
        break;

      case EXPR_GT:
        t = octave_value::op_gt;
        break;

      case EXPR_NE:
        t = octave_value::op_ne;
        break;

      case EXPR_AND:
        t = octave_value::op_el_and;
        break;

      case EXPR_OR:
        t = octave_value::op_el_or;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return maybe_compound_binary_expression (op1, op2, l, c, t);
  }

  // Build a boolean expression.

  tree_expression *
  base_parser::make_boolean_op (int op, tree_expression *op1,
                                token *tok_val, tree_expression *op2)
  {
    tree_boolean_expression::type t;

    switch (op)
      {
      case EXPR_AND_AND:
        t = tree_boolean_expression::bool_and;
        break;

      case EXPR_OR_OR:
        t = tree_boolean_expression::bool_or;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_boolean_expression (op1, op2, l, c, t);
  }

  // Build a prefix expression.

  tree_expression *
  base_parser::make_prefix_op (int op, tree_expression *op1, token *tok_val)
  {
    octave_value::unary_op t = octave_value::unknown_unary_op;

    switch (op)
      {
      case EXPR_NOT:
        t = octave_value::op_not;
        break;

      case '+':
        t = octave_value::op_uplus;
        break;

      case '-':
        t = octave_value::op_uminus;
        break;

      case PLUS_PLUS:
        t = octave_value::op_incr;
        break;

      case MINUS_MINUS:
        t = octave_value::op_decr;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_prefix_expression (op1, l, c, t);
  }

  // Build a postfix expression.

  tree_expression *
  base_parser::make_postfix_op (int op, tree_expression *op1, token *tok_val)
  {
    octave_value::unary_op t = octave_value::unknown_unary_op;

    switch (op)
      {
      case HERMITIAN:
        t = octave_value::op_hermitian;
        break;

      case TRANSPOSE:
        t = octave_value::op_transpose;
        break;

      case PLUS_PLUS:
        t = octave_value::op_incr;
        break;

      case MINUS_MINUS:
        t = octave_value::op_decr;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_postfix_expression (op1, l, c, t);
  }

  // Build an unwind-protect command.

  tree_command *
  base_parser::make_unwind_command (token *unwind_tok,
                                    tree_statement_list *body,
                                    tree_statement_list *cleanup_stmts,
                                    token *end_tok,
                                    comment_list *lc,
                                    comment_list *mc)
  {
    tree_command *retval = nullptr;

    if (end_token_ok (end_tok, token::unwind_protect_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = unwind_tok->line ();
        int c = unwind_tok->column ();

        retval = new tree_unwind_protect_command (body, cleanup_stmts,
                                                  lc, mc, tc, l, c);
      }
    else
      {
        delete body;
        delete cleanup_stmts;

        end_token_error (end_tok, token::unwind_protect_end);
      }

    return retval;
  }

  // Build a try-catch command.

  tree_command *
  base_parser::make_try_command (token *try_tok,
                                 tree_statement_list *body,
                                 char catch_sep,
                                 tree_statement_list *cleanup_stmts,
                                 token *end_tok,
                                 comment_list *lc,
                                 comment_list *mc)
  {
    tree_command *retval = nullptr;

    if (end_token_ok (end_tok, token::try_catch_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = try_tok->line ();
        int c = try_tok->column ();

        tree_identifier *id = nullptr;

        if (! catch_sep && cleanup_stmts && ! cleanup_stmts->empty ())
          {
            tree_statement *stmt = cleanup_stmts->front ();

            if (stmt)
              {
                tree_expression *expr = stmt->expression ();

                if (expr && expr->is_identifier ())
                  {
                    id = dynamic_cast<tree_identifier *> (expr);

                    cleanup_stmts->pop_front ();

                    stmt->set_expression (nullptr);
                    delete stmt;
                  }
              }
          }

        retval = new tree_try_catch_command (body, cleanup_stmts, id,
                                             lc, mc, tc, l, c);
      }
    else
      {
        delete body;
        delete cleanup_stmts;

        end_token_error (end_tok, token::try_catch_end);
      }

    return retval;
  }

  // Build a while command.

  tree_command *
  base_parser::make_while_command (token *while_tok,
                                   tree_expression *expr,
                                   tree_statement_list *body,
                                   token *end_tok,
                                   comment_list *lc)
  {
    tree_command *retval = nullptr;

    maybe_warn_assign_as_truth_value (expr);

    if (end_token_ok (end_tok, token::while_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        m_lexer.m_looping--;

        int l = while_tok->line ();
        int c = while_tok->column ();

        retval = new tree_while_command (expr, body, lc, tc, l, c);
      }
    else
      {
        delete expr;
        delete body;

        end_token_error (end_tok, token::while_end);
      }

    return retval;
  }

  // Build a do-until command.

  tree_command *
  base_parser::make_do_until_command (token *until_tok,
                                      tree_statement_list *body,
                                      tree_expression *expr,
                                      comment_list *lc)
  {
    maybe_warn_assign_as_truth_value (expr);

    comment_list *tc = m_lexer.m_comment_buf.get_comment ();

    m_lexer.m_looping--;

    int l = until_tok->line ();
    int c = until_tok->column ();

    return new tree_do_until_command (expr, body, lc, tc, l, c);
  }

  // Build a for command.

  tree_command *
  base_parser::make_for_command (int tok_id, token *for_tok,
                                 tree_argument_list *lhs,
                                 tree_expression *expr,
                                 tree_expression *maxproc,
                                 tree_statement_list *body,
                                 token *end_tok,
                                 comment_list *lc)
  {
    tree_command *retval = nullptr;

    bool parfor = tok_id == PARFOR;

    if (end_token_ok (end_tok, parfor ? token::parfor_end : token::for_end))
      {
        expr->mark_as_for_cmd_expr ();

        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        m_lexer.m_looping--;

        int l = for_tok->line ();
        int c = for_tok->column ();

        if (lhs->length () == 1)
          {
            tree_expression *tmp = lhs->remove_front ();

            retval = new tree_simple_for_command (parfor, tmp, expr, maxproc,
                                                  body, lc, tc, l, c);

            delete lhs;
          }
        else
          {
            if (parfor)
              {
                delete lhs;
                delete expr;
                delete maxproc;
                delete body;

                bison_error ("invalid syntax for parfor statement");
              }
            else
              retval = new tree_complex_for_command (lhs, expr, body,
                                                     lc, tc, l, c);
          }
      }
    else
      {
        delete lhs;
        delete expr;
        delete maxproc;
        delete body;

        end_token_error (end_tok, parfor ? token::parfor_end : token::for_end);
      }

    return retval;
  }

  // Build a break command.

  tree_command *
  base_parser::make_break_command (token *break_tok)
  {
    int l = break_tok->line ();
    int c = break_tok->column ();

    if (! m_lexer.m_looping)
      {
        bison_error ("break must appear within a loop");
        return nullptr;
      }
    else
      return new tree_break_command (l, c);
  }

  // Build a continue command.

  tree_command *
  base_parser::make_continue_command (token *continue_tok)
  {
    int l = continue_tok->line ();
    int c = continue_tok->column ();

    if (! m_lexer.m_looping)
      {
        bison_error ("continue must appear within a loop");
        return nullptr;
      }
    else
      return new tree_continue_command (l, c);
  }

  // Build a return command.

  tree_command *
  base_parser::make_return_command (token *return_tok)
  {
    int l = return_tok->line ();
    int c = return_tok->column ();

    return new tree_return_command (l, c);
  }

  // Start an if command.

  tree_if_command_list *
  base_parser::start_if_command (tree_expression *expr,
                                 tree_statement_list *list)
  {
    maybe_warn_assign_as_truth_value (expr);

    tree_if_clause *t = new tree_if_clause (expr, list);

    return new tree_if_command_list (t);
  }

  // Finish an if command.

  tree_if_command *
  base_parser::finish_if_command (token *if_tok,
                                  tree_if_command_list *list,
                                  token *end_tok,
                                  comment_list *lc)
  {
    tree_if_command *retval = nullptr;

    if (end_token_ok (end_tok, token::if_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = if_tok->line ();
        int c = if_tok->column ();

        if (list && ! list->empty ())
          {
            tree_if_clause *elt = list->front ();

            if (elt)
              {
                elt->line (l);
                elt->column (c);
              }
          }

        retval = new tree_if_command (list, lc, tc, l, c);
      }
    else
      {
        delete list;

        end_token_error (end_tok, token::if_end);
      }

    return retval;
  }

  // Build an elseif clause.

  tree_if_clause *
  base_parser::make_elseif_clause (token *elseif_tok,
                                   tree_expression *expr,
                                   tree_statement_list *list,
                                   comment_list *lc)
  {
    maybe_warn_assign_as_truth_value (expr);

    int l = elseif_tok->line ();
    int c = elseif_tok->column ();

    return new tree_if_clause (expr, list, lc, l, c);
  }

  // Finish a switch command.

  tree_switch_command *
  base_parser::finish_switch_command (token *switch_tok,
                                      tree_expression *expr,
                                      tree_switch_case_list *list,
                                      token *end_tok,
                                      comment_list *lc)
  {
    tree_switch_command *retval = nullptr;

    if (end_token_ok (end_tok, token::switch_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = switch_tok->line ();
        int c = switch_tok->column ();

        if (list && ! list->empty ())
          {
            tree_switch_case *elt = list->front ();

            if (elt)
              {
                elt->line (l);
                elt->column (c);
              }
          }

        retval = new tree_switch_command (expr, list, lc, tc, l, c);
      }
    else
      {
        delete expr;
        delete list;

        end_token_error (end_tok, token::switch_end);
      }

    return retval;
  }

  // Build a switch case.

  tree_switch_case *
  base_parser::make_switch_case (token *case_tok,
                                 tree_expression *expr,
                                 tree_statement_list *list,
                                 comment_list *lc)
  {
    maybe_warn_variable_switch_label (expr);

    int l = case_tok->line ();
    int c = case_tok->column ();

    return new tree_switch_case (expr, list, lc, l, c);
  }

  // Build an assignment to a variable.

  tree_expression *
  base_parser::make_assign_op (int op, tree_argument_list *lhs,
                               token *eq_tok, tree_expression *rhs)
  {
    octave_value::assign_op t = octave_value::unknown_assign_op;

    switch (op)
      {
      case '=':
        t = octave_value::op_asn_eq;
        break;

      case ADD_EQ:
        t = octave_value::op_add_eq;
        break;

      case SUB_EQ:
        t = octave_value::op_sub_eq;
        break;

      case MUL_EQ:
        t = octave_value::op_mul_eq;
        break;

      case DIV_EQ:
        t = octave_value::op_div_eq;
        break;

      case LEFTDIV_EQ:
        t = octave_value::op_ldiv_eq;
        break;

      case POW_EQ:
        t = octave_value::op_pow_eq;
        break;

      case EMUL_EQ:
        t = octave_value::op_el_mul_eq;
        break;

      case EDIV_EQ:
        t = octave_value::op_el_div_eq;
        break;

      case ELEFTDIV_EQ:
        t = octave_value::op_el_ldiv_eq;
        break;

      case EPOW_EQ:
        t = octave_value::op_el_pow_eq;
        break;

      case AND_EQ:
        t = octave_value::op_el_and_eq;
        break;

      case OR_EQ:
        t = octave_value::op_el_or_eq;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = eq_tok->line ();
    int c = eq_tok->column ();

    if (! lhs->is_simple_assign_lhs () && t != octave_value::op_asn_eq)
      {
        // Multiple assignments like [x,y] OP= rhs are only valid for
        // '=', not '+=', etc.

        delete lhs;
        delete rhs;

        bison_error ("computed multiple assignment not allowed",
                     eq_tok->beg_pos ());

        return nullptr;
      }

    if (lhs->is_simple_assign_lhs ())
      {
        // We are looking at a simple assignment statement like x = rhs;

        tree_expression *tmp = lhs->remove_front ();

        if ((tmp->is_identifier () || tmp->is_index_expression ())
            && iskeyword (tmp->name ()))
          {
            std::string kw = tmp->name ();

            delete tmp;
            delete lhs;
            delete rhs;

            bison_error ("invalid assignment to keyword \"" + kw + "\"",
                         eq_tok->beg_pos ());

            return nullptr;
          }

        delete lhs;

        return new tree_simple_assignment (tmp, rhs, false, l, c, t);
      }
    else
      {
        std::list<std::string> names = lhs->variable_names ();

        for (const auto& kw : names)
          {
            if (iskeyword (kw))
              {
                delete lhs;
                delete rhs;

                bison_error ("invalid assignment to keyword \"" + kw + "\"",
                             eq_tok->beg_pos ());

                return nullptr;
              }
          }

        return new tree_multi_assignment (lhs, rhs, false, l, c);
      }
  }

  // Define a script.

  void
  base_parser::make_script (tree_statement_list *cmds,
                            tree_statement *end_script)
  {
    if (! cmds)
      cmds = new tree_statement_list ();

    cmds->append (end_script);

    symbol_scope script_scope = m_lexer.m_symtab_context.curr_scope ();

    script_scope.cache_name (m_lexer.m_fcn_file_full_name);
    script_scope.cache_fcn_file_name (m_lexer.m_fcn_file_full_name);
    script_scope.cache_dir_name (m_lexer.m_dir_name);

    octave_user_script *script
      = new octave_user_script (m_lexer.m_fcn_file_full_name,
                                m_lexer.m_fcn_file_name, script_scope,
                                cmds, m_lexer.m_help_text);

    m_lexer.m_symtab_context.pop ();
    m_lexer.m_help_text = "";

    sys::time now;

    script->stash_fcn_file_time (now);
    script->stash_dir_name (m_lexer.m_dir_name);

    m_primary_fcn = octave_value (script);
  }

  tree_identifier *
  base_parser::make_fcn_name (tree_identifier *id)
  {
    std::string id_name = id->name ();

    // Make classdef local functions unique from classdef methods.

    if (m_parsing_local_functions && m_curr_fcn_depth == 0)
      id_name = m_lexer.m_fcn_file_name + ">" + id_name;

    if (! m_function_scopes.name_current_scope (id_name))
      {
        bison_error ("duplicate subfunction or nested function name",
                     id->line (), id->column ());

        delete id;
        return nullptr;
      }

    octave::symbol_scope curr_scope = m_lexer.m_symtab_context.curr_scope ();
    curr_scope.cache_name (id_name);

    m_lexer.m_parsed_function_name.top () = true;
    m_lexer.m_maybe_classdef_get_set_method = false;

    return id;
  }

  // Define a function.

  // FIXME: combining start_function, finish_function, and
  // recover_from_parsing_function should be possible, but it makes
  // for a large mess.  Maybe this could be a bit better organized?

  tree_function_def *
  base_parser::make_function (token *fcn_tok,
                              tree_parameter_list *ret_list,
                              tree_identifier *id,
                              tree_parameter_list *param_list,
                              tree_statement_list *body,
                              tree_statement *end_fcn_stmt,
                              comment_list *lc)
  {
    int l = fcn_tok->line ();
    int c = fcn_tok->column ();

    octave_user_function *tmp_fcn
      = start_function (id, param_list, body, end_fcn_stmt);

    tree_function_def *retval = finish_function (ret_list, tmp_fcn, lc, l, c);

    recover_from_parsing_function ();

    return retval;
  }

  // Begin defining a function.

  octave_user_function *
  base_parser::start_function (tree_identifier *id,
                               tree_parameter_list *param_list,
                               tree_statement_list *body,
                               tree_statement *end_fcn_stmt)
  {
    // We'll fill in the return list later.

    std::string id_name = id->name ();

    delete id;

    if (m_lexer.m_parsing_classdef_get_method)
      id_name.insert (0, "get.");
    else if (m_lexer.m_parsing_classdef_set_method)
      id_name.insert (0, "set.");

    m_lexer.m_parsing_classdef_get_method = false;
    m_lexer.m_parsing_classdef_set_method = false;

    if (! body)
      body = new tree_statement_list ();

    body->append (end_fcn_stmt);

    octave_user_function *fcn
      = new octave_user_function (m_lexer.m_symtab_context.curr_scope (),
                                  param_list, nullptr, body);

    comment_list *tc = m_lexer.m_comment_buf.get_comment ();

    fcn->stash_trailing_comment (tc);
    fcn->stash_fcn_end_location (end_fcn_stmt->line (),
                                 end_fcn_stmt->column ());

    // If input is coming from a file, issue a warning if the name of
    // the file does not match the name of the function stated in the
    // file.  Matlab doesn't provide a diagnostic (it ignores the stated
    // name).
    if (! m_autoloading && m_lexer.m_reading_fcn_file
        && m_curr_fcn_depth == 0 && ! m_parsing_subfunctions)
      {
        // FIXME: should m_lexer.m_fcn_file_name already be
        // preprocessed when we get here?  It seems to only be a
        // problem with relative filenames.

        std::string nm = m_lexer.m_fcn_file_name;

        std::size_t pos = nm.find_last_of (sys::file_ops::dir_sep_chars ());

        if (pos != std::string::npos)
          nm = m_lexer.m_fcn_file_name.substr (pos+1);

        if (nm != id_name)
          {
            warning_with_id
              ("Octave:function-name-clash",
               "function name '%s' does not agree with function filename '%s'",
               id_name.c_str (), m_lexer.m_fcn_file_full_name.c_str ());

            id_name = nm;
          }
      }

    sys::time now;

    fcn->stash_fcn_file_name (m_lexer.m_fcn_file_full_name);
    fcn->stash_fcn_file_time (now);
    fcn->stash_dir_name (m_lexer.m_dir_name);
    fcn->stash_package_name (m_lexer.m_package_name);
    fcn->mark_as_system_fcn_file ();
    fcn->stash_function_name (id_name);

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_classdef_file || m_autoloading)
      {
        if (m_fcn_file_from_relative_lookup)
          fcn->mark_relative ();

        if (m_lexer.m_parsing_class_method)
          {
            if (m_lexer.m_parsing_classdef)
              {
                if (m_curr_class_name == id_name)
                  fcn->mark_as_classdef_constructor ();
                else
                  fcn->mark_as_classdef_method ();
              }
            else
              {
                if (m_curr_class_name == id_name)
                  fcn->mark_as_legacy_constructor ();
                else
                  fcn->mark_as_legacy_method ();
              }

            fcn->stash_dispatch_class (m_curr_class_name);
          }

        std::string nm = fcn->fcn_file_name ();

        sys::file_stat fs (nm);

        if (fs && fs.is_newer (now))
          warning_with_id ("Octave:future-time-stamp",
                           "time stamp for '%s' is in the future", nm.c_str ());
      }
    else if (! m_lexer.input_from_tmp_history_file ()
             && ! m_lexer.m_force_script
             && m_lexer.m_reading_script_file
             && m_lexer.m_fcn_file_name == id_name)
      {
        warning ("function '%s' defined within script file '%s'",
                 id_name.c_str (), m_lexer.m_fcn_file_full_name.c_str ());
      }

    // Record help text for functions other than nested functions.
    // We cannot currently record help for nested functions (bug #46008)
    // because the doc_string of the outermost function is read first,
    // whereas this function is called for the innermost function first.
    // We could have a stack of help_text in lexer.
    if (! m_lexer.m_help_text.empty () && m_curr_fcn_depth == 0)
      {
        fcn->document (m_lexer.m_help_text);

        m_lexer.m_help_text = "";
      }

    if (m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_primary_fcn = octave_value (fcn);

    return fcn;
  }

  tree_statement *
  base_parser::make_end (const std::string& type, bool eof,
                         const filepos& beg_pos, const filepos& /*end_pos*/)
  {
    int l = beg_pos.line ();
    int c = beg_pos.column ();

    return make_statement (new tree_no_op_command (type, eof, l, c));
  }

  tree_function_def *
  base_parser::finish_function (tree_parameter_list *ret_list,
                                octave_user_function *fcn,
                                comment_list *lc,
                                int l, int c)
  {
    tree_function_def *retval = nullptr;

    if (! ret_list)
      ret_list = new tree_parameter_list (tree_parameter_list::out);

    ret_list->mark_as_formal_parameters ();

    if (fcn)
      {
        std::string fcn_nm = fcn->name ();
        std::string file = fcn->fcn_file_name ();

        std::string tmp = fcn_nm;
        if (! file.empty ())
          tmp += ": " + file;

        symbol_scope fcn_scope = fcn->scope ();
        fcn_scope.cache_name (tmp);
        fcn_scope.cache_fcn_name (fcn_nm);
        fcn_scope.cache_fcn_file_name (file);
        fcn_scope.cache_dir_name (m_lexer.m_dir_name);

        if (lc)
          fcn->stash_leading_comment (lc);

        fcn->define_ret_list (ret_list);

        if (m_curr_fcn_depth > 0 || m_parsing_subfunctions)
          {
            fcn->stash_fcn_location (l, c);
            fcn->stash_parent_fcn_name (m_lexer.m_fcn_file_name);

            octave_value ov_fcn (fcn);

            if (m_endfunction_found && m_function_scopes.size () > 1)
              {
                fcn->mark_as_nested_function ();
                fcn_scope.set_nesting_depth (m_curr_fcn_depth);

                symbol_scope pscope = m_function_scopes.parent_scope ();
                fcn_scope.set_parent (pscope);
                fcn_scope.set_primary_parent (m_primary_fcn_scope);
                pscope.install_nestfunction (fcn_nm, ov_fcn, fcn_scope);

                // For nested functions, the list of parent functions is
                // set in symbol_scope::update_nest.
              }
            else
              {
                fcn->mark_as_subfunction ();
                m_subfunction_names.push_back (fcn_nm);
                fcn_scope.set_parent (m_primary_fcn_scope);
                if (m_parsing_subfunctions)
                  fcn_scope.set_primary_parent (m_primary_fcn_scope);
                m_primary_fcn_scope.install_subfunction (fcn_nm, ov_fcn);

                // Prepend name of primary fucntion to list of parent
                // functions (if any) for subfunction.

                std::list<std::string> plst
                  = fcn_scope.parent_fcn_names ();
                plst.push_front (m_primary_fcn_scope.fcn_name ());
                fcn_scope.cache_parent_fcn_names (plst);
              }
          }

        if (m_curr_fcn_depth == 0)
          fcn_scope.update_nest ();

        if (! m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0)
          {
            // We are either reading a script file or defining a function
            // at the command line, so this definition creates a
            // tree_function object that is placed in the parse tree.
            // Otherwise, it is just inserted in the symbol table,
            // either as a subfunction or nested function (see above),
            // or as the primary function for the file, via
            // m_primary_fcn (see also load_fcn_from_file,,
            // parse_fcn_file, and
            // fcn_info::fcn_info_rep::find_user_function).

            if (m_lexer.m_buffer_function_text)
              {
                fcn->cache_function_text (m_lexer.m_function_text,
                                          fcn->time_parsed ());
                m_lexer.m_buffer_function_text = false;
              }

            retval = new tree_function_def (fcn);
          }
      }

    return retval;
  }

  void
  base_parser::recover_from_parsing_function (void)
  {
    m_lexer.m_symtab_context.pop ();

    if (m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_parsing_subfunctions = true;

    m_curr_fcn_depth--;
    m_function_scopes.pop ();

    m_lexer.m_defining_func--;
    m_lexer.m_parsed_function_name.pop ();
    m_lexer.m_looking_at_return_list = false;
    m_lexer.m_looking_at_parameter_list = false;
  }

  // A CLASSDEF block defines a class that has a constructor and other
  // methods, but it is not an executable command.  Parsing the block
  // makes some changes in the symbol table (inserting the constructor
  // and methods, and adding to the list of known objects) and creates
  // a parse tree containing meta information about the class.

  // LC contains comments appearing before the classdef keyword.
  // TC contains comments appearing between the classdef elements
  // and the final end token for the classdef block.

  tree_classdef *
  base_parser::make_classdef (token *tok_val,
                              tree_classdef_attribute_list *a,
                              tree_identifier *id,
                              tree_classdef_superclass_list *sc,
                              tree_classdef_body *body, token *end_tok,
                              comment_list *lc, comment_list *tc)
  {
    tree_classdef *retval = nullptr;

    m_lexer.m_symtab_context.pop ();

    std::string cls_name = id->name ();

    std::string nm = m_lexer.m_fcn_file_name;

    std::size_t pos = nm.find_last_of (sys::file_ops::dir_sep_chars ());

    if (pos != std::string::npos)
      nm = m_lexer.m_fcn_file_name.substr (pos+1);

    if (nm != cls_name)
      {
        int l = id->line ();
        int c = id->column ();

        delete a;
        delete id;
        delete sc;
        delete body;
        delete lc;
        delete tc;

        bison_error ("invalid classdef definition, the class name must match the filename", l, c);

      }
    else
      {
        if (end_token_ok (end_tok, token::classdef_end))
          {
            int l = tok_val->line ();
            int c = tok_val->column ();

            if (! body)
              body = new tree_classdef_body ();

            retval = new tree_classdef (m_lexer.m_symtab_context.curr_scope (),
                                        a, id, sc, body, lc, tc,
                                        m_curr_package_name, l, c);
          }
        else
          {
            delete a;
            delete id;
            delete sc;
            delete body;
            delete lc;
            delete tc;

            end_token_error (end_tok, token::switch_end);
          }
      }

    return retval;
  }

  // LC contains comments appearing before the properties keyword.
  // If this properties block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  // TC contains comments appearing between the list of properties
  // and the final end token for the properties block and may be used to
  // find the doc string for the final property in the list.

  tree_classdef_properties_block *
  base_parser::make_classdef_properties_block (token *tok_val,
                                               tree_classdef_attribute_list *a,
                                               tree_classdef_property_list *plist,
                                               token *end_tok,
                                               comment_list *lc,
                                               comment_list *tc)
  {
    tree_classdef_properties_block *retval = nullptr;

    if (end_token_ok (end_tok, token::properties_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (plist)
          {
            // If the element at the end of the list doesn't have a doc
            // string, see whether the first element of TC is an
            // end-of-line comment for us to use.

            if (tc)
              {
                tree_classdef_property *last_elt = plist->back ();

                if (! last_elt->have_doc_string ())
                  {
                    comment_elt first_comment_elt = tc->front ();

                    if (first_comment_elt.is_end_of_line ())
                      {
                        std::string eol_comment = first_comment_elt.text ();

                        last_elt->doc_string (eol_comment);
                      }
                  }
              }
          }
        else
          plist = new tree_classdef_property_list ();

        retval = new tree_classdef_properties_block (a, plist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete plist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::properties_end);
      }

    return retval;
  }

  // LC contains comments appearing before the methods keyword.
  // If this methods block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  tree_classdef_methods_block *
  base_parser::make_classdef_methods_block (token *tok_val,
                                            tree_classdef_attribute_list *a,
                                            tree_classdef_methods_list *mlist,
                                            token *end_tok, comment_list *lc,
                                            comment_list *tc)
  {
    tree_classdef_methods_block *retval = nullptr;

    if (end_token_ok (end_tok, token::methods_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! mlist)
          mlist = new tree_classdef_methods_list ();

        retval = new tree_classdef_methods_block (a, mlist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete mlist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::methods_end);
      }

    return retval;
  }

  // LC contains comments appearing before the events keyword.
  // If this events block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  // TC contains comments appearing between the list of events and
  // the final end token for the events block and may be used to find
  // the doc string for the final event in the list.

  tree_classdef_events_block *
  base_parser::make_classdef_events_block (token *tok_val,
                                           tree_classdef_attribute_list *a,
                                           tree_classdef_events_list *elist,
                                           token *end_tok,
                                           comment_list *lc,
                                           comment_list *tc)
  {
    tree_classdef_events_block *retval = nullptr;

    if (end_token_ok (end_tok, token::events_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! elist)
          elist = new tree_classdef_events_list ();

        retval = new tree_classdef_events_block (a, elist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete elist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::events_end);
      }

    return retval;
  }

  // LC contains comments appearing before the enumeration keyword.
  // If this enumeration block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  // TC contains comments appearing between the list of
  // enumerations and the final end token for the enumeration block and
  // may be used to find the doc string for the final enumeration in the
  // list.

  tree_classdef_enum_block *
  base_parser::make_classdef_enum_block (token *tok_val,
                                         tree_classdef_attribute_list *a,
                                         tree_classdef_enum_list *elist,
                                         token *end_tok,
                                         comment_list *lc,
                                         comment_list *tc)
  {
    tree_classdef_enum_block *retval = nullptr;

    if (end_token_ok (end_tok, token::enumeration_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! elist)
          elist = new tree_classdef_enum_list ();

        retval = new tree_classdef_enum_block (a, elist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete elist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::enumeration_end);
      }

    return retval;
  }

  octave_user_function*
  base_parser::start_classdef_external_method (tree_identifier *id,
                                               tree_parameter_list *pl)
  {
    octave_user_function* retval = nullptr;

    // External methods are only allowed within @-folders. In this case,
    // m_curr_class_name will be non-empty.

    if (! m_curr_class_name.empty ())
      {

        std::string mname = id->name ();

        // Methods that cannot be declared outside the classdef file:
        // - methods with '.' character (e.g. property accessors)
        // - class constructor
        // - 'delete'

        if (mname.find_first_of (".") == std::string::npos
            && mname != "delete"
            && mname != m_curr_class_name)
          {
            // Create a dummy function that is used until the real method
            // is loaded.

            retval = new octave_user_function (symbol_scope (), pl);

            retval->stash_function_name (mname);

            int l = id->line ();
            int c = id->column ();

            retval->stash_fcn_location (l, c);
          }
        else
          bison_error ("invalid external method declaration, an external "
                       "method cannot be the class constructor, 'delete' "
                       "or have a dot (.) character in its name");
      }
    else
      bison_error ("external methods are only allowed in @-folders");

    if (! retval)
      delete id;

    return retval;
  }

  tree_function_def *
  base_parser::finish_classdef_external_method (octave_user_function *fcn,
                                                tree_parameter_list *ret_list,
                                                comment_list *cl)
  {
    if (! ret_list)
      ret_list = new tree_parameter_list (tree_parameter_list::out);

    fcn->define_ret_list (ret_list);

    if (cl)
      fcn->stash_leading_comment (cl);

    int l = fcn->beginning_line ();
    int c = fcn->beginning_column ();

    return new tree_function_def (fcn, l, c);
  }

  void
  base_parser::finish_classdef_file (tree_classdef *cls,
                                     tree_statement_list *local_fcns)
  {
    if (m_lexer.m_reading_classdef_file)
      m_classdef_object = std::shared_ptr<tree_classdef> (cls);

    if (local_fcns)
      {
        symbol_table& symtab
          = __get_symbol_table__ ("base_parser::finish_classdef_file");

        for (tree_statement *elt : *local_fcns)
          {
            tree_command *cmd = elt->command ();

            tree_function_def *fcn_def
              = dynamic_cast<tree_function_def *> (cmd);

            octave_value ov_fcn = fcn_def->function ();
            octave_function *fcn = ov_fcn.function_value ();
            std::string nm = fcn->name ();
            std::string file = fcn->fcn_file_name ();

            symtab.install_local_function (nm, ov_fcn, file);
          }

        delete local_fcns;
      }
  }

  // Make an index expression.

  tree_index_expression *
  base_parser::make_index_expression (tree_expression *expr,
                                      tree_argument_list *args,
                                      char type)
  {
    tree_index_expression *retval = nullptr;

    if (args && args->has_magic_tilde ())
      {
        delete expr;
        delete args;

        bison_error ("invalid use of empty argument (~) in index expression");
      }
    else
      {
        int l = expr->line ();
        int c = expr->column ();

        if (! expr->is_postfix_indexed ())
          expr->set_postfix_index (type);

        if (expr->is_index_expression ())
          {
            tree_index_expression *tmp
              = dynamic_cast<tree_index_expression *> (expr);

            tmp->append (args, type);

            retval = tmp;
          }
        else
          retval = new tree_index_expression (expr, args, l, c, type);
      }

    return retval;
  }

  // Make an indirect reference expression.

  tree_index_expression *
  base_parser::make_indirect_ref (tree_expression *expr,
                                  const std::string& elt)
  {
    tree_index_expression *retval = nullptr;

    int l = expr->line ();
    int c = expr->column ();

    if (! expr->is_postfix_indexed ())
      expr->set_postfix_index ('.');

    if (expr->is_index_expression ())
      {
        tree_index_expression *tmp
          = dynamic_cast<tree_index_expression *> (expr);

        tmp->append (elt);

        retval = tmp;
      }
    else
      retval = new tree_index_expression (expr, elt, l, c);

    m_lexer.m_looking_at_indirect_ref = false;

    return retval;
  }

  // Make an indirect reference expression with dynamic field name.

  tree_index_expression *
  base_parser::make_indirect_ref (tree_expression *expr,
                                  tree_expression *elt)
  {
    tree_index_expression *retval = nullptr;

    int l = expr->line ();
    int c = expr->column ();

    if (! expr->is_postfix_indexed ())
      expr->set_postfix_index ('.');

    if (expr->is_index_expression ())
      {
        tree_index_expression *tmp
          = dynamic_cast<tree_index_expression *> (expr);

        tmp->append (elt);

        retval = tmp;
      }
    else
      retval = new tree_index_expression (expr, elt, l, c);

    m_lexer.m_looking_at_indirect_ref = false;

    return retval;
  }

  // Make a declaration command.

  tree_decl_command *
  base_parser::make_decl_command (int tok, token *tok_val,
                                  tree_decl_init_list *lst)
  {
    tree_decl_command *retval = nullptr;

    int l = tok_val->line ();
    int c = tok_val->column ();

    if (lst)
      m_lexer.mark_as_variables (lst->variable_names ());

    switch (tok)
      {
      case GLOBAL:
        {
          retval = new tree_decl_command ("global", lst, l, c);
          retval->mark_global ();
        }
        break;

      case PERSISTENT:
        if (m_curr_fcn_depth >= 0)
          {
            retval = new tree_decl_command ("persistent", lst, l, c);
            retval->mark_persistent ();
          }
        else
          {
            if (m_lexer.m_reading_script_file)
              warning ("ignoring persistent declaration near line %d of file '%s'",
                       l, m_lexer.m_fcn_file_full_name.c_str ());
            else
              warning ("ignoring persistent declaration near line %d", l);
          }
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  bool
  base_parser::validate_param_list (tree_parameter_list *lst,
                                    tree_parameter_list::in_or_out type)
  {
    std::set<std::string> dict;

    for (tree_decl_elt *elt : *lst)
      {
        tree_identifier *id = elt->ident ();

        if (id)
          {
            std::string name = id->name ();

            if (id->is_black_hole ())
              {
                if (type != tree_parameter_list::in)
                  {
                    bison_error ("invalid use of ~ in output list");
                    return false;
                  }
              }
            else if (dict.find (name) != dict.end ())
              {
                bison_error ("'" + name
                             + "' appears more than once in parameter list");
                return false;
              }
            else
              dict.insert (name);
          }
      }

    std::string va_type = (type == tree_parameter_list::in
                           ? "varargin" : "varargout");

    std::size_t len = lst->length ();

    if (len > 0)
      {
        tree_decl_elt *elt = lst->back ();

        tree_identifier *id = elt->ident ();

        if (id && id->name () == va_type)
          {
            if (len == 1)
              lst->mark_varargs_only ();
            else
              lst->mark_varargs ();

            tree_parameter_list::iterator p = lst->end ();
            --p;
            delete *p;
            lst->erase (p);
          }
      }

    return true;
  }

  bool
  base_parser::validate_array_list (tree_expression *e)
  {
    bool retval = true;

    tree_array_list *al = dynamic_cast<tree_array_list *> (e);

    for (tree_argument_list* row : *al)
      {
        if (row && row->has_magic_tilde ())
          {
            retval = false;

            if (e->is_matrix ())
              bison_error ("invalid use of tilde (~) in matrix expression");
            else
              bison_error ("invalid use of tilde (~) in cell expression");

            break;
          }
      }

    return retval;
  }

  tree_argument_list *
  base_parser::validate_matrix_for_assignment (tree_expression *e)
  {
    tree_argument_list *retval = nullptr;

    if (e->is_constant ())
      {
        tree_evaluator& tw
          = __get_evaluator__ ("validate_matrix_for_assignment");

        octave_value ov = e->evaluate (tw);

        delete e;

        if (ov.isempty ())
          bison_error ("invalid empty left hand side of assignment");
        else
          bison_error ("invalid constant left hand side of assignment");
      }
    else
      {
        bool is_simple_assign = true;

        tree_argument_list *tmp = nullptr;

        if (e->is_matrix ())
          {
            tree_matrix *mat = dynamic_cast<tree_matrix *> (e);

            if (mat && mat->size () == 1)
              {
                tmp = mat->front ();
                mat->pop_front ();
                delete e;
                is_simple_assign = false;
              }
          }
        else
          tmp = new tree_argument_list (e);

        if (tmp && tmp->is_valid_lvalue_list ())
          {
            m_lexer.mark_as_variables (tmp->variable_names ());
            retval = tmp;
          }
        else
          {
            delete tmp;

            bison_error ("invalid left hand side of assignment");
          }

        if (retval && is_simple_assign)
          retval->mark_as_simple_assign_lhs ();
      }

    return retval;
  }

  // Finish building an array_list.

  tree_expression *
  base_parser::finish_array_list (tree_array_list *array_list,
                                  token */*open_delim*/, token *close_delim)
  {
    tree_expression *retval = array_list;

    array_list->set_location (close_delim->line (), close_delim->column ());

    if (array_list->all_elements_are_constant ())
      {
        interpreter& interp = __get_interpreter__ ("finish_array_list");

        try
          {
            // If the evaluation generates a warning message, restore
            // the previous value of last_warning_message and skip the
            // conversion to a constant value.

            unwind_protect frame;

            error_system& es = interp.get_error_system ();

            frame.add_method (es, &error_system::set_last_warning_message,
                              es.last_warning_message (""));

            frame.add_method (es, &error_system::set_discard_warning_messages,
                              es.discard_warning_messages (true));

            tree_evaluator& tw = interp.get_evaluator ();

            octave_value tmp = array_list->evaluate (tw);

            std::string msg = es.last_warning_message ();

            if (msg.empty ())
              {
                tree_constant *tc_retval
                  = new tree_constant (tmp, close_delim->line (),
                                       close_delim->column ());

                std::ostringstream buf;

                tree_print_code tpc (buf);

                array_list->accept (tpc);

                tc_retval->stash_original_text (buf.str ());

                delete array_list;

                retval = tc_retval;
              }
          }
        catch (const execution_exception&)
          {
            interp.recover_from_exception ();
          }
      }

    return retval;
  }

  // Finish building a matrix list.

  tree_expression *
  base_parser::finish_matrix (tree_matrix *m, token *open_delim,
                              token *close_delim)
  {
    return (m
            ? finish_array_list (m, open_delim, close_delim)
            : new tree_constant (octave_null_matrix::instance,
                                 close_delim->line (), close_delim->column ()));
  }

  // Finish building a cell list.

  tree_expression *
  base_parser::finish_cell (tree_cell *c, token *open_delim,
                            token *close_delim)
  {
    return (c
            ? finish_array_list (c, open_delim, close_delim)
            : new tree_constant (octave_value (Cell ()),
                                 close_delim->line (), close_delim->column ()));
  }

  tree_statement_list *
  base_parser::set_stmt_print_flag (tree_statement_list *list,
                                    char sep, bool warn_missing_semi)
  {
    tree_statement *tmp = list->back ();

    switch (sep)
      {
      case ';':
        tmp->set_print_flag (false);
        break;

      case 0:
      case ',':
      case '\n':
        tmp->set_print_flag (true);
        if (warn_missing_semi)
          maybe_warn_missing_semi (list);
        break;

      default:
        warning ("unrecognized separator type!");
        break;
      }

    // Even if a statement is null, we add it to the list then remove it
    // here so that the print flag is applied to the correct statement.

    if (tmp->is_null_statement ())
      {
        list->pop_back ();
        delete tmp;
      }

    return list;
  }

  // Finish building a statement.
  template <typename T>
  tree_statement *
  base_parser::make_statement (T *arg)
  {
    comment_list *comment = m_lexer.get_comment ();

    return new tree_statement (arg, comment);
  }

  tree_statement_list *
  base_parser::make_statement_list (tree_statement *stmt)
  {
    return new tree_statement_list (stmt);
  }

  tree_statement_list *
  base_parser::append_statement_list (tree_statement_list *list,
                                      char sep, tree_statement *stmt,
                                      bool warn_missing_semi)
  {
    set_stmt_print_flag (list, sep, warn_missing_semi);

    list->append (stmt);

    return list;
  }

  void
  base_parser::disallow_command_syntax (void)
  {
    m_lexer.m_allow_command_syntax = false;
  }

  // FIXME: this function partially duplicates do_dbtype in debug.cc.
  static std::string
  get_file_line (const std::string& name, int line)
  {
    // NAME should be an absolute file name and the file should exist.

    std::ifstream fs = sys::ifstream (name.c_str (), std::ios::in);

    std::string text;

    if (fs)
      {
        int i = 1;

        do
          {
            if (! std::getline (fs, text))
              {
                text = "";
                break;
              }
          }
        while (i++ < line);
      }

    return text;
  }

  void
  base_parser::bison_error (const std::string& str)
  {
    bison_error (str, m_lexer.m_filepos);
  }

  void
  base_parser::bison_error (const std::string& str, const filepos& pos)
  {
    bison_error (str, pos.line (), pos.column ());
  }

  void
  base_parser::bison_error (const std::string& str, int err_line, int err_col)
  {
    std::ostringstream output_buf;

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_script_file
        || m_lexer.m_reading_classdef_file)
      output_buf << "parse error near line " << err_line
                 << " of file " << m_lexer.m_fcn_file_full_name;
    else
      output_buf << "parse error:";

    if (str != "parse error")
      output_buf << "\n\n  " << str;

    output_buf << "\n\n";

    std::string curr_line;

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_script_file
        || m_lexer.m_reading_classdef_file)
      curr_line = get_file_line (m_lexer.m_fcn_file_full_name, err_line);
    else
      curr_line = m_lexer.m_current_input_line;

    // Adjust the error column for display because it is 1-based in the
    // lexer for easier reporting.
    err_col--;

    if (! curr_line.empty ())
      {
        // FIXME: we could do better if we just cached lines from the
        // input file in a list.  See also functions for managing input
        // buffers in lex.ll.

        std::size_t len = curr_line.length ();

        if (curr_line[len-1] == '\n')
          curr_line.resize (len-1);

        // Print the line, maybe with a pointer near the error token.

        output_buf << ">>> " << curr_line << "\n";

        if (err_col == 0)
          err_col = len;

        for (int i = 0; i < err_col + 3; i++)
          output_buf << " ";

        output_buf << "^";
      }

    output_buf << "\n";

    m_parse_error_msg = output_buf.str ();
  }

  int
  parser::run (void)
  {
    int status = -1;

    yypstate *pstate = static_cast<yypstate *> (m_parser_state);

    try
      {
        status = octave_pull_parse (pstate, *this);
      }
    catch (const execution_exception&)
      {
        // FIXME: In previous versions, we emitted a parse error here
        // but that is not always correct because the error could have
        // happened inside a GUI callback functions executing in the
        // readline event_hook loop.  Maybe we need a separate exception
        // class for parse errors?

        throw;
      }
    catch (const exit_exception&)
      {
        throw;
      }
    catch (const interrupt_exception&)
      {
        throw;
      }
    catch (...)
      {
        std::string file = m_lexer.m_fcn_file_full_name;

        if (file.empty ())
          error ("unexpected exception while parsing input");
        else
          error ("unexpected exception while parsing %s", file.c_str ());
      }

    if (status != 0)
      parse_error ("%s", m_parse_error_msg.c_str ());

    return status;
  }

  // Parse input from INPUT.  Pass TRUE for EOF if the end of INPUT should
  // finish the parse.

  int
  push_parser::run (const std::string& input, bool eof)
  {
    int status = -1;

    dynamic_cast<push_lexer&> (m_lexer).append_input (input, eof);

    do
      {
        YYSTYPE lval;

        int token = octave_lex (&lval, m_lexer.m_scanner);

        if (token < 0)
          {
            // TOKEN == -2 means that the lexer recognized a comment
            // and we should be at the end of the buffer but not the
            // end of the file so we should return 0 to indicate
            // "complete input" instead of -1 to request more input.

            status = (token == -2 ? 0 : -1);

            if (! eof && m_lexer.at_end_of_buffer ())
              return status;

            break;
          }

        yypstate *pstate = static_cast<yypstate *> (m_parser_state);

        try
          {
            status = octave_push_parse (pstate, token, &lval, *this);
          }
        catch (execution_exception& e)
          {
            std::string file = m_lexer.m_fcn_file_full_name;

            if (file.empty ())
              error (e, "parse error");
            else
              error (e, "parse error in %s", file.c_str ());
          }
        catch (const exit_exception&)
          {
            throw;
          }
        catch (interrupt_exception &)
          {
            throw;
          }
        catch (...)
          {
            std::string file = m_lexer.m_fcn_file_full_name;

            if (file.empty ())
              error ("unexpected exception while parsing input");
            else
              error ("unexpected exception while parsing %s", file.c_str ());
          }
      }
    while (status == YYPUSH_MORE || ! m_lexer.at_end_of_buffer ());

    if (status != 0)
      parse_error ("%s", m_parse_error_msg.c_str ());

    return status;
  }

  int
  push_parser::run (void)
  {
    if (! m_reader)
      error ("push_parser::run requires valid input_reader");

    int exit_status = 0;

    input_system&  input_sys = m_interpreter.get_input_system ();

    std::string prompt
      = command_editor::decode_prompt_string (input_sys.PS1 ());

    do
      {
        // Reset status each time through the read loop so that
        // it won't be set to -1 and cause us to exit the outer
        // loop early if there is an exception while reading
        // input or parsing.

        exit_status = 0;

        bool eof = false;
        std::string input_line = m_reader->get_input (prompt, eof);

        if (eof)
          {
            exit_status = EOF;
            break;
          }

        exit_status = run (input_line, false);

        prompt = command_editor::decode_prompt_string (input_sys.PS2 ());
      }
    while (exit_status < 0);

    return exit_status;
  }

  octave_value
  parse_fcn_file (interpreter& interp, const std::string& full_file,
                  const std::string& file, const std::string& dir_name,
                  const std::string& dispatch_type,
                  const std::string& package_name, bool require_file,
                  bool force_script, bool autoload, bool relative_lookup)
  {
    octave_value retval;

    FILE *ffile = nullptr;

    if (! full_file.empty ())
      ffile = sys::fopen (full_file, "rb");

    if (! ffile)
      {
        if (require_file)
          error ("no such file, '%s'", full_file.c_str ());

        return octave_value ();
      }

    unwind_action act ([ffile] (void)
                       {
                         fclose (ffile);
                       });

    parser parser (ffile, interp);

    parser.m_curr_class_name = dispatch_type;
    parser.m_curr_package_name = package_name;
    parser.m_autoloading = autoload;
    parser.m_fcn_file_from_relative_lookup = relative_lookup;

    parser.m_lexer.m_force_script = force_script;
    parser.m_lexer.prep_for_file ();
    parser.m_lexer.m_parsing_class_method = ! dispatch_type.empty ();

    parser.m_lexer.m_fcn_file_name = file;
    parser.m_lexer.m_fcn_file_full_name = full_file;
    parser.m_lexer.m_dir_name = dir_name;
    parser.m_lexer.m_package_name = package_name;

    int err = parser.run ();

    if (err)
      error ("parse error while reading file %s", full_file.c_str ());

    octave_value ov_fcn = parser.m_primary_fcn;

    if (parser.m_lexer.m_reading_classdef_file
        && parser.classdef_object ())
      {
        // Convert parse tree for classdef object to
        // meta.class info (and stash it in the symbol
        // table?).  Return pointer to constructor?

        if (ov_fcn.is_defined ())
          panic_impossible ();

        bool is_at_folder = ! dispatch_type.empty ();

        std::shared_ptr<tree_classdef> cdef_obj
          = parser.classdef_object();

        return cdef_obj->make_meta_class (interp, is_at_folder);
      }
    else if (ov_fcn.is_defined ())
      {
        octave_function *fcn = ov_fcn.function_value ();

        fcn->maybe_relocate_end ();

        if (parser.m_parsing_subfunctions)
          {
            if (! parser.m_endfunction_found)
              parser.m_subfunction_names.reverse ();

            fcn->stash_subfunction_names (parser.m_subfunction_names);
          }

        return ov_fcn;
      }

    return octave_value ();
  }

  // Maybe print a warning if an assignment expression is used as the
  // test in a logical expression.

  void
  base_parser::maybe_warn_assign_as_truth_value (tree_expression *expr)
  {
    if (expr->is_assignment_expression ()
        && expr->paren_count () < 2)
      {
        if (m_lexer.m_fcn_file_full_name.empty ())
          warning_with_id
            ("Octave:assign-as-truth-value",
             "suggest parenthesis around assignment used as truth value");
        else
          warning_with_id
            ("Octave:assign-as-truth-value",
             "suggest parenthesis around assignment used as truth value near line %d, column %d in file '%s'",
             expr->line (), expr->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  // Maybe print a warning about switch labels that aren't constants.

  void
  base_parser::maybe_warn_variable_switch_label (tree_expression *expr)
  {
    if (! expr->is_constant ())
      {
        if (m_lexer.m_fcn_file_full_name.empty ())
          warning_with_id ("Octave:variable-switch-label",
                           "variable switch label");
        else
          warning_with_id
            ("Octave:variable-switch-label",
             "variable switch label near line %d, column %d in file '%s'",
             expr->line (), expr->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  void
  base_parser::maybe_warn_missing_semi (tree_statement_list *t)
  {
    if (m_curr_fcn_depth >= 0)
      {
        tree_statement *tmp = t->back ();

        if (tmp->is_expression ())
          warning_with_id
            ("Octave:missing-semicolon",
             "missing semicolon near line %d, column %d in file '%s'",
             tmp->line (), tmp->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  std::string
  get_help_from_file (const std::string& nm, bool& symbol_found,
                      std::string& full_file)
  {
    std::string retval;

    full_file = fcn_file_in_path (nm);

    std::string file = full_file;

    std::size_t file_len = file.length ();

    if ((file_len > 4 && file.substr (file_len-4) == ".oct")
        || (file_len > 4 && file.substr (file_len-4) == ".mex")
        || (file_len > 2 && file.substr (file_len-2) == ".m"))
      {
        file = sys::env::base_pathname (file);
        file = file.substr (0, file.find_last_of ('.'));

        std::size_t pos = file.find_last_of (sys::file_ops::dir_sep_str ());
        if (pos != std::string::npos)
          file = file.substr (pos+1);
      }

    if (! file.empty ())
      {
        interpreter& interp = __get_interpreter__ ("get_help_from_file");

        symbol_found = true;

        octave_value ov_fcn
          = parse_fcn_file (interp, full_file, file, "", "", "", true,
                            false, false, false);

        if (ov_fcn.is_defined ())
          {
            octave_function *fcn = ov_fcn.function_value ();

            if (fcn)
              retval = fcn->doc_string ();
          }
      }

    return retval;
  }

  std::string
  get_help_from_file (const std::string& nm, bool& symbol_found)
  {
    std::string file;
    return get_help_from_file (nm, symbol_found, file);
  }

  octave_value
  load_fcn_from_file (const std::string& file_name,
                      const std::string& dir_name,
                      const std::string& dispatch_type,
                      const std::string& package_name,
                      const std::string& fcn_name, bool autoload)
  {
    octave_value retval;

    unwind_protect frame;

    std::string nm = file_name;

    std::size_t nm_len = nm.length ();

    std::string file;

    bool relative_lookup = false;

    file = nm;

    if ((nm_len > 4 && nm.substr (nm_len-4) == ".oct")
        || (nm_len > 4 && nm.substr (nm_len-4) == ".mex")
        || (nm_len > 2 && nm.substr (nm_len-2) == ".m"))
      {
        nm = sys::env::base_pathname (file);
        nm = nm.substr (0, nm.find_last_of ('.'));

        std::size_t pos = nm.find_last_of (sys::file_ops::dir_sep_str ());
        if (pos != std::string::npos)
          nm = nm.substr (pos+1);
      }

    relative_lookup = ! sys::env::absolute_pathname (file);

    file = sys::env::make_absolute (file);

    int len = file.length ();

    interpreter& interp = __get_interpreter__ ("load_fcn_from_file");

    dynamic_loader& dyn_loader = interp.get_dynamic_loader ();

    if (len > 4 && file.substr (len-4, len-1) == ".oct")
      {
        if (autoload && ! fcn_name.empty ())
          nm = fcn_name;

        octave_function *tmpfcn
          = dyn_loader.load_oct (nm, file, relative_lookup);

        if (tmpfcn)
          {
            tmpfcn->stash_package_name (package_name);
            retval = octave_value (tmpfcn);
          }
      }
    else if (len > 4 && file.substr (len-4, len-1) == ".mex")
      {
        // Temporarily load m-file version of mex-file, if it exists,
        // to get the help-string to use.

        std::string doc_string;

        octave_value ov_fcn
          = parse_fcn_file (interp, file.substr (0, len - 2), nm, dir_name,
                            dispatch_type, package_name, false,
                            autoload, autoload, relative_lookup);

        if (ov_fcn.is_defined ())
          {
            octave_function *tmpfcn = ov_fcn.function_value ();

            if (tmpfcn)
              doc_string = tmpfcn->doc_string ();
          }

        octave_function *tmpfcn
          = dyn_loader.load_mex (nm, file, relative_lookup);

        if (tmpfcn)
          {
            tmpfcn->document (doc_string);
            tmpfcn->stash_package_name (package_name);

            retval = octave_value (tmpfcn);
          }
      }
    else if (len > 2)
      {
        retval = parse_fcn_file (interp, file, nm, dir_name,
                                 dispatch_type, package_name, true,
                                 autoload, autoload, relative_lookup);
      }

    return retval;
  }
}

DEFMETHOD (autoload, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {@var{autoload_map} =} autoload ()
@deftypefnx {} {} autoload (@var{function}, @var{file})
@deftypefnx {} {} autoload (@dots{}, "remove")
Define @var{function} to autoload from @var{file}.

The second argument, @var{file}, should be an absolute filename or a file
name in the same directory as the function or script from which the autoload
command was run.  @var{file} @emph{should not} depend on the Octave load
path.

Normally, calls to @code{autoload} appear in PKG_ADD script files that are
evaluated when a directory is added to Octave's load path.  To avoid having
to hardcode directory names in @var{file}, if @var{file} is in the same
directory as the PKG_ADD script then

@example
autoload ("foo", "bar.oct");
@end example

@noindent
will load the function @code{foo} from the file @code{bar.oct}.  The above
usage when @code{bar.oct} is not in the same directory, or usages such as

@example
autoload ("foo", file_in_loadpath ("bar.oct"))
@end example

@noindent
are strongly discouraged, as their behavior may be unpredictable.

With no arguments, return a structure containing the current autoload map.

If a third argument @qcode{"remove"} is given, the function is cleared and
not loaded anymore during the current Octave session.

@seealso{PKG_ADD}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin == 1 || nargin > 3)
    print_usage ();

  octave::tree_evaluator& tw = interp.get_evaluator ();

  if (nargin == 0)
    return octave_value (tw.get_autoload_map ());
  else
    {
      string_vector argv = args.make_argv ("autoload");

      if (nargin == 2)
        tw.add_autoload (argv[1], argv[2]);
      else if (nargin == 3)
        {
          if (argv[3] != "remove")
            error_with_id ("Octave:invalid-input-arg",
                           "autoload: third argument can only be 'remove'");

          tw.remove_autoload (argv[1], argv[2]);
        }
    }

  return octave_value_list ();
}

DEFMETHOD (mfilename, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} mfilename ()
@deftypefnx {} {} mfilename ("fullpath")
@deftypefnx {} {} mfilename ("fullpathext")
Return the name of the currently executing file.

The base name of the currently executing script or function is returned without
any extension.  If called from outside an m-file, such as the command line,
return the empty string.

Given the argument @qcode{"fullpath"}, include the directory part of the
filename, but not the extension.

Given the argument @qcode{"fullpathext"}, include the directory part of
the filename and the extension.
@seealso{inputname, dbstack}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin > 1)
    print_usage ();

  std::string opt;

  if (nargin == 1)
    opt = args(0).xstring_value ("mfilename: option argument must be a string");

  return octave_value (interp.mfilename (opt));
}

namespace octave
{
  // Execute the contents of a script file.  For compatibility with
  // Matlab, also execute a function file by calling the function it
  // defines with no arguments and nargout = 0.

  void
  source_file (const std::string& file_name, const std::string& context,
               bool verbose, bool require_file)
  {
    interpreter& interp = __get_interpreter__ ("source_file");

    interp.source_file (file_name, context, verbose, require_file);
  }
}

DEFMETHOD (source, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} source (@var{file})
@deftypefnx {} {} source (@var{file}, @var{context})
Parse and execute the contents of @var{file}.

Without specifying @var{context}, this is equivalent to executing commands
from a script file, but without requiring the file to be named
@file{@var{file}.m} or to be on the execution path.

Instead of the current context, the script may be executed in either the
context of the function that called the present function
(@qcode{"caller"}), or the top-level context (@qcode{"base"}).
@seealso{run}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  std::string file_name
    = args(0).xstring_value ("source: FILE must be a string");

  std::string context;
  if (nargin == 2)
    context = args(1).xstring_value ("source: CONTEXT must be a string");

  interp.source_file (file_name, context);

  return octave_value_list ();
}

namespace octave
{
  //! Evaluate an Octave function (built-in or interpreted) and return
  //! the list of result values.
  //!
  //! @param name The name of the function to call.
  //! @param args The arguments to the function.
  //! @param nargout The number of output arguments expected.
  //! @return A list of output values.  The length of the list is not
  //!         necessarily the same as @c nargout.

  octave_value_list
  feval (const char *name, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (name, args, nargout);
  }

  octave_value_list
  feval (const std::string& name, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (name, args, nargout);
  }

  octave_value_list
  feval (octave_function *fcn, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (fcn, args, nargout);
  }

  octave_value_list
  feval (const octave_value& val, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (val, args, nargout);
  }

  octave_value_list
  feval (const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (args, nargout);
  }
}

DEFMETHOD (feval, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn {} {} feval (@var{name}, @dots{})
Evaluate the function named @var{name}.

Any arguments after the first are passed as inputs to the named function.
For example,

@example
@group
feval ("acos", -1)
     @result{} 3.1416
@end group
@end example

@noindent
calls the function @code{acos} with the argument @samp{-1}.

The function @code{feval} can also be used with function handles of any sort
(@pxref{Function Handles}).  Historically, @code{feval} was the only way to
call user-supplied functions in strings, but function handles are now
preferred due to the cleaner syntax they offer.  For example,

@example
@group
@var{f} = @@exp;
feval (@var{f}, 1)
    @result{} 2.7183
@var{f} (1)
    @result{} 2.7183
@end group
@end example

@noindent
are equivalent ways to call the function referred to by @var{f}.  If it
cannot be predicted beforehand whether @var{f} is a function handle,
function name in a string, or inline function then @code{feval} can be used
instead.
@end deftypefn */)
{
  if (args.length () == 0)
    print_usage ();

  return interp.feval (args, nargout);
}

DEFMETHOD (builtin, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn {} {[@dots{}] =} builtin (@var{f}, @dots{})
Call the base function @var{f} even if @var{f} is overloaded to another
function for the given type signature.

This is normally useful when doing object-oriented programming and there is
a requirement to call one of Octave's base functions rather than the
overloaded one of a new class.

A trivial example which redefines the @code{sin} function to be the
@code{cos} function shows how @code{builtin} works.

@example
@group
sin (0)
  @result{} 0
function y = sin (x), y = cos (x); endfunction
sin (0)
  @result{} 1
builtin ("sin", 0)
  @result{} 0
@end group
@end example
@end deftypefn */)
{
  octave_value_list retval;

  if (args.length () == 0)
    print_usage ();

  const std::string name (args(0).xstring_value ("builtin: function name (F) must be a string"));

  octave::symbol_table& symtab = interp.get_symbol_table ();

  octave_value fcn = symtab.builtin_find (name);

  if (fcn.is_defined ())
    retval = interp.feval (fcn.function_value (), args.splice (0, 1), nargout);
  else
    error ("builtin: lookup for symbol '%s' failed", name.c_str ());

  return retval;
}

namespace octave
{
  octave_value_list
  eval_string (const std::string& eval_str, bool silent,
               int& parse_status, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("eval_string");

    return interp.eval_string (eval_str, silent, parse_status, nargout);
  }

  octave_value
  eval_string (const std::string& eval_str, bool silent, int& parse_status)
  {
    interpreter& interp = __get_interpreter__ ("eval_string");

    return interp.eval_string (eval_str, silent, parse_status);
  }

  void
  cleanup_statement_list (tree_statement_list **lst)
  {
    if (*lst)
      {
        delete *lst;
        *lst = nullptr;
      }
  }
}

DEFMETHOD (eval, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} eval (@var{try})
@deftypefnx {} {} eval (@var{try}, @var{catch})
Parse the string @var{try} and evaluate it as if it were an Octave
program.

If execution fails, evaluate the optional string @var{catch}.

The string @var{try} is evaluated in the current context, so any results
remain available after @code{eval} returns.

The following example creates the variable @var{A} with the approximate
value of 3.1416 in the current workspace.

@example
eval ("A = acos(-1);");
@end example

If an error occurs during the evaluation of @var{try} then the @var{catch}
string is evaluated, as the following example shows:

@example
@group
eval ('error ("This is a bad example");',
      'printf ("This error occurred:\n%s\n", lasterr ());');
     @print{} This error occurred:
        This is a bad example
@end group
@end example

Programming Note: if you are only using @code{eval} as an error-capturing
mechanism, rather than for the execution of arbitrary code strings,
Consider using try/catch blocks or unwind_protect/unwind_protect_cleanup
blocks instead.  These techniques have higher performance and don't
introduce the security considerations that the evaluation of arbitrary code
does.
@seealso{evalin, evalc, assignin, feval}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  if (! args(0).is_string () || args(0).rows () > 1 || args(0).ndims () != 2)
    error ("eval: TRY must be a string");

  std::string try_code = args(0).string_value ();

  if (nargin == 1)
    return interp.eval (try_code, nargout);
  else
    {
      if (! args(1).is_string () || args(1).rows () > 1
          || args(1).ndims () != 2)
        error ("eval: CATCH must be a string");

      std::string catch_code = args(1).string_value ();

      return interp.eval (try_code, catch_code, nargout);
    }
}

/*

%!shared x
%! x = 1;

%!assert (eval ("x"), 1)
%!assert (eval ("x;"))
%!assert (eval ("x;"), 1)

%!test
%! y = eval ("x");
%! assert (y, 1);

%!test
%! y = eval ("x;");
%! assert (y, 1);

%!test
%! eval ("x = 1;");
%! assert (x,1);

%!test
%! eval ("flipud = 2;");
%! assert (flipud, 2);

%!function y = __f ()
%!  eval ("flipud = 2;");
%!  y = flipud;
%!endfunction
%!assert (__f(), 2)

%!test <*35645>
%! [a,] = gcd (1,2);
%! [a,b,] = gcd (1, 2);

## Can't assign to a keyword
%!error eval ("switch = 13;")

%!shared str
%! str = "disp ('hello');";
%! str(:,:,2) = str(:,:,1);

%!error <TRY must be a string> eval (1)
%!error <TRY must be a string> eval (['a';'b'])
%!error <TRY must be a string> eval (str)

%!error <CATCH must be a string> eval (str(:,:,1), 1)
%!error <CATCH must be a string> eval (str(:,:,1), ['a';'b'])
%!error <CATCH must be a string> eval (str(:,:,1), str)

*/

DEFMETHOD (assignin, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn {} {} assignin (@var{context}, @var{varname}, @var{value})
Assign @var{value} to @var{varname} in context @var{context}, which
may be either @qcode{"base"} or @qcode{"caller"}.
@seealso{evalin}
@end deftypefn */)
{
  if (args.length () != 3)
    print_usage ();

  std::string context
    = args(0).xstring_value ("assignin: CONTEXT must be a string");

  std::string varname
    = args(1).xstring_value ("assignin: VARNAME must be a string");

  interp.assignin (context, varname, args(2));

  return octave_value_list ();
}

/*

%!error assignin ("base", "switch", "13")

*/

DEFMETHOD (evalin, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} evalin (@var{context}, @var{try})
@deftypefnx {} {} evalin (@var{context}, @var{try}, @var{catch})
Like @code{eval}, except that the expressions are evaluated in the context
@var{context}, which may be either @qcode{"caller"} or @qcode{"base"}.
@seealso{eval, assignin}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 2 || nargin > 3)
    print_usage ();

  std::string context
    = args(0).xstring_value ("evalin: CONTEXT must be a string");

  std::string try_code
    = args(1).xstring_value ("evalin: TRY must be a string");

  if (nargin == 3)
    {
      std::string catch_code
        = args(2).xstring_value ("evalin: CATCH must be a string");

      return interp.evalin (context, try_code, catch_code, nargout);
    }

  return interp.evalin (context, try_code, nargout);
}

DEFMETHOD (evalc, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {@var{s} =} evalc (@var{try})
@deftypefnx {} {@var{s} =} evalc (@var{try}, @var{catch})
Parse and evaluate the string @var{try} as if it were an Octave program,
while capturing the output into the return variable @var{s}.

If execution fails, evaluate the optional string @var{catch}.

This function behaves like @code{eval}, but any output or warning messages
which would normally be written to the console are captured and returned in
the string @var{s}.

The @code{diary} is disabled during the execution of this function.  When
@code{system} is used, any output produced by external programs is
@emph{not} captured, unless their output is captured by the @code{system}
function itself.

@example
@group
s = evalc ("t = 42"), t
  @result{} s = t =  42

  @result{} t =  42
@end group
@end example
@seealso{eval, diary}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin == 0 || nargin > 2)
    print_usage ();

  // Flush pending output and redirect stdout/stderr to capturing
  // buffer.

  octave_stdout.flush ();
  std::cerr.flush ();

  std::stringbuf buffer;

  std::streambuf *old_out_buf = octave_stdout.rdbuf (&buffer);
  std::streambuf *old_err_buf = std::cerr.rdbuf (&buffer);

  // Restore previous output buffers no matter how control exits this
  // function.  There's no need to flush here.  That has already
  // happened for the normal execution path.  If an error happens during
  // the eval, then the message is stored in the exception object and we
  // will display it later, after the buffers have been restored.

  octave::unwind_action act ([old_out_buf, old_err_buf] (void)
                             {
                               octave_stdout.rdbuf (old_out_buf);
                               std::cerr.rdbuf (old_err_buf);
                             });

  // Call standard eval function.

  int eval_nargout = std::max (0, nargout - 1);

  octave_value_list retval = Feval (interp, args, eval_nargout);

  // Make sure we capture all pending output.

  octave_stdout.flush ();
  std::cerr.flush ();

  retval.prepend (buffer.str ());

  return retval;
}

/*

%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   str = evalc ("1");
%!   assert (str, "ans = 1\n");
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!assert (evalc ("1;"), "")

%!test
%! [s, y] = evalc ("1");
%! assert (s, "");
%! assert (y, 1);

%!test
%! [s, y] = evalc ("1;");
%! assert (s, "");
%! assert (y, 1);

%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   str = evalc ("y = 2");
%!   assert (str, "y = 2\n");
%!   assert (y, 2);
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!test
%! assert (evalc ("y = 3;"), "");
%! assert (y, 3);

%!test
%! [s, a, b] = evalc ("deal (1, 2)");
%! assert (s, "");
%! assert (a, 1);
%! assert (b, 2);

%!function [a, b] = __f_evalc ()
%!  printf ("foo");
%!  fprintf (stdout, "bar ");
%!  disp (pi);
%!  a = 1;
%!  b = 2;
%!endfunction
%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   [s, a, b] = evalc ("__f_evalc ()");
%!   assert (s, "foobar 3.1416\n");
%!   assert (a, 1);
%!   assert (b, 2);
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!error <foo> (evalc ("error ('foo')"))
%!error <bar> (evalc ("error ('foo')", "error ('bar')"))

%!test
%! warning ("off", "quiet", "local");
%! str = evalc ("warning ('foo')");
%! assert (str(1:13), "warning: foo\n");

%!test
%! warning ("off", "quiet", "local");
%! str = evalc ("error ('foo')", "warning ('bar')");
%! assert (str(1:13), "warning: bar\n");

%!error evalc ("switch = 13;")

*/

DEFUN (__parser_debug_flag__, args, nargout,
       doc: /* -*- texinfo -*-
@deftypefn  {} {@var{val} =} __parser_debug_flag__ ()
@deftypefnx {} {@var{old_val} =} __parser_debug_flag__ (@var{new_val})
Query or set the internal flag that determines whether Octave's parser
prints debug information as it processes an expression.
@seealso{__lexer_debug_flag__}
@end deftypefn */)
{
  octave_value retval;

  bool debug_flag = octave_debug;

  retval = set_internal_variable (debug_flag, args, nargout,
                                  "__parser_debug_flag__");

  octave_debug = debug_flag;

  return retval;
}

DEFMETHOD (__parse_file__, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn {} {} __parse_file__ (@var{file}, @var{verbose})
Undocumented internal function.
@end deftypefn */)
{
  octave_value retval;

  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  std::string file = args(0).xstring_value ("__parse_file__: expecting filename as argument");

  std::string full_file
      = octave::sys::file_ops::tilde_expand (file);

  full_file = octave::sys::env::make_absolute (full_file);

  std::string dir_name;

  std::size_t file_len = file.length ();

  if ((file_len > 4 && file.substr (file_len-4) == ".oct")
      || (file_len > 4 && file.substr (file_len-4) == ".mex")
      || (file_len > 2 && file.substr (file_len-2) == ".m"))
    {
      file = octave::sys::env::base_pathname (file);
      file = file.substr (0, file.find_last_of ('.'));

      std::size_t pos = file.find_last_of (octave::sys::file_ops::dir_sep_str ());
      if (pos != std::string::npos)
        {
          dir_name = file.substr (0, pos);
          file = file.substr (pos+1);
        }
    }

  if (nargin == 2)
    octave_stdout << "parsing " << full_file << std::endl;

  octave_value ov_fcn
    = parse_fcn_file (interp, full_file, file, dir_name, "", "", true,
                      false, false, false);

  return retval;
}
